/* ------------------------------------------------------------------------ */
/* Ot\                                                           */
/*                                             designed by hamayan          */
/*                                             Copyright(C) hamayan         */
/*                                             since 2004 -                 */
/*                                             webmaster@hamayan.zive.net   */
/* ------------------------------------------------------------------------ */
#ifdef		__300HA__
#include	<no_float.h>
#endif		/*__300HA__*/

/*#include	<stdio.h>*/
#ifndef _STDIO_H
#define		EOF		(-1)
#endif	/*_STDIO_H*/
#include	<string.h>

#include	"itron.h"
#include	"kernel.h"
#include	"kernel_id.h"
#include	"ip.h"
#include	"nava_cfg.h"
#include	"tcp.h"
#include	"cgi.h"

typedef struct
{
	unsigned char	left:4;
	unsigned char	right:4;
} FOUR_BIT_COLOR;

#define		__4BIT_COLOR__
#define		WIDTH		230		/**/
#define		AREA_WIDTH	((((WIDTH - 1) / 8) + 1) * 8)
#define		HEIGHT		110		/**/
#define		ZERO_POINT_X	(40)				/*X̊Jnʒu*/
#define		ZERO_POINT_Y	(HEIGHT - 10 -1)	/*X̊Jnʒu*/
#define		X_STEP		(10)	/*X̃Ԋu*/
#define		Y_STEP		(10)	/*ỸԊu*/
#define		COLOR_COUNT	4		/*4bit*/
#define		COLOR_VARIATION	16	/*16FJ[*/
#include	"dib.h"

static const RGBQUAD ColorPallet[] =
{
	WHITE,
	BLACK,
	GREY,
	LIGHTGREY,
	RED,
	GREEN,
	BLUE,
	YELLOW,
	SAXEBLUE,
	MAGENTA,
	DARKRED,
	DARKYELLOW,
	DARKGREEN,
	DARKSAXEBLUE,
	DARKBLUE,
	DARKMAGENTA,
};

/*FONT ROM*/
typedef struct
{
	unsigned short start;		/*R[h̊Jnԍ*/
	unsigned short end;			/*R[h̏Iԍ*/
	const char *font;		/*tHgf[^̈̐擪AhX*/
} AREA_RECORD;

typedef struct
{
	long	start_x;	/*Jn_XW*/
	long	start_y;	/*Jn_YW*/
	long	end_x;		/*I_XW*/
	long	end_y;		/*I_YW*/
	int 	plt;		/*pbgԍ*/
} DrawForm;

typedef struct	/*ݎ̑*/
{
	long	pos_x;		/*JnXW*/
	long	pos_y;		/*JnYW*/
	int 	foreground;	/*tHAOhpbgԍ*/
	int 	background;	/*obNOhpbgԍ*/
} DrawCharactorsAttribute;

static BITMAPFILEFORMAT bmp;
static int GetPalletNumber( unsigned long color );
static void clear_set( void *area, long width, long height, unsigned long color );
static int DrawLine( void *area, const DrawForm *df );
static void DrawDot( void *area, long x, long y, int plt );
static int DrawKanji_c( void *area, const DrawCharactorsAttribute *dca, unsigned short moji );

/* ------------------------------------------------------------------------ */
/*  GfBA̕ϊsB                                              */
/* ------------------------------------------------------------------------ */
static void B2LforWord( unsigned char *dest, unsigned short source )
{
	dest[0] = *(((unsigned char *)&source) + 1);
	dest[1] = *(((unsigned char *)&source) + 0);
}

static void B2LforDWord( unsigned char *dest, unsigned long source )
{
	dest[0] = *(((unsigned char *)&source) + 3);
	dest[1] = *(((unsigned char *)&source) + 2);
	dest[2] = *(((unsigned char *)&source) + 1);
	dest[3] = *(((unsigned char *)&source) + 0);
}

/* ------------------------------------------------------------------------ */
/*  vOC													    */
/* ------------------------------------------------------------------------ */
static int cgi_access_graph( TcpAddressAndPortInformation *info, int argc, char *argv[] )
{
	int i,x,y;
	DrawForm df;
	DrawCharactorsAttribute dca;
	static const short dummy = 1234;	/*Ep*/
	static const char x_jiku[] = "PQRSTUVWXOPQRSTUVWXO0";	/*Ō0͋Ep*/
	static const char y_jiku[] = "|SOO|ROO|QOO|POO@@@O{POO{QOO{ROO{SOO0";	/*Ō0͋Ep*/

	/*t@Cwb_[̐B*/
	bmp.bf.bfType[0] = 'B';
	bmp.bf.bfType[1] = 'M';

	B2LforDWord( (unsigned char *)bmp.bf.bfSize, sizeof(bmp) );	/*t@CTCY*/
	B2LforWord( (unsigned char *)bmp.bf.bfReserved1, 0 );	/*ɂO*/
	B2LforWord( (unsigned char *)bmp.bf.bfReserved2, 0 );	/*ɂO*/
	B2LforDWord( (unsigned char *)bmp.bf.bfOffBits, sizeof(bmp.bf) + sizeof(bmp.bi) + sizeof(bmp.plt) );	/*摜f[^̊JnAhX*/

	/*wb_[̐B*/
	B2LforDWord( (unsigned char *)bmp.bi.biSize, 0x00000028 );	/*wb_[*/
	B2LforDWord( (unsigned char *)bmp.bi.biWidth, WIDTH );	/**/
	B2LforDWord( (unsigned char *)bmp.bi.biHeight, HEIGHT );	/**/
	B2LforWord( (unsigned char *)bmp.bi.Planes, 1 );	/*J[v[*/
	B2LforWord( (unsigned char *)bmp.bi.biBitCount, COLOR_COUNT );	/*sNZbit*/
	B2LforDWord( (unsigned char *)bmp.bi.biCompression, 0 );	/*k`*/
	B2LforDWord( (unsigned char *)bmp.bi.biSizeImage, sizeof(bmp.image) );	/*k̉摜f[^TCY*/
	B2LforDWord( (unsigned char *)bmp.bi.biXPelsPerMeter, 0 );	/*𑜓x*/
	B2LforDWord( (unsigned char *)bmp.bi.biYPelsPerMeter, 0 );	/*𑜓x*/
	B2LforDWord( (unsigned char *)bmp.bi.biClrUsed, COLOR_VARIATION );	/*gpF*/
	B2LforDWord( (unsigned char *)bmp.bi.biClrImportant, COLOR_VARIATION );	/*dvȐF*/

	/*J[pbg̃Rs[*/
	memcpy( bmp.plt, ColorPallet, sizeof(bmp.plt) );

	clear_set( bmp.image, WIDTH, HEIGHT, DARKSAXEBLUE );

	/*w*/
	df.start_x = ZERO_POINT_X - 5;
	df.start_y = ZERO_POINT_Y;
	df.end_x = WIDTH - 1;
	df.end_y = ZERO_POINT_Y;
	df.plt = GetPalletNumber( GREY );	/*pbgԍ*/
	DrawLine( bmp.image, &df );

	/*x*/
	df.start_x = ZERO_POINT_X;
	df.start_y = ZERO_POINT_Y + 5;
	df.end_x = ZERO_POINT_X;
	df.end_y = 0;
	df.plt = GetPalletNumber( GREY );	/*pbgԍ*/
	DrawLine( bmp.image, &df );

	/*w̌rƃ*/
	for( x = ZERO_POINT_X + X_STEP; x < WIDTH; x += X_STEP )
	{
		df.start_x = x;
		df.start_y = ZERO_POINT_Y;
		df.end_x = x;
		df.end_y = 0;
		df.plt = GetPalletNumber( SAXEBLUE );	/*pbgԍ*/
		DrawLine( bmp.image, &df );

		df.end_y = ZERO_POINT_Y - 5;
		df.plt = GetPalletNumber( YELLOW );	/*pbgԍ*/
		DrawLine( bmp.image, &df );
	}

	/*x̌rƃ*/
	for( y = ZERO_POINT_Y - Y_STEP; y >= 0; y -= Y_STEP )
	{
		df.start_x = ZERO_POINT_X;
		df.start_y = y;
		df.end_x = WIDTH - 1;
		df.end_y = y;
		df.plt = GetPalletNumber( SAXEBLUE );	/*pbgԍ*/
		DrawLine( bmp.image, &df );

		df.end_x = ZERO_POINT_X + 5;
		df.plt = GetPalletNumber( MAGENTA );	/*pbgԍ*/
		DrawLine( bmp.image, &df );
	}

	/*Xɐl*/
	for( x = 0; x < 19; x++ )
	{
		dca.pos_x = (x * X_STEP) + ZERO_POINT_X - 3;
		dca.pos_y = ZERO_POINT_Y + 2;
		dca.foreground = GetPalletNumber( WHITE );	/*pbgԍ*/;
		DrawKanji_c( bmp.image, &dca, *((unsigned short *)&x_jiku[ x * 2 ]) );
	}

	/*yɐl*/
	for( y = 0; y < 9; y++ )
	{
		for( i = 0; i < 4; i++ )
		{
			dca.pos_x = ZERO_POINT_X - 38 + (i * 8);
			dca.pos_y = ZERO_POINT_Y - (y * Y_STEP) - 10 - 8 + 6;
			dca.foreground = GetPalletNumber( WHITE );	/*pbgԍ*/;
			DrawKanji_c( bmp.image, &dca, *((unsigned short *)&y_jiku[ (y * 8) + (i * 2) ]) );
		}
	}

	/*\PbgőM*/
	if( TCPwrite( info, (void *)&bmp, sizeof(bmp) ) < 0 )
	{
		TCPForceCloseState( info );
		return EOF;
	}
	return 0;
}

/********************************************************************************************/
/*	FR[hpbgԍ擾B													*/
/*	color͐FR[hB																	*/
/*	Ypbg͂̔ԍԂAȂ0ԂԂB		*/
/********************************************************************************************/
static int GetPalletNumber( unsigned long color )
{
	int i;

	/*pbge[uvpbg*/
	for( i = 0; i < COLOR_VARIATION; i++ )
		if( ColorPallet[i] == color ) return i;

	return 0;
}

/********************************************************************************************/
/*	w肵̈Aw肵cŁAw肵FœhׂB									*/
/********************************************************************************************/
static void clear_set( void *area, long width, long height, unsigned long color )
{
	int plt;

	/*width̕␳*/
	width = ((((width - 1) / 8) + 1) * (8 / 2));

	/*pbgԍ擾*/
	plt = GetPalletNumber( color );
	memset( area, (plt << 4) | plt, width * height );
}

/********************************************************************************************/
/*	x,yWۂVRAMAhXɕϊɂ́AY~̈őTCYXZlAIt	*/
/*	ZbgƂȂBplt̓pbgԍB													*/
/*	YW͋t]KvB																*/
/*	߂l͖B																			*/
/********************************************************************************************/
static void DrawDot( void *area, long x, long y, int plt )
{
	y = ((HEIGHT - y - 1) * (AREA_WIDTH / 2)) + (x / 2);

	if( x & 0x01 )	/*͉E*/
		((FOUR_BIT_COLOR *)((char *)area + y))->right = plt;
	else	/*͍*/
		((FOUR_BIT_COLOR *)((char *)area + y))->left = plt;
}

/********************************************************************************************/
/*	̕`sB																		*/
/*	͊Jn_ƏI_Aɕ\(J[pbgԍ)nƕ`悳B			*/
/*	߂ĺA͈͂zꍇEOFԂB펞0ԂB							*/
/********************************************************************************************/
static int DrawLine( void *area, const DrawForm *df )
{
	short	E,x,y;
	short	dx,dy,sx,sy;
	int		i;

	if( df->start_x >= WIDTH || df->end_x >= WIDTH || df->start_y >= HEIGHT || df->end_y >= HEIGHT ) return EOF;

	sx = ( df->end_x > df->start_x ) ? 1 : -1;
	dx = ( df->end_x > df->start_x ) ? df->end_x - df->start_x : df->start_x - df->end_x;
	sy = ( df->end_y > df->start_y ) ? 1 : -1;
	dy = ( df->end_y > df->start_y ) ? df->end_y - df->start_y : df->start_y - df->end_y;

	x = df->start_x;
	y = df->start_y;

	/* ̏ꍇ */
	if( dx && dy == 0 )
	{
		x = (sx > 0) ? df->start_x : df->end_x;
		for( i = 0; i < dx; i++ )
			DrawDot( area, x + i, df->start_y, df->plt );
	}
	/* ̏ꍇ */
	else if( dy && dx == 0 )
	{
		y = (sy > 0) ? df->start_y : df->end_y;
		for( i = 0; i < dy; i++ )
			DrawDot( area, df->start_x, y + i, df->plt );
	}
	/* X1ȉ̏ꍇ */
	else if( dx >= dy )
	{
		E = -dx;
		for( i = 0; i <= dx; i++ )
		{
			DrawDot( area, x, y, df->plt );
			x += sx;
			E += 2 * dy;
			if( E >= 0 )
			{
				y += sy;
				E -= 2 * dx;
			}
		}
	}
	/* X1傫ꍇ */
	else
	{
		E = -dy;
		for( i = 0; i <= dy; i++ )
		{
			DrawDot( area, x, y, df->plt );
			y += sy;
			E += 2 * dx;
			if( E >= 0 )
			{
				x += sx;
				E -= 2 * dy;
			}
		}
	}
	return 0;
}

/********************************************************************************************/
/*	R[hɊY镶`悷B													*/
/*	df͕`JnʒuAmoji͖ܘ_R[h												*/
/*	̈Ow肷铙Ap[^[G[̎EOFԂB펞0ԂB				*/
/********************************************************************************************/

extern	const unsigned short KanjiXSize;
extern	const unsigned short KanjiYSize;
extern	const unsigned short KanjiTnum;
extern	const AREA_RECORD KanjiAreaRecord[];


static int DrawKanji_c( void *area, const DrawCharactorsAttribute *dca, unsigned short moji )
{
	int		block,x,col,row,bit_pos,bit_count;
	const char	*data;
	DrawForm	df2;

	/*8bit0x7FƂ͂ȂȂB*/
	if( (moji & 0xff) == 0x7f ) return EOF;
	/*FONT ROM񂩂Y̊Jnʒu肷B*/
	for( block = 0; block < KanjiTnum; block++ )
	{
		/*R[hubŇ*/
		if( moji >= KanjiAreaRecord[ block ].start && moji <= KanjiAreaRecord[ block ].end ) break;
	}

	if( block == KanjiTnum ) return EOF;	/*YȂׂEOFԂďIB*/

	/*\̂̃Rs[*/
	df2.start_x = dca->pos_x;		/*XW*/
	df2.start_y = dca->pos_y;		/*YW*/
	/*wiFL̏ꍇA{Xy[X̋`hԂsB*/
	df2.plt = dca->foreground;	/*OʐF*/

	/*擾̃rbg}bvhbgɓWJB*/
	x = ((KanjiXSize - 1) / 8) + 1;
	data = KanjiAreaRecord[ block ].font + (moji - KanjiAreaRecord[ block ].start) * x * KanjiYSize;

	/*sP*/
	for( col = 0; col < KanjiYSize; col++ )
	{
		/*P*/
		for( row = 0, bit_count = 0; row < x; row++ )
		{
			/*rbgTCYŃ[v*/
			for( bit_pos = 7; bit_pos >= 0; bit_pos-- )
			{
				if( (*data >> bit_pos) & 0x01 ) DrawDot( area, df2.start_x, df2.start_y, df2.plt );

				/*̃rbgɐi݁A̐ɒBĂȂ𒲂ׂB*/
				df2.start_x++;
				if( ++bit_count >= KanjiXSize )
				{
					data++;
					goto _DrawKanji_c_01;	/*rbgp^[̗̏I[*/
				}
			}
			data++;
		}
_DrawKanji_c_01:
		df2.start_x = dca->pos_x;	/*̐擪ɖ߂B*/
		df2.start_y++;				/*̍sɈړ*/
	}

	return 0;
}

/********************************************************************/
/*	Reco^p̃vpeB									*/
/*	cgi_imgQƂB											*/
/********************************************************************/
const FILE_PROPERTIES TimeCompensation_bmp =
{
	"TimeCompensation.bmp",
	"2004/ 7/ 5 20:44:00",
	cgi_access_graph,
	(void *)0,
	"designed by hamayan.",
	(void *)0,
	0,
};

/* ------------------------------------------------------------------------ */
/*                                             designed by hamayan          */
/*                                             Copyright(C) hamayan         */
/*                                             since 2004 -                 */
/*                                             webmaster@hamayan.zive.net   */
/* ------------------------------------------------------------------------ */
