/* ------------------------------------------------------------------------ */
/*  Hyper Operating System V4 ]vO								*/
/*                                                                          */
/*                                  Copyright (C) 1998-2002 by hamayan		*/
/*                                  http://sourceforge.jp/projects/hos/     */
/* ------------------------------------------------------------------------ */
#ifdef		__300HA__
#include	<no_float.h>
#endif		/*__300HA__*/

#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<ctype.h>

#include	"itron.h"
#include	"kernel.h"
#include	"kernel_id.h"
#include	"comm.h"
#include	"system.h"
#include	"ip.h"
#include	"nava_cfg.h"
#include	"udp.h"
#include	"dhcp.h"
#include	"util.h"

unsigned char	*GetRtlMac( void );

#ifdef __DHCP_USE__

typedef struct
{
	unsigned char	tag;
	unsigned char	length;
	void			*data;
} DHCP_OPTION_FIELD_ACCESS;

/********************************************************/
/*	O֐Q										*/
/********************************************************/

/*[J֐*/
static	unsigned long	DhcpDiscover( DHCP *dhcp );
static	int				DhcpOffer( DHCP *dhcp, DHCP_NETWORK_INFO *dnf, unsigned long xid );
static	void			DhcpRequest( DHCP *dhcp, DHCP_NETWORK_INFO *dnf, unsigned long xid, int mode );
static	int				DhcpPack( DHCP *dhcp, DHCP_NETWORK_INFO *dnf, unsigned long xid );

static	void			DHCPOptionWrite( void *option, const DHCP_OPTION_FIELD_ACCESS *dofa );
static	void			*DHCPOptionRead( void *option, DHCP_OPTION_FIELD_ACCESS *dofa );
static	unsigned long	GetSequenceNumber( void );

/********************************************************************/
/*	UDPpTv												*/
/*	UDP	DHCPNCAg											*/
/*	߂ĺAȂ0AُȂ-1ԂB							*/
/********************************************************************/
int UdpDhcpClient( int handle, DHCP_NETWORK_INFO *dnf, int mode )
{
#ifdef	DEBUG_MODE
	char	buf[ 64 ];
#endif
	int		i;
	int		rcv_yes;
	long	rcvsz;
	unsigned long	xid = 0;	/*gUNVID*/
	DHCP	*dhcp;
	UdpAddressAndPortInformation info;		/*UDPڑ*/

	/*\Pbg̐BIND*/
	if( UDPsocket( &info ) == EOF ) return -1;

	if( mode == DHCP_DISCOVER ) memset( ThisIs, 0, LENGTHIPV4 );	/*UAhXONAB*/
	info.sport = DHCP_CLIENT;
	info.dport = DHCP_SERVER;
	UDPbind( &info, handle );		/*bind*/

	/*L̎؂o*/
	dhcp = (DHCP *)GetMemBlock( 576 );

	if( mode == DHCP_DISCOVER )
	{
		/*DISCOVERpPbg̐ƑM*/
		xid = DhcpDiscover( dhcp );
		info.DataSz = sizeof(DHCP);		/*Mf[^*/
		info.data = (VP)dhcp;			/*DHCPpPbg̈*/
		IP_COPY( info.dip, BroadCast );	/*u[hLXgw*/
		UDPsendto( &info, handle );		/*M*/
		DebugPrintPara4( "DHCP:DIS--> to %u.%u.%u.%u\r\n", info.dip[0],info.dip[1],info.dip[2],info.dip[3] );
	}

	if( mode == DHCP_DISCOVER )
	{
		/*OFFERpPbg̎M*/
		info.tmout = 5000;				/*^CAEgԂ͂Tb*/
		info.data = (VP)dhcp;			/*Mobt@̈*/
		rcv_yes = FALSE;
		for( i = 0; i < 256; i++ )
		{
			info.DataSz = ( i == 0 ) ? sizeof(DHCP) : 0;	/*ŏ̃T[o[̂ݎ󂯎*/
			rcvsz = UDPrecvfrom( &info, handle );	/*M*/
			if( rcvsz < 0 ) break;		/*ȏ̎M*/
			DebugPrintPara4( "DHCP:OFR<-- from %u.%u.%u.%u\r\n", info.dip[0], info.dip[1], info.dip[2], info.dip[3] );
			if( rcvsz ) rcv_yes = TRUE;
		}

		if( rcv_yes == TRUE ) DhcpOffer( dhcp, dnf, xid );
		else mode = 0;
	}

	if( mode == DHCP_DISCOVER || mode == DHCP_REQUEST )
	{
		DhcpRequest( dhcp, dnf, xid, mode );
		if( mode == DHCP_REQUEST )
		{
			IP_COPY( info.dip, &dnf->dhcp_server_ip );	/*擾DHCPT[o[AhXw*/
		}
		else
		{
			IP_COPY( info.dip, BroadCast );	/*u[hLXgw*/
		}

		info.DataSz = sizeof(DHCP);		/*Mf[^*/
		info.data = (VP)dhcp;			/*DHCPpPbg̈*/
		UDPsendto( &info, handle );		/*M*/
		DebugPrintPara4( "DHCP:REQ--> to %u.%u.%u.%u\r\n", info.dip[0], info.dip[1], info.dip[2] ,info.dip[3] );
	}

	if( mode == DHCP_DISCOVER || mode == DHCP_REQUEST )
	{
		/*PACKAPNAKpPbg҂*/
		for( i = 0; i < 4; i++ )
		{
			info.tmout = 15000;				/*^CAEgԂ͂PTbAőSJԂ*/
			info.data = (VP)dhcp;			/*Mobt@̈*/
			info.DataSz = sizeof(DHCP);		/*ŏ̃T[o[̂ݎ󂯎*/
			rcvsz = UDPrecvfrom( &info, handle );	/*M҂ɓ*/
			if( rcvsz > 0 ) break;		/*M*/
			else
			{
				DhcpRequest( dhcp, dnf, xid, mode );
				if( mode == DHCP_REQUEST )
				{
					IP_COPY( info.dip, &dnf->dhcp_server_ip );	/*擾DHCPT[o[AhXw*/
				}
				else
				{
					IP_COPY( info.dip, BroadCast );	/*u[hLXgw*/
				}

				info.DataSz = sizeof(DHCP);		/*Mf[^*/
				info.data = (VP)dhcp;			/*DHCPpPbg̈*/
				UDPsendto( &info, handle );		/*M*/
				DebugPrintPara4( "DHCP:REQ--> to %u.%u.%u.%u\r\n", info.dip[0], info.dip[1], info.dip[2], info.dip[3] );
			}
		}

		if( i != 4 )
		{
			if( DhcpPack( dhcp, dnf, xid ) == 0 )
				DebugPrintPara4( "DHCP:PACK<-- from %u.%u.%u.%u\r\n", info.dip[0], info.dip[1] ,info.dip[2] ,info.dip[3] );
			else
			{
				DebugPrintPara4( "DHCP:PNAK<-- from %u.%u.%u.%u\r\n", info.dip[0], info.dip[1], info.dip[2], info.dip[3] );
				mode = 0;
			}
		}
		else mode = 0;
	}

	/*L̕ԋp*/
	RelMemBlock( (VP)dhcp );
	/*\Pbg̃N[Y*/
	UDPclose( &info );
	return ((mode) ? 0 : EOF);
}

/************************************************************************/
/*	UDP	DHCP DISCOVER													*/
/*	߂ĺAȂ0AُȂ-1ԂB								*/
/************************************************************************/
static unsigned long DhcpDiscover( DHCP *dhcp )
{
	char	buf[ 16 ];
	DHCP_OPTION_FIELD_ACCESS	dofa;
	static const char	FieldData[] = {0x01,0x02,0x03,0x04,0x05,0x06,0x07,0x08};
	static const char	magic_code[] = MAGIC_CODE;

	/*DHCPwb_[̈̐ݒ*/
	dhcp->op = 0x01;		/*IyR[h*/
	dhcp->htype = 0x01;		/*n[hEGA^Cv*/
	dhcp->hlen = LENGTHMAC;	/*n[hEGAAhX*/
	dhcp->hops = 0x00;		/*zbv*/
	dhcp->xid = GetSequenceNumber();	/*gUNVhc*/
	dhcp->secs = 0;			/*b*/
	dhcp->flags = 0;		/*gp(0Œ)*/
	dhcp->ciaddr = 0L;		/*NCAghoAhX*/
	dhcp->yiaddr = 0L;		/*[U[hoAhX*/
	dhcp->siaddr = 0L;		/*T[o[hoAhX*/
	dhcp->giaddr = 0L;		/*Q[gEGChoAhX*/
	memcpy( dhcp->chaddr, GetRtlMac(), LENGTHMAC );	/*NCAgn[hEGAAhX*/
	memset( &dhcp->chaddr[LENGTHMAC], 0, sizeof(dhcp->chaddr) - LENGTHMAC );	/*NCAgn[hEGAAhX*/
	/*T[o[zXg*/
	memset( dhcp->sname, 0 , sizeof(dhcp->sname) );
	/*T[o[t@C*/
	memset( dhcp->file, 0 , sizeof(dhcp->file) );
	/*IvV̈̐ݒ*/
	memset( dhcp->options, 0, sizeof(dhcp->options) );	/*IvV̈ONA*/
	memcpy( dhcp->options, magic_code, sizeof(magic_code) );	/*}WbNR[h̏*/
	dhcp->options[sizeof(magic_code)] = 0xff;	/*f~^̐ݒ*/
	/*IvV̏*/
	/*DISCOVERbZ[W̔s*/
	dofa.tag = DHCP_TAG_DHCP_MESSAGE_TYPE;
	dofa.length = 1;
	dofa.data = (void *)&FieldData[0];
	DHCPOptionWrite( &dhcp->options[sizeof(magic_code)], &dofa );
	/*CLIENT ID̔s*/
	dofa.tag = DHCP_TAG_DHCP_CLIENT_ID;
	dofa.length = 7;
	buf[0] = 0x01;
	memcpy( &buf[1], (char *)GetRtlMac(), LENGTHMAC );
	dofa.data = buf;
	DHCPOptionWrite( &dhcp->options[sizeof(magic_code)], &dofa );

	return dhcp->xid;
}

/************************************************************************/
/*	UDP	DHCP OFFER														*/
/*	DHCP\̂烆[U[IPƁAT[o[ID擾B					*/
/*	߂ĺAȂ0AُȂ-1ԂB								*/
/************************************************************************/
static int DhcpOffer( DHCP *dhcp, DHCP_NETWORK_INFO *dnf, unsigned long xid )
{
	char	buf[ 16 ];
	DHCP_OPTION_FIELD_ACCESS	dofa;
	static const char	magic_code[] = MAGIC_CODE;

	/*gWbgIDr*/
	if( xid != dhcp->xid ) return EOF;
	/*OFERpPbg烊[XꂽIPAhXl*/
	dnf->lease_ip = dhcp->yiaddr;
	/*OFFERbZ[WT[o[ID擾*/
	dofa.tag = DHCP_TAG_DHCP_SERVER_ID;
	dofa.length = 4;
	dofa.data = buf;
	if( DHCPOptionRead( &dhcp->options[sizeof(magic_code)], &dofa ) != (void *)NADR )
	{
		IP_COPY( &dnf->dhcp_server_ip, buf );
	}
	else
	{
		dnf->dhcp_server_ip = 0UL;
	}

	return 0;
}

/************************************************************************/
/*	UDP	DHCP REQUEST													*/
/*	IP݂oNGXg𔭍sA܂Albg[NB		*/
/************************************************************************/
static void DhcpRequest( DHCP *dhcp, DHCP_NETWORK_INFO *dnf, unsigned long xid, int mode )
{
	char	buf[ 16 ];
	DHCP_OPTION_FIELD_ACCESS	dofa;
	static const char	FieldData[] = {0x01,0x02,0x03,0x04,0x05,0x06,0x07,0x08};
	static const char	magic_code[] = MAGIC_CODE;
	static const char	request_list[] = {DHCP_TAG_SUBNET_MASK,DHCP_TAG_ROUTER,DHCP_TAG_DOMAIN_NAME_SERVER};

	/*DHCPwb_[̈̐ݒ*/
	dhcp->op = 0x01;		/*IyR[h*/
	dhcp->htype = 0x01;		/*n[hEGA^Cv*/
	dhcp->hlen = LENGTHMAC;	/*n[hEGAAhX*/
	dhcp->hops = 0x00;		/*zbv*/
	dhcp->xid = xid;		/*gUNVhc*/
	dhcp->secs = 0;			/*b*/
	dhcp->flags = 0;		/*gp(0Œ)*/
	dhcp->ciaddr = 0L;		/*NCAghoAhX*/
	dhcp->yiaddr = (mode == DHCP_REQUEST) ? dnf->lease_ip : 0L;	/*[U[hoAhX*/
	dhcp->siaddr = 0L;		/*T[o[hoAhX*/
	dhcp->giaddr = 0L;		/*Q[gEGChoAhX*/
	memcpy( dhcp->chaddr, GetRtlMac(), LENGTHMAC );	/*NCAgn[hEGAAhX*/
	memset( &dhcp->chaddr[LENGTHMAC], 0, sizeof(dhcp->chaddr) - LENGTHMAC );	/*NCAgn[hEGAAhX*/
	/*T[o[zXg*/
	memset( dhcp->sname, 0 , sizeof(dhcp->sname) );
	/*T[o[t@C*/
	memset( dhcp->file, 0 , sizeof(dhcp->file) );
	/*IvV̈̐ݒ*/
	memset( dhcp->options, 0, sizeof(dhcp->options) );	/*IvV̈ONA*/
	memcpy( dhcp->options, magic_code, sizeof(magic_code) );	/*}WbNR[h̏*/
	dhcp->options[sizeof(magic_code)] = 0xff;	/*f~^̐ݒ*/
	/*IvV̏*/
	dofa.tag = DHCP_TAG_DHCP_MESSAGE_TYPE;	/*REQUESTbZ[W̔s*/
	dofa.length = 1;
	dofa.data = (void *)&FieldData[3 - 1];
	DHCPOptionWrite( &dhcp->options[sizeof(magic_code)], &dofa );
	/*CLIENT ID̔s*/
	dofa.tag = DHCP_TAG_DHCP_CLIENT_ID;
	dofa.length = 7;
	buf[0] = 0x01;
	memcpy( &buf[1], (char *)GetRtlMac(), LENGTHMAC );
	dofa.data = buf;
	DHCPOptionWrite( &dhcp->options[sizeof(magic_code)], &dofa );
	/*pIPAhXL*/
	dofa.tag = DHCP_TAG_DHCP_REQUEST_IP_ADDRESS;
	dofa.length = 4;
	dofa.data = (char *)&dnf->lease_ip;
	DHCPOptionWrite( &dhcp->options[sizeof(magic_code)], &dofa );
	/*DHCPT[o[IDw*/
	dofa.tag = DHCP_TAG_DHCP_SERVER_ID;
	dofa.length = 4;
	dofa.data = (char *)&dnf->dhcp_server_ip;
	DHCPOptionWrite( &dhcp->options[sizeof(magic_code)], &dofa );
	/*p[^[NGXg*/
	dofa.tag = DHCP_TAG_DHCP_PARAMETER_REQUEST_LIST;
	dofa.length = sizeof(request_list);
	dofa.data = (void *)request_list;
	DHCPOptionWrite( &dhcp->options[sizeof(magic_code)], &dofa );
}

/************************************************************************/
/*	UDP	DHCP PACK														*/
/*	DHCP\̂烆[U[IP(uip)ƁAT[o[ID(sid)擾B		*/
/*	߂ĺAȂ0AُȂ-1ԂB								*/
/************************************************************************/
static int DhcpPack( DHCP *dhcp, DHCP_NETWORK_INFO *dnf, unsigned long xid )
{
	char	buf[ 16 ];
	DHCP_OPTION_FIELD_ACCESS	dofa;
	static const char	magic_code[] = MAGIC_CODE;

	/*gWbgIDr*/
	if( xid != dhcp->xid ) return EOF;
	/*PACKAPNAKpPbg̔f*/
	dofa.tag = DHCP_TAG_DHCP_MESSAGE_TYPE;
	dofa.length = 1;
	dofa.data = buf;
	if( DHCPOptionRead( &dhcp->options[sizeof(magic_code)], &dofa ) != (void *)NADR
		&& *buf == DHCP_PACK )		/*PACKłȂ́Aꂩ蒼ƂȂB*/
	{
		/*PACKpPbg烊[XԂl*/
		dofa.tag = DHCP_TAG_DHCP_IP_ADDRESS_LEASE_TIME;
		dofa.length = 4;
		dofa.data = buf;
		dnf->lease_time =
			( DHCPOptionRead( &dhcp->options[sizeof(magic_code)], &dofa ) != (void *)NADR ) ? *((unsigned long *)buf) : 0;
		/*PACKpPbgXVԂl*/
		dofa.tag = DHCP_TAG_DHCP_RENEW_TIME_VALUE;
		dnf->renew_time_value =
			( DHCPOptionRead( &dhcp->options[sizeof(magic_code)], &dofa ) != (void *)NADR ) ? *((unsigned long *)buf) : 0;
		/*PACKpPbg烊oChԂl*/
		dofa.tag = DHCP_TAG_DHCP_REBINDING_TIME_VALUE;
		dnf->rebinding_time_value =
			( DHCPOptionRead( &dhcp->options[sizeof(magic_code)], &dofa ) != (void *)NADR ) ? *((unsigned long *)buf) : 0;
		/*PACKpPbgDHCPT[o[AhXl*/
		dofa.tag = DHCP_TAG_DHCP_SERVER_ID;
		dnf->dhcp_server_ip =
			( DHCPOptionRead( &dhcp->options[sizeof(magic_code)], &dofa ) != (void *)NADR ) ? *((unsigned long *)buf) : 0;
		/*PACKpPbgTulbg}XNl*/
		dofa.tag = DHCP_TAG_SUBNET_MASK;
		dnf->sub_net_mask =
			( DHCPOptionRead( &dhcp->options[sizeof(magic_code)], &dofa ) != (void *)NADR ) ? *((unsigned long *)buf) : 0;
		/*PACKpPbghCl[AhXl*/
		dofa.tag = DHCP_TAG_DOMAIN_NAME_SERVER;
		dnf->domain_name_ip =
			( DHCPOptionRead( &dhcp->options[sizeof(magic_code)], &dofa ) != (void *)NADR ) ? *((unsigned long *)buf) : 0;
		/*PACKpPbgQ[gEGCAhXl*/
		dofa.tag = DHCP_TAG_ROUTER;
		dnf->gateway =
			( DHCPOptionRead( &dhcp->options[sizeof(magic_code)], &dofa ) != (void *)NADR ) ?  *((unsigned long *)buf) : 0;
	}
	else return EOF;

	return 0;
}

/********************************************************************/
/*	IvV̏												*/
/*	option̈ɁAdofa̓eRs[B						*/
/*	܂TAG𒲂ׁAf~^ǂ𔻒fAf~^A	*/
/*	ɘABf~^łȂ́Ä̗ɐi߂B				*/
/********************************************************************/
static void DHCPOptionWrite( void *option, const DHCP_OPTION_FIELD_ACCESS *dofa )
{
	unsigned char	*ptr = (unsigned char *)option;

	do
	{
		if( *ptr == 0xff )
		{
			*ptr++ = dofa->tag;		/*TAG̏*/
			*ptr++ = dofa->length;	/*f[^*/
			memcpy( ptr, dofa->data, dofa->length );	/*f[^̈*/
			ptr += dofa->length;	/*̗̈ɐi߂*/
			*ptr = 0xff;			/*f~^̐ݒ*/
			break;
		}
		ptr++;	/*f[^̃tB[hɐi߂*/
		ptr += *ptr + 1;
	} while( 1 );
}

/********************************************************************/
/*	IvV̓Ǎ												*/
/********************************************************************/
static void *DHCPOptionRead( void *option, DHCP_OPTION_FIELD_ACCESS *dofa )
{
	unsigned char	*ptr = (unsigned char *)option;

	do
	{
		if( *ptr == 0xff ) return (void *)NADR;	/*^Of~^̎*/
		if( *ptr == dofa->tag )	/*҂TAGt*/
		{
			memcpy( (char *)dofa->data, ptr + 2, *(ptr + 1) );
			return ptr + 2;
		}
		/*TAG{*/
		ptr++;	/*f[^̃tB[hɐi߂*/
		ptr += *ptr + 1;
	} while( 1 );
}

/********************************************************************/
/*	V[PXԍ̏l𓾂B									*/
/*	VXe^C}[ 4msPʂŔԍPB					*/
/*	߂lɂ̎_̃V[PXԍ								*/
/********************************************************************/
static unsigned long GetSequenceNumber( void )
{
	SYSTIM			RefTime;

	get_tim( &RefTime );
	RefTime.ltime >>= 2;
	RefTime.ltime |= ( RefTime.utime & 0x0001 ) ? 0x40000000 : 0x00000000;
	RefTime.ltime |= ( RefTime.utime & 0x0002 ) ? 0x80000000 : 0x00000000;

	return RefTime.ltime;
}

/********************************************************************/
/*	UDPpTv												*/
/*	DHCP̃NGXgeiẌׂɊ֐Ă܂B*/
/*	DHCP擾ł0AsEOFԂB				*/
/*	IPV6ɂ͑ΉłȂȁB										*/
/********************************************************************/
int	RequesetDHCP( int handle, DHCP_NETWORK_INFO *dnf )
{
	unsigned long	ThisIsBackup;
#ifdef	DEBUG_MODE
	char	buf[32];
#endif	/*DEBUG_MODE*/

	/*IPAhXꎞIɑޔĒuB*/
	IP_COPY( &ThisIsBackup, ThisIs );
	/*sɋʂolɂO*/
	dnf->lease_time = 0L;

	if( UdpDhcpClient( handle, dnf, DHCP_DISCOVER ) == 0 )
	{
		/*DHCPT[o[琳IPAhX擾łꍇ*/
		if( dnf->lease_ip )		IP_COPY( ThisIs, dnf->lease_ip );
		if( dnf->sub_net_mask )	IP_COPY( SubNetMask, dnf->sub_net_mask );
		if( dnf->gateway )		IP_COPY( GateWay, dnf->gateway );
		if( dnf->domain_name_ip ) IP_COPY( DomainNameServer, dnf->domain_name_ip );
		/*lbg[NAhXƁATulbg}XN̍ČvZ*/
		NetWorkAddress[0] = ThisIs[0] & SubNetMask[0];
		NetWorkAddress[1] = ThisIs[1] & SubNetMask[1];
		NetWorkAddress[2] = ThisIs[2] & SubNetMask[2];
		NetWorkAddress[3] = ThisIs[3] & SubNetMask[3];
		SubNetBroadCast[0] = ThisIs[0] | ~SubNetMask[0];
		SubNetBroadCast[1] = ThisIs[1] | ~SubNetMask[1];
		SubNetBroadCast[2] = ThisIs[2] | ~SubNetMask[2];
		SubNetBroadCast[3] = ThisIs[3] | ~SubNetMask[3];

		DebugPrintPara4( "IP Address:%u.%u.%u.%u ",*((unsigned char *)&dnf->lease_ip + 0),*((unsigned char *)&dnf->lease_ip + 1),*((unsigned char *)&dnf->lease_ip + 2),*((unsigned char *)&dnf->lease_ip + 3) );
		DebugPrintPara1( "Renew Time:%ld ", dnf->renew_time_value );
		DebugPrintPara1( "Rebind Time:%ld ", dnf->rebinding_time_value );
		DebugPrintPara1( "Lease Time:%ld\r\n", dnf->lease_time );
		/*DHCPT[o[ɂẮAXVԂԂȂ^CvL̂ŁA̎̓[XԂ̔XVԂƂB*/
		dnf->renew_time_value = ( dnf->renew_time_value ) ? dnf->renew_time_value : dnf->lease_time >> 1;
	}
	if( ThisIs[3] == 0 )	/*DHCPIPAhX̎擾oȂ*/
	{
		IP_COPY( ThisIs, &ThisIsBackup );
		return EOF;
	}

	return 0;
}


/********************************************************************/
/*	UDPpTv												*/
/*	DHCP̉eiẌׂɊ֐Ă܂B		*/
/*	ł0AsEOFԂB							*/
/********************************************************************/
int	UpdateDHCP( int handle, DHCP_NETWORK_INFO *dnf )
{
#ifdef	DEBUG_MODE
	char	buf[32];
#endif	/*DEBUG_MODE*/

	if( UdpDhcpClient( handle, dnf, DHCP_DISCOVER ) == 0 )
	{
		/*DHCPT[o[琳IPAhX擾łꍇ*/
		if( dnf->lease_ip )		IP_COPY( ThisIs, dnf->lease_ip );
		if( dnf->sub_net_mask )	IP_COPY( SubNetMask, dnf->sub_net_mask );
		if( dnf->gateway )		IP_COPY( GateWay, dnf->gateway );
		if( dnf->domain_name_ip ) IP_COPY( DomainNameServer, dnf->domain_name_ip );
		/*lbg[NAhXƁATulbg}XN̍ČvZ*/
		NetWorkAddress[0] = ThisIs[0] & SubNetMask[0];
		NetWorkAddress[1] = ThisIs[1] & SubNetMask[1];
		NetWorkAddress[2] = ThisIs[2] & SubNetMask[2];
		NetWorkAddress[3] = ThisIs[3] & SubNetMask[3];
		SubNetBroadCast[0] = ThisIs[0] | ~SubNetMask[0];
		SubNetBroadCast[1] = ThisIs[1] | ~SubNetMask[1];
		SubNetBroadCast[2] = ThisIs[2] | ~SubNetMask[2];
		SubNetBroadCast[3] = ThisIs[3] | ~SubNetMask[3];

		DebugPrintPara4( "IP Address:%u.%u.%u.%u ",*((unsigned char *)&dnf->lease_ip + 0),*((unsigned char *)&dnf->lease_ip + 1),*((unsigned char *)&dnf->lease_ip + 2),*((unsigned char *)&dnf->lease_ip + 3) );
		DebugPrintPara1( "Renew Time:%ld ", dnf->renew_time_value );
		DebugPrintPara1( "Rebind Time:%ld ", dnf->rebinding_time_value );
		DebugPrintPara1( "Lease Time:%ld\r\n", dnf->lease_time );
		/*DHCPT[o[ɂẮAXVԂԂȂ^CvL̂ŁA̎̓[XԂ̔XVԂƂB*/
		dnf->renew_time_value = ( dnf->renew_time_value ) ? dnf->renew_time_value : dnf->lease_time >> 1;
	}
	else
	{
		/* ------------------------------------------------------------------------ */
		/*	XVԂɁA\łAsRebinddingԂOFFER	*/
		/*	ĊJAłIPAhX擾łȂ́AIPAhX̎gp~߂	*/
		/*	KvLB́AXVÂ݃T|[gB						*/
		/*	ÂAgݍ݂ɓIIP擾͌ĂȂƎvEEE			*/
		/* ------------------------------------------------------------------------ */
	}

	return 0;
}

#endif	/*__DHCP_USE__*/

/* ------------------------------------------------------------------------ */
/*  Copyright (C) 1998-2002 by Project HOS                                  */
/* ------------------------------------------------------------------------ */
