/* ------------------------------------------------------------------------ */
/*  Hyper Operating System V4 ]vO								*/
/*                                                                          */
/*                                  Copyright (C) 1998-2002 by hamayan		*/
/*                                  http://sourceforge.jp/projects/hos/     */
/* ------------------------------------------------------------------------ */
#ifdef		__300HA__
#include	<no_float.h>
#endif		/*__300HA__*/

#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<ctype.h>

#include	"itron.h"
#include	"kernel.h"
#include	"kernel_id.h"
#include	"comm.h"
#include	"system.h"
#include	"ip.h"
#include	"nava_cfg.h"
#include	"tcp.h"
#include	"util.h"

/********************************************************/
/*	O֐Q										*/
/********************************************************/

/********************************************************************/
/*	TCPpTv												*/
/********************************************************************/
void dis_cli( int argc, char *argv[], int handle )
{
#define	BLOCK_NUMBER		1000
#define	TRANSMIT_DATA_SIZE	50000
#define	USER_BREAK			0x03
	char	buffer[ 32 ];
	int		index;
	TcpAddressAndPortInformation info;		/*TCPڑ*/

	/*p[^[`FbNƑIPAhX̎擾*/
	if( argc != 2 || IPAddSplit( info.dip, argv[ 1 ] ) != 0 )		/*]IPAhX擾*/
	{
		SCI_Puts( handle, "PARAMETER ERROR : transmit IP ADDRESS\r\n" );
		return;
	}

	/*[U[ŎMobt@̈o^*/
	TCPRegistReceiveBufferArea( &info, buffer, sizeof(buffer) );
	/*]|[gԍ擾*/
	info.dport = DISCARD;	/*AvP[VŎwFKv*/
	/*\Pbg̐*/
	TCPsocket( &info );
	/*ڑ*/
	if( TCPconnect( &info, handle ) == 0 )
	{
		for( index = 0; index < BLOCK_NUMBER; index++ )
		{
			if( SCI_Getc( handle ) == USER_BREAK )
			{
				TCPclose( &info, handle );
				return;
			}
			/*f[^̑M*/
			if( TCPwrite( &info, (void *)0, TRANSMIT_DATA_SIZE ) < EOF ) break;
		}
		if( index == BLOCK_NUMBER ) TCPclose( &info, handle );
		else TCPForceCloseState( &info );
	}
	else TCPForceCloseState( &info );	/*I*/
}

/********************************************************************/
/*	TCPpTv												*/
/********************************************************************/
void TcpDiscardServerTask( VP_INT handle );

void dis_server( int argc, char *argv[], int handle )
{
	ID		tid;

	/*p[^[̃`FbN*/
	if( argc != 1 )
	{
		SCI_Puts( handle, "PARAMETER ERROR : discard serve\r\n" );
		return;
	}
	/*^XN̐*/
#define		TCPDISCARDSERVERTASK_STK_SZ		(((((452 + 80) - 1) / 16) + 1) * 16)	/*H8300H̏ꍇ*/
	tid = CreateTask( handle, TCPDISCARDSERVERTASK_STK_SZ, 7, (FP)TcpDiscardServerTask );
	if( tid <= 0 )
	{
		SCI_Puts( handle, "acre_tsk error\r\n" );
		return;
	}
	/*^XN̋N*/
	act_tsk( tid );				/*^XN̋N*/
}

static char RcvBuffer[ MSS_SIZE * 1 ];

void TcpDiscardServerTask( VP_INT handle )
{
	char	*ComparePtr,*ptr;
	int		i;
	long	length;
	TcpAddressAndPortInformation info;		/*TCPڑ*/

	/*^XN̓o^*/
	RegistProcessTable( _BACK_GROUND_, TRUE );
	while(1)
	{
		/*vZXKILLꂽf*/
		if( QueryRunningMode() == -1 ) break;

		/*\Pbg̐*/
		TCPsocket( &info );
		/*|[gԍ擾*/
		info.sport = DISCARD;			/*AvP[VŎwFKv*/
		/*bind*/
		TCPbind( &info );
		/*listen*/
		TCPlisten( &info, handle );
		/*[U[ŎMobt@̈o^*/
		TCPRegistReceiveBufferArea( &info, RcvBuffer, sizeof(RcvBuffer) );
		/*accept*/
		if( TCPaccept( &info, handle ) == 0 )
		{
			ComparePtr = (char *)0;
			/*read*/
			while( 1 )
			{
				if( (length = TCPread(&info, RcvBuffer, sizeof(RcvBuffer))) > 0 )
				{
					ptr = RcvBuffer;
					/*Mf[^̃`FbN*/
					for( i = 0; i < length; i++ )
					{
						if( *ComparePtr++ != *ptr++ )
						{
							SCI_Puts( handle, "DATA COMPARE ERROR\r\n" );
							length = EOF;
							break;
						}
						/*rAhX̊ۂ*/
						if( ComparePtr == (char *)TRANSMIT_DATA_SIZE ) ComparePtr = (char *)0;
					}
					/*obt@󂢂LBȂƉėȂ\LB*/
					TCPRegistReceiveBufferArea( &info, RcvBuffer, sizeof(RcvBuffer) );
					TCPAnnounceReceiveBufferSize( &info );
				}
				else if( length < 0 ) break;
				else{}
			}
			if( length == EOF ) TCPclose( &info, handle );	/*FINMꍇ*/
			else	/*^CAEgُȈ*/
			{
				switch ( length )
				{
					case TCP_UNREACHABLE_PORT :
						SCI_Puts( handle, "TCP UNREACHABLE PORT\r\n" );
						break;
					case TCP_DISCONNECT :
						SCI_Puts( handle, "TCP DISCONNECT\r\n" );
						break;
					case TCP_UNKNOWN_IP_ADDRESS :
						SCI_Puts( handle, "TCP_UNKNOWN_IP_ADDRESS\r\n" );
						break;
					case TCP_TIME_OUT :
						SCI_Puts( handle, "TCP_TIME_OUT\r\n" );
						break;
					default :
						SCI_Puts( handle, "ANOTHER REASON\r\n" );
						break;
				}
				TCPForceCloseState( &info );	/*ICLOSED̏ԂɂB*/
			}
		}
		else TCPForceCloseState( &info );	/*ICLOSED̏ԂɂB*/
	}

	/*^XN̍폜*/
	RelocateProcessTable();
	exd_tsk();					/*TASK̏Iƍ폜*/
}

/* ------------------------------------------------------------------------ */
/*  Copyright (C) 1998-2002 by Project HOS                                  */
/* ------------------------------------------------------------------------ */
