/* ------------------------------------------------------------------------ */
/*  Hyper Operating System V4									   			*/
/*	test program for Navajo													*/
/*	: DNS IPAhX									*/
/*																			*/
/*	̃vÓAm-arai̍DӂŁAProject HOS̒앨ƂȂ܂B	*/
/*                                  Copyright (C) 1998-2004 by Project HOS  */
/*                                  http://sourceforge.jp/projects/hos/     */
/* ------------------------------------------------------------------------ */
#ifdef		__300HA__
#include	<no_float.h>
#endif		/*__300HA__*/

#include <stdio.h>
#include <string.h>

#include	"itron.h"
#include	"kernel.h"
#include	"comm.h"
#include	"system.h"
#include	"ip.h"
#include	"nava_cfg.h"
#include	"udp.h"

#define DNS_PSIZE	512
#define PORT_DNS	53

#define E_LONG		-1	/* hC߂ */
#define E_BADID		-2	/* 񓚂IDႤ */
#define E_BADHD		-3	/* 񓚂̃wb_łȂ */
#define E_SNDFAIL	-4	/* Ȃ񂩒mUDPsendɎs  */
#define E_SCKFAIL	-5	/* Ȃ񂩒mUDPsocketɎs  */

static const UB head_qa[] = {
  0x01,0x00, /* ċAƉ */
  0x00,0x01, /* ␔ 1 */
  0x00,0x00, /* 񓚐 */
  0x00,0x00, /*  */
  0x00,0x00 /* ǉ */
}; 

static const UB tail_qa[] = {
  0x00,		/* hCI[ */
  0x00,0x01,	/* type  A */
  0x00,0x01	/* class INET */
}; 

static const UB repl_head[] = {
  0x81, 0x00,	/* FLAG: ,ċAƉ */
  0x00, 0x01,	/* Qnum: ␔ 1 */
  0x00, 0x01,	/* Anum: 񓚐 1 */
  0x00, 0x00,	/* : 0 */
  0x00, 0x00,	/* ǉ: 0 */
};

/* ǂł̂,ꉞ */
static int id = 0;

/* DNS A̖₢킹pPbg쐬
   Ԃl̓pPbgTCY邢͕̃G[R[h */
int setup_query_pkt( char *dname, UB buff[])
{
  char *p,*q;
  int  i,len,lid;

  /* idj[N */
  loc_cpu();
  lid = id++;
  unl_cpu();

  /* IDݒ */
  buff[0] = (lid >> 8) & 0xff;
  buff[1] = lid & 0xff;

  /* FLAG`hCȑO̐ݒ */
  memcpy( &buff[2], head_qa, sizeof( head_qa));

  for ( i=12,p=dname; *p != '\0'; i+=len, p=q+1) {
    /* '.'͕̌ */
    for ( q=p; *q != '.' && *q != '\0'; q++);

    /* pPbg`FbN */
    if( (len = q-p)+i > DNS_PSIZE-5) {
      return E_LONG;
    }

    buff[i++] = len;

    /* Rs[ */
    strncpy( (char *)&buff[i], p, len);

    if (*q=='\0') {
      i += len;
      break;
    }
  }

  /* hCI[`pPbgI̐ݒ */
  memcpy( &buff[i], tail_qa, sizeof( tail_qa));

  return i+sizeof(tail_qa);
}

int getaddr_from_pkt( int qid, unsigned char buff[], unsigned char addr[])
{
  int i;

  /* 񓚂IDvĂ邩`FbN */
  if ( qid != ((buff[0]<<8) + buff[1])) {
    return E_BADID;
  }

  /* wb_񓚂`FbN */
  if (((buff[2] & 0xfb) != 0x81) || ((buff[3] & 0x0f) != 0)
      || ((buff[4]<<8)+buff[5]) != 1 || ((buff[6]<<8)+buff[7]) != 1 ){
    return E_BADHD;
  }

  /* hC̏I[T */
  for ( i=12; buff[i]!='\0'; i++);

  /* ̌,񓚂̃^Cv͈؃`FbNȂ */

  if ( ( buff[i+5] & 0xc0) == 0xc0) {
    /* hC͈kĂ */
    memcpy( addr, &buff[i+17], LENGTHIPV4);
  } else {
    /* L蓾Ȃ,kĂȂ */
    /* hCI[ */
    for( i=i+6; buff[i]!='\0'; i++);
    memcpy( addr, &buff[i+11], LENGTHIPV4);
  }

  return 0;
}

/*static char dnsqp[DNS_PSIZE]; */
/*static char dnsap[DNS_PSIZE]; */

int getaddrbydns( char *dname , char addr[] )
{
    int  ssz,ret,qid;
    long  rsz;
    UB	*buff;
    UdpAddressAndPortInformation info;		/*UDPڑ*/

    if ( UDPsocket( &info) == EOF )
      return E_SCKFAIL;

    UDPbind( &info );

    /* LDNSpPbgobt@p擾 */
    buff = (UB *)GetMemBlock( DNS_PSIZE);

    /* server address/port̐ݒ */
    IP_COPY( info.dip, DomainNameServer );
    info.dport = PORT_DNS;
    info.tmout = 10*1000; /* ^CAEg͂ */

    /* DNS A₢킹pPbg쐬 */
    info.DataSz = ssz = setup_query_pkt( dname, buff);
    info.data = buff;
/*    info.DataSz = ssz = setup_query_pkt( dname, dnsqp); */
/*    info.data = dnsqp; */
    qid = (buff[0]<<8)+buff[1];
/*    qid = (dnsqp[0]<<8)+dnsqp[1]; */

    /* pPbgM */
    if ( UDPsendto( &info ) == EOF) {
      /* DNSpPbgobt@p */
      RelMemBlock( buff);
	  /*\Pbg̃N[Y*/
	  UDPclose( &info );
      return E_SNDFAIL;
    }

/*    info.data = dnsap; */
    info.DataSz = DNS_PSIZE;
    /* 񓚎M */
    rsz = UDPrecvfrom( &info );

    /* 񓚂IPAhX擾 */
/*    ret = getaddr_from_pkt( qid, dnsap, addr); */
    ret = getaddr_from_pkt( qid, buff, (unsigned char *)addr);

    /* DNSpPbgobt@p */
    RelMemBlock( buff);
	/*\Pbg̃N[Y*/
	UDPclose( &info );

    return ret;
}

/* ------------------------------------------------------------------------ */
/*                                  Copyright (C) 1998-2004 by Project HOS  */
/*                                  http://sourceforge.jp/projects/hos/     */
/* ------------------------------------------------------------------------ */
