/* ------------------------------------------------------------------------ */
/*  Hyper Operating System V4 ]vO								*/
/*                                                                          */
/*                                  Copyright (C) 1998-2002 by hamayan		*/
/*                                  http://sourceforge.jp/projects/hos/     */
/* ------------------------------------------------------------------------ */
#ifdef		__300HA__
#include	<no_float.h>
#endif		/*__300HA__*/

#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<ctype.h>

#include	"itron.h"
#include	"kernel.h"
#include	"kernel_id.h"
#include	"comm.h"
#include	"system.h"
#include	"ip.h"
#include	"tcp.h"
#include	"cgi.h"
#include	"nava_cfg.h"
unsigned char	*GetRtlMac( void );

/********************************************************/
/*	IvVXCb`ɑΉo^\	*/
/********************************************************/
typedef	struct
{
	int		(* func)(int argc,char *argv[],int handle);
	char	*optionname;
} OPTION_LIST;

/********************************************************/
/*	O֐Q										*/
/********************************************************/

/********************************************************************/
/*			ifconfigs											*/
/*	]̎NETWORK̎QƂɁAXɏ̍XV@\ǉI			*/
/*	{IɓIɕύX̂́AIPAhXNETMASKƎvB		*/
/*	NETMASKύXƎIɁANET ADDRESSDEFAULT GATEWAYA		*/
/*	hXύXB												*/
/********************************************************************/
/************************************************/
/*	̊֐łpȂ@\֐			*/
/************************************************/
static int DisplayInfo( int argc, char *argv[], int handle );
static int InterfaceSet( int argc, char *argv[], int handle );
static int UnSupporting( int argc, char *argv[], int handle );
static int NetMaskChange( int argc, char *argv[], int handle );
static int IPV4AddChange( int argc, char *argv[], int handle );
static int DNSChange( int argc, char *argv[], int handle );
static int GATEWAYChange( int argc, char *argv[], int handle );

/************************************************/
/*	ifconfig̎								*/
/*	ifconfigA{Iɂ̓R}hC	*/
/*	NƂȂĂ邪AXg쐬	*/
/*	vŐN\B				*/
/************************************************/
void ifconfig( int argc, char *argv[], int handle )
{
	OPTION_LIST	*ol;
	static const OPTION_LIST	OptionList[] =	/*IvVLIST*/
	{
		{DisplayInfo,	"-a"},			/*݂̏\*/
		{InterfaceSet,	"eth0"},			/*ݒύXC^tF[X̕ύX*/
		{InterfaceSet,	"lo"},			/*ݒύXC^tF[X̕ύX*/
	};

	if( argc == 1 )
	{	/*ݒ̕\*/
		DisplayInfo( argc, argv, handle );
		return;
	}
	else
	{	/*ݒ*/
		/*IvV*/
		ol = (OPTION_LIST *)OptionList;
		while( ol < &OptionList[ sizeof(OptionList) / sizeof(OPTION_LIST) ] )
		{
			if( strncmp( ol->optionname, argv[ 1 ], strlen(ol->optionname) ) == 0 )
			{
				/*YIvV*/
				(*ol->func)( argc, argv, handle );
				return;
			}
			ol++;
		}
	}
	SCI_Puts( handle, "Illegal option type : Please read the man page for ifconfig\r\n" );
}

/*݂̃foCXAIPAhXANET MASKADEFAULT GATEWAY\*/
static int DisplayInfo( int argc, char *argv[], int handle )
{
	char			buf[ 64 ];
	unsigned char	*rtlMAC;

	rtlMAC = GetRtlMac();
	sprintf( buf, "eth0,Ethernet HWaddr=%02x:%02x:%02x:%02x:%02x:%02x\r\n", 
		rtlMAC[0] & 0xff,rtlMAC[1] & 0xff,rtlMAC[2] & 0xff,rtlMAC[3] & 0xff,rtlMAC[4] & 0xff,rtlMAC[5] & 0xff );
	SCI_Puts( handle, buf );

	sprintf( buf, "inet addr=%u.%u.%u.%u\r\n", ThisIs[0],ThisIs[1],ThisIs[2],ThisIs[3] );
	SCI_Puts( handle, buf );

	sprintf( buf, "net addr=%u.%u.%u.%u\r\n", NetWorkAddress[0],NetWorkAddress[1],NetWorkAddress[2],NetWorkAddress[3] );
	SCI_Puts( handle, buf );

	sprintf( buf, "Mask=%u.%u.%u.%u\r\n", SubNetMask[0],SubNetMask[1],SubNetMask[2],SubNetMask[3] );
	SCI_Puts( handle, buf );

	sprintf( buf, "Gateway=%u.%u.%u.%u\r\n", GateWay[0],GateWay[1],GateWay[2],GateWay[3] );
	SCI_Puts( handle, buf );

	sprintf( buf, "DNS=%u.%u.%u.%u\r\n", DomainNameServer[0],DomainNameServer[1],DomainNameServer[2],DomainNameServer[3] );
	SCI_Puts( handle, buf );

	sprintf( buf, "SubNetBCast=%u.%u.%u.%u\r\n", SubNetBroadCast[0],SubNetBroadCast[1],SubNetBroadCast[2],SubNetBroadCast[3] );
	SCI_Puts( handle, buf );

	return 0;
}

/*̃IvVtXɉ͂KvƂ*/
/*ifconfig eth0 address 192.168.100.204 netmask 255.255.255.0 dns 192.168.100.1 gateway 192.168.100.1*/
/*ɒӂKvȂ̂́Agateway̍XV͈ԍŌɍsB*/
static int InterfaceSet( int argc, char *argv[], int handle )
{
	int			i;
	OPTION_LIST	*ol;
	static const OPTION_LIST	OptionList[] =	/*IvVLIST*/
	{
		{UnSupporting,	"up"},			/*C^tF[XԂɂBA͂Ȃ*/
		{UnSupporting,	"down"},		/*C^tF[X~ԂɂBA͂Ȃ*/
		{UnSupporting,	"metric"},		/*T|[g*/
		{UnSupporting,	"mtu"},			/*̏T|[g*/
		{NetMaskChange,	"netmask"},		/*NETMASKXV*/
		{IPV4AddChange,	"address"},		/*IPV4AhXXV*/
		{DNSChange,		"dns"},			/*DNSAhXXV*/
		{GATEWAYChange,	"gateway"},		/*GATEWAYAhXXV*/
	};

	if( argc <= 3 )
	{
		SCI_Puts( handle, "Illegal option type : Please read the man page for ifconfig\r\n" );
		return EOF;
	}
	else
	{
		if( strncmp( argv[ 1 ], "eth0", sizeof("eth0") - 1 ) == 0 )	/*̏eth0̂ݑΉ*/
		{
			/*̉*/
			for( i = 2; i < argc; i++ )
			{
				/*IvV*/
				ol = (OPTION_LIST *)OptionList;
				while( ol < &OptionList[ sizeof(OptionList) / sizeof(OPTION_LIST) ] )
				{
					if( strncmp( ol->optionname, argv[ i ], strlen(ol->optionname) ) == 0 )
					{
						/*YIvV*/
						if( (*ol->func)( i, argv, handle ) != 0 ) return EOF;
					}
					ol++;
				}
			}
			/*lbg[NAhXƃTulbgu[hLXg̍XV*/
			for( i = 0; i < LENGTHIPV4; i++ )
			{
				NetWorkAddress[i] = ThisIs[i] & SubNetMask[i];	/*NETWORKAhX̕ύX*/
				SubNetBroadCast[i] = (BroadCast[i] & ~SubNetMask[i]) | NetWorkAddress[i];
			}
			return 0;
		}
		else
		{
			return EOF;
		}
	}
}

static int UnSupporting( int argc, char *argv[], int handle )
{
	SCI_Puts( handle, "Un-Supporting Option\r\n" );
	return EOF;
}

static int NetMaskChange( int argc, char *argv[], int handle)
{
	int		i,mask[ 4 ];

	if( sscanf( argv[ argc + 1 ], "%d.%d.%d.%d", &mask[0], &mask[1], &mask[2], &mask[3] ) == LENGTHIPV4 )
	{
		for( i = 0; i < LENGTHIPV4; i++ )
		{
			SubNetMask[ i ] = mask[ i ];					/*SUB NET MASK̕ύX*/
			NetWorkAddress[ i ] = ThisIs[ i ] & mask[ i ];	/*NETWORKAhX̕ύX*/
		}
		return 0;
	}
	else return EOF;
}

static int IPV4AddChange( int argc, char *argv[], int handle)
{
	int		i,newip[ 4 ];

	if( sscanf( argv[ argc + 1 ], "%u.%u.%u.%u", &newip[0], &newip[1], &newip[2], &newip[3] ) == LENGTHIPV4 )
	{
		for( i = 0; i < LENGTHIPV4; i++ )
		{
			ThisIs[ i ] = newip[ i ];						/*IP ADDRESS̕ύX*/
			NetWorkAddress[ i ] = newip[ i ] & SubNetMask[ i ];	/*NETWORKAhX̕ύX*/
		}
		return 0;
	}
	else return EOF;
}

static int DNSChange( int argc, char *argv[], int handle )
{
	int		i,newip[ 4 ];

	if( sscanf( argv[ argc + 1 ], "%u.%u.%u.%u", &newip[0], &newip[1], &newip[2], &newip[3] ) == LENGTHIPV4 )
	{
		for( i = 0; i < LENGTHIPV4; i++ ) DomainNameServer[ i ] = newip[ i ];	/*DNS ADDRESS̕ύX*/
		return 0;
	}
	else return EOF;
}

static int GATEWAYChange( int argc, char *argv[], int handle )
{
	int		i,newip[ 4 ];

	if( sscanf( argv[ argc + 1 ], "%u.%u.%u.%u", &newip[0], &newip[1], &newip[2], &newip[3] ) == LENGTHIPV4 )
	{
		for( i = 0; i < LENGTHIPV4; i++ ) GateWay[ i ] = newip[ i ];	/*GATEWAY ADDRESS̕ύX*/
		return 0;
	}
	else return EOF;
}

/********************************************************************/
/*	WEBy[WRtBM[VB			*/
/*	lbg[NO[vłύX͂łȂƂB			*/
/*	\bhGETŒlnȂ́Aݒl\݂̂ƂAln	*/
/*	lnꂽ́AύXAstrinfosB܂AύX̒l̍	*/
/*	\sB													*/
/********************************************************************/
#if !defined( __NETCLOCK3_3069_20__ )
static const char HtmlHeadAndBody[] =
{
	"<html lang=\"ja\">\r\n"
	"<head>\r\n"
	"<meta http-equiv=\"Content-type\" content=\"text/html; charset=Shift_JIS\">\r\n"
	"<title>IPAhXύXy[W</title>\r\n"
	"</head>\r\n"

	"<body bgcolor=\"#ccffcc\">\r\n"
	"<center><h3>IPAhXύXy[W</h3>\r\n"

	"<center><h3><font color=\"#cc0000\">ӁIIPAhX̕ύX́AċNȂƐVݒ肪LɂȂ܂B</font></h3><br></center>\r\n"
	"<center>\r\n"
	""
};

static const struct
{
	char	msg[40];
	char	name[8];
	unsigned char	*ip;
} HtmlFormIPContents[] =
{
	{"fBARo[^IPAhX̐ݒ",	"ip",	ThisIs},
	{"SUBNET MASKAhX̐ݒ",			"mask",	SubNetMask},
	{"ftHgQ[gEGCAhX̐ݒ","gw",	GateWay},
	{"DNSAhX̐ݒ",					"dns",	DomainNameServer},
	{"SMTPT[o[IPAhX̐ݒ",		"smtp",	SMTPServer},
	{"NTPT[o[IPAhX̐ݒ",			"ntp",	NTPServer},
	{"SYSLOGT[o[IPAhX̐ݒ",		"sys",	SYSLOGServer},
	{"POP3T[o[IPAhX̐ݒ",		"pop",	POP3Server},
};

static const char HtmlFormTable[] =
{
	"<form method=\"get\" action=\"ifconfig.cgi\">\r\n<table border=\"1\">\r\n"
};

static const char HtmlFormTableEnd[] =
{
	"</table>\r\n</form>\r\n"
};

static const char HtmlFormTr[] =
{
	"<tr align=\"left\">\r\n"
};

static const char HtmlFormTrEnd[] =
{
	"<tr align=\"left\">\r\n"
};

static const char HtmlFormTd[] =
{
	"<td>"
};

static const char HtmlFormTdEnd[] =
{
	"</td>\r\n"
};

static const char HtmlFormInput1[] =
{
	"<input size=\"8\" name=\""
};

static const char HtmlFormInput2[] =
{
	"\" type=\"text\" value=\""
};

static const char HtmlFormInput3[] =
{
	"\">\r\n"
};

static const char HtmlFormSubmit[] =
{
	"<tr align=\"center\"><td colspan=\"2\">\r\n"
	"<input value=\"ύX\" type=\"submit\"><input value=\"\" type=\"reset\">\r\n"
	"</td></tr>\r\n"
};

static const char HtmlFooter[] =
{
	"</body></html>\r\n\r\n"
};

int	StoreAnyInformation2EEPROM( void );	/*EEPROM֏ݏ*/
static char ifconfig_work[256 * 12];

static int CGIifconfig( TcpAddressAndPortInformation *info, int argc, char *argv[] )
{
	int		i,j,num,keta,end_point,temp;
	char	*str;

	/*/ifconfigɑ?݂鎞́AɃp[^LB*/
	if( strncmp( argv[ RQUEST_URL ], "/ifconfig.cgi?", sizeof("/ifconfig.cgi?") - 1) == 0 )
	{
		/*lbg[NO[vȊO̕ύX́AsƂB*/
		if(
			(info->dip[0] ^ ThisIs[0]) & SubNetMask[0] ||
			(info->dip[1] ^ ThisIs[1]) & SubNetMask[1] ||
			(info->dip[2] ^ ThisIs[2]) & SubNetMask[2] ||
			(info->dip[3] ^ ThisIs[3]) & SubNetMask[3]
		) goto _DiaplayOnly;

		str = argv[ RQUEST_URL ];	/*URL͂̐擪AhX擾B*/
		end_point = strlen( str );	/*URL̒擾B*/
		str[ sizeof("/ifconfig.cgi?") - 2 ] = '&';
		for( j = 0; j < end_point; j++ )
		{
			/*񌟍*/
			if( str[j] == '&' )
			{
				/*L[[h̒vB*/
				for( i = 0; i < sizeof(HtmlFormIPContents) / sizeof(HtmlFormIPContents[0]); i++ )
				{
					if( strncmp( HtmlFormIPContents[i].name, &str[j + 1], strlen( HtmlFormIPContents[i].name ) ) == 0 )	/*L[[hƂ̈vB*/
					{
						/*v̂ŁAL[[hɑ擾B*/
						num = j + 1 + strlen(HtmlFormIPContents[i].name);
						if( isdigit(str[ num ]) )	/*ł鎖mF*/
						{
							keta = str[ num++ ] - '0';	/*IPAhX̌LĒuB*/
							num++;	/*CR[̕΂B*/
							/*ϐIPRtBM[VB*/
							if( isdigit(str[ num ]) )	/*ŏ*/
							{
								temp = str[ num++ ] - '0';	/*1*/
								if( isdigit(str[ num ]) )
								{
									temp *= 10;
									temp += str[ num++ ] - '0';	/*19*/
									if( isdigit(str[ num ]) )
									{
										temp *= 10;
										temp += str[ num++ ] - '0';	/*192*/
									}
								}

								/*ASCIIintɕϊAϐ̈̏sĂB*/
								HtmlFormIPContents[i].ip[ keta ] = temp;
							}
							j = num - 1;
						}
						break;
					}
				}
			}
		}
		/*EEPROM֕ۑ*/
		StoreAnyInformation2EEPROM();
	}

_DiaplayOnly:
	/*y[WHEADERABODY*/
	strcpy( ifconfig_work, HtmlHeadAndBody );

	/*<TABLE>*/
	strcat( ifconfig_work, HtmlFormTable );
	for( i = 0; i < sizeof(HtmlFormIPContents) / sizeof(HtmlFormIPContents[0]); i++ )
	{
		/*<TR>*/
		strcat( ifconfig_work, HtmlFormTr );

		/*<TD>*/
		strcat( ifconfig_work, HtmlFormTd );
		/*Rec*/
		strcat( ifconfig_work, HtmlFormIPContents[ i ].msg );
		/*</TD>*/
		strcat( ifconfig_work, HtmlFormTdEnd );

		/*<TD>*/
		strcat( ifconfig_work, HtmlFormTd );
		for( j = 0; j < LENGTHIPV4; j++ )
		{
			sprintf( strchr( ifconfig_work, '\0' ),
				"%s%s%d%s%u%s",
				HtmlFormInput1,					/*<input size=8 name=*/
				HtmlFormIPContents[ i ].name,	/*ip*/
				j,								/*ԍ*/
				HtmlFormInput2,					/*type=text value=*/
				HtmlFormIPContents[ i ].ip[ j ],	/*192*/
				HtmlFormInput3					/*>\r\n*/
			);
		}
		/*</TD>*/
		strcat( ifconfig_work, HtmlFormTdEnd );

		/*</TR>*/
		strcat( ifconfig_work, HtmlFormTrEnd );
	}
	/*{^\*/
	strcat( ifconfig_work, HtmlFormSubmit );

	/*</TABLE>*/
	strcat( ifconfig_work, HtmlFormTable );

	/*y[WFOOTER*/
	strcat( ifconfig_work, HtmlFooter );

	return TCPwrite( info, ifconfig_work, strlen(ifconfig_work) );
}

/********************************************************************/
/*	httpdANZX郌R[h									*/
/********************************************************************/
const FILE_PROPERTIES ifconfig_cgi =
{
	"ifconfig.cgi",
	"2004/10/13 09:31:00",
	CGIifconfig,
	(void *)0,
	"designed by hamayan",
	(void *)0,
	0,
};
#endif  /*!defined( __NETCLOCK3_3069_20__ )*/

/* ------------------------------------------------------------------------ */
/*  Copyright (C) 1998-2002 by Project HOS                                  */
/* ------------------------------------------------------------------------ */
