/* ------------------------------------------------------------------------ */
/*  Hyper Operating System V4 ]vO								*/
/*  SNTP                                                                    */
/*                                  Copyright (C) 2003-2004 by hamayan		*/
/*                                  http://sourceforge.jp/projects/hos/     */
/* ------------------------------------------------------------------------ */
#ifdef		__300HA__
#include	<no_float.h>
#endif		/*__300HA__*/

#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<ctype.h>

#define	__THIS_IS_A_NTP_C_FILE__

#undef	DEBUG_MODE

#include	"itron.h"
#include	"kernel.h"
#include	"kernel_id.h"
#include	"comm.h"
#include	"system.h"
#include	"udp.h"
#include	"ip.h"
#include	"nava_cfg.h"
#include	"ntp.h"
#include	"util.h"

#define		DELTA128			0x02000000UL		/*_ȉ̉ZPʁB1281b*/
#define		DELTA_TIMER			(2147483648UL / 64 / (__CPU_CLOCK__ / 8 / 128))		/*^C}[1JEg̕␳*/

#if		defined(__NETCLOCK3_3069_20__)
#include	"h83068f.h"
#endif	/*defined(__NETCLOCK3_3069_20__)*/

void SNTPSyncTimerStartStop( int StartStop );
volatile unsigned short SNTPSyncTimerCounterGet( void );
void SNTPSyncTimerCounterSet( unsigned short value );

/*GRAXVpϐ*/
extern unsigned short NewGRAValue;

static unsigned long SelfDateTime( NTP_TIME_STAMP_FORMAT *self );
static void SelfDateTimeSet( NTP_TIME_STAMP_FORMAT self );

char	DateTimeStrings[24];
char	DateTimeStringsFor7SegLed[16];

/* ----------------------------------------------------------- */
/*  1900N̒ʎZb̃e[uB                           */
/* ----------------------------------------------------------- */
static const unsigned long SecondTableFrom2003To2035[] =
{
	3281904000UL,	/*age 2003*/
	3313526400UL,	/*age 2004*/
	3345062400UL,	/*age 2005*/
	3376598400UL,	/*age 2006*/
	3408134400UL,	/*age 2007*/
	3439756800UL,	/*age 2008*/
	3471292800UL,	/*age 2009*/
	3502828800UL,	/*age 2010*/
	3534364800UL,	/*age 2011*/
	3565987200UL,	/*age 2012*/
	3597523200UL,	/*age 2013*/
	3629059200UL,	/*age 2014*/
	3660595200UL,	/*age 2015*/
	3692217600UL,	/*age 2016*/
	3723753600UL,	/*age 2017*/
	3755289600UL,	/*age 2018*/
	3786825600UL,	/*age 2019*/
	3818448000UL,	/*age 2020*/
	3849984000UL,	/*age 2021*/
	3881520000UL,	/*age 2022*/
	3913056000UL,	/*age 2023*/
	3944678400UL,	/*age 2024*/
	3976214400UL,	/*age 2025*/
	4007750400UL,	/*age 2026*/
	4039286400UL,	/*age 2027*/
	4070908800UL,	/*age 2028*/
	4102444800UL,	/*age 2029*/
	4133980800UL,	/*age 2030*/
	4165516800UL,	/*age 2031*/
	4197139200UL,	/*age 2032*/
	4228675200UL,	/*age 2033*/
	4260211200UL,	/*age 2034*/
	4291747200UL,	/*age 2035*/
};

/* ----------------------------------------------------------- */
/*  e̒ʎZbe[uB                                 */
/* ----------------------------------------------------------- */
static const unsigned long	SecAtMonth[2][13] =
{
	{
		0,
		JAN_SEC, FEB_SEC, MAR_SEC, APR_SEC, MAY_SEC, JUN_SEC,
		JLY_SEC, AUG_SEC, SEP_SEC, OCT_SEC, NOV_SEC, DEC_SEC
	},
	{
		0,
		JAN_SEC, FEB_LEAP_SEC, MAR_LEAP_SEC, APR_LEAP_SEC, MAY_LEAP_SEC, JUN_LEAP_SEC,
		JLY_LEAP_SEC, AUG_LEAP_SEC, SEP_LEAP_SEC, OCT_LEAP_SEC, NOV_LEAP_SEC, DEC_LEAP_SEC
	},
};

struct NTP_SERVER_LIST
{
	char	ip[ LENGTHIPV4 ];
	char	*name;
};

/* ----------------------------------------------------------- */
/*  ^C}[                                               */
/*  ܂A^C}[2004Nn܂B                   */
/* ----------------------------------------------------------- */
volatile NTP_TIME_STAMP_FORMAT SelfTimer =
{
#define		THIS_YEAR		2004UL
#define		DIF_FROM_1900	(THIS_YEAR - 1900UL)

	3281904000UL,	/**/
	0	/**/
};

/* ----------------------------------------------------------- */
/*  ^C}[̐ԂB                               */
/* ----------------------------------------------------------- */
unsigned long SecsFrom1900( void )
{
	return SelfTimer.integer;
}

/********************************************************************/
/*  1900N̒ʎZbvZĂ݂B                              */
/********************************************************************/
static unsigned long TotalSecondFrom1900( unsigned short year )
{
	return SecondTableFrom2003To2035[ year - 2004 ];
}

/********************************************************************/
/*  [Nǂ𔻒肷B[N̎͂PAȊO͂OԂB      */
/********************************************************************/
static int DeciedLeapYear( unsigned short year )
{
	return ( year % 4 ) ? 0 : ( year % 100 ) ? 1 : ( year % 400 ) ? 0 : 1;
}

/********************************************************************/
/*  b猻݂̌𒲂ׂBAA̒ʎZb͈ZĂ    */
/*  鎖B                                                          */
/*  leaṕA[N̎PAȊO͂OB                          */
/********************************************************************/
static int MonthFromSecond( unsigned long sec, int leap )
{
	int month;

	for( month = 0; month < 13; month++ )
	{
		if( sec < SecAtMonth[ leap ][ month ] ) return month;
	}
	return EOF;
}

/********************************************************************/
/*  1900N11̒ʎZb\ɕϊB                  */
/*  timer͒ʎZbAdest͓̕ۑB                   */
/*  ߂ĺA擪AhXB                              */
/*  ӁIdestɂ͏\ȗeʂL鎖B                              */
/********************************************************************/
char *Str2DateTime( unsigned long timer, char *dest )
{
	unsigned short	year,month,day,hour,minute,second;
	unsigned long	seconds;

	timer += TZ * ONE_HOUR_SEC;		/*^C][̒*/

	/*̐̎擾*/
	for( year = 2004; year < 2100; year++ )	/*TotalSecondFrom1900ł̌vZ܂ɂȂ̂ŁA2099NEB*/
	{
		seconds = TotalSecondFrom1900( year );
		if( timer == seconds ) break;
		else if( timer < seconds )
		{
			seconds = TotalSecondFrom1900( --year );
			break;
		}
		else{}
	}

	timer -= seconds;
	/*̌̎擾*/
	month = MonthFromSecond( timer, DeciedLeapYear( year ) );
	timer -= SecAtMonth[ DeciedLeapYear( year ) ][ month - 1 ];
	/*̓t̎擾*/
	day = (timer / ONE_DAY_SEC) + 1;
	timer %= ONE_DAY_SEC;
	/*ݎ̎擾*/
	hour = timer / ONE_HOUR_SEC;
	timer %= 3600;
	minute = timer / 60;
	second = timer % 60;

	/*𐶐B*/
	/*2004/05/31 11:07:30*/
	dest[0] = (year / 1000) | '0';
	dest[1] = ((year % 1000) / 100) | '0';
	dest[2] = ((year % 100) / 10) | '0';
	dest[3] = (year % 10) | '0';
	dest[4] = '/';

	dest[5] = ( (month / 10) == 0 ) ? ' ' : (month / 10) | '0';
	dest[6] = (month % 10) | '0';
	dest[7] = '/';

	dest[8] = ( (day / 10) == 0 ) ? ' ' : (day / 10) | '0';
	dest[9] = (day % 10) | '0';
	dest[10] = ' ';

	dest[11] = ( (hour / 10) == 0 ) ? ' ' :	(hour / 10) | '0';
	dest[12] = (hour % 10) | '0';
	dest[13] = ':';

	dest[14] = (minute / 10) | '0';
	dest[15] = (minute % 10) | '0';
	dest[16] = ':';

	dest[17] = (second / 10) | '0';
	dest[18] = (second % 10) | '0';
	dest[19] = '\0';

	DateTimeStringsFor7SegLed[ 0 ] = dest[ 0 ];	/*̃Rs[*/
	DateTimeStringsFor7SegLed[ 1 ] = dest[ 1 ];
	DateTimeStringsFor7SegLed[ 2 ] = dest[ 2 ];
	DateTimeStringsFor7SegLed[ 3 ] = dest[ 3 ];

	DateTimeStringsFor7SegLed[ 4 ] = (dest[ 5 ] == ' ') ? 0xff : dest[ 5 ];	/*̃Rs[*/
	DateTimeStringsFor7SegLed[ 5 ] = dest[ 6 ];

	DateTimeStringsFor7SegLed[ 6 ] = (dest[ 8 ] == ' ') ? 0xff : dest[ 8 ];	/*̃Rs[*/
	DateTimeStringsFor7SegLed[ 7 ] = dest[ 9 ];

	DateTimeStringsFor7SegLed[ 8 ] = (dest[ 11 ] == ' ') ? 0xff : dest[ 11 ];	/*̃Rs[*/
	DateTimeStringsFor7SegLed[ 9 ] = dest[ 12 ];

	DateTimeStringsFor7SegLed[ 10 ] = dest[ 14 ];	/*̃Rs[*/
	DateTimeStringsFor7SegLed[ 11 ] = dest[ 15 ];

	DateTimeStringsFor7SegLed[ 12 ] = dest[ 17 ];	/*b̃Rs[*/
	DateTimeStringsFor7SegLed[ 13 ] = dest[ 18 ];

	return dest;
}

/********************************************************************/
/*  \̓m̈Z                                              */
/********************************************************************/
static NTP_TIME_STAMP_FORMAT __sub( NTP_TIME_STAMP_FORMAT a, NTP_TIME_STAMP_FORMAT b )
{
	if( a.small_number < b.small_number ) a.integer--;
	a.small_number -= b.small_number;
	a.integer -= b.integer;

	return a;
}

/********************************************************************/
/*  \̓m̑Z                                              */
/********************************************************************/
static NTP_TIME_STAMP_FORMAT __add( NTP_TIME_STAMP_FORMAT a, NTP_TIME_STAMP_FORMAT b )
{
	unsigned long	temp = a.small_number;

	a.integer += b.integer;
	a.small_number += b.small_number;
	if( a.small_number < temp ) a.integer++;

	return a;
}

/********************************************************************/
/*  \̂QŊ                                                */
/********************************************************************/
static NTP_TIME_STAMP_FORMAT __div2( NTP_TIME_STAMP_FORMAT a )
{
	unsigned long	temp = a.integer;

	a.small_number /= 2UL;
	if( a.integer & 0x00000001UL ) a.small_number |= 0x80000000UL;
	a.integer >>= 1;
	a.integer |= temp & 0x80000000UL;

	return a;
}

void SNTPSyncTimerCounterInit( void );

/********************************************************************/
/*  SNTPvO                                                  */
/*  芸NTPɃbZ[W𑗂āAĂ݂悤B           */
/*  ߂l̒ǉAsrandɎglɃG[1ԂĂB        */
/*  ^CT[o[琳擾ł΁A_ȏԐMB    */
/********************************************************************/
unsigned long SNTPClient( unsigned char dip[], int handle )
{
#ifdef	DEBUG_MODE
	char	buf[32];
	NTP_TIME_STAMP_FORMAT	Delay;
#endif	/*DEBUG_MODE*/
	int		area = 0;
	static unsigned long	DelayAverageBuffer[4] = {0x10000,0x10000,0x10000,0x10000};
	UdpAddressAndPortInformation info;		/*UDPڑ*/
	NTP_MESSAGE_FORMAT	ntp;
	NTP_TIME_STAMP_FORMAT	LocalTimeStamp,Error;

	/*NCAgbZ[W̐*/
	ntp.B.LI = 0;	/*[bʎq*/
	ntp.B.VN = 4;	/*o[Wԍ*/
	ntp.B.Mode = 3;	/*[h:NCAg*/
	ntp.Layer = 0;	/*Kw*/
	ntp.PollingPeriod = 0;	/*|[OԊu*/
	ntp.Precision = 0;	/*x*/
	ntp.Delay = 0;	/*x*/
	ntp.Spread = 0;	/*gU*/
	ntp.RefID = 0;	/*ʎq*/

	ntp.RefTimeStamp.integer = ntp.RefTimeStamp.small_number = 0;	/*Qƃ^CX^vNA*/
	ntp.StaTimeStamp.integer = ntp.StaTimeStamp.small_number = 0;	/*Jn^CX^vNA*/
	ntp.RcvTimeStamp.integer = ntp.RcvTimeStamp.small_number = 0;	/*M^CX^vNA*/

#if 0
	ntp.KeyID = 0;	/*ʎq*/
#endif

	/*\Pbg̐*/
	if( UDPsocket( &info ) == EOF ) return 1;
	/*bind*/
	UDPbind( &info );
	IP_COPY( info.dip, dip );	/*IPAhX̎w*/
	info.dport = NTP;				/*|[gԍ*/
	info.DataSz = sizeof( ntp );	/*Mf[^*/
	info.data = &ntp;
	SelfDateTime( &ntp.SndTimeStamp );	/*JnԂ̋L^*/
	/*M*/
	UDPsendto( &info );
	/*MɕKvȏZbg*/
	info.tmout = 1000;
	info.DataSz = sizeof( ntp );	/*Mobt@TCY*/
	info.data = &ntp;			/*Mobt@̈*/
	if( UDPrecvfrom( &info ) <= 0 )
	{
		UDPclose( &info );	/*\Pbg̃N[Y*/
		return 1;			/*G[*/
	}

	if( ntp.Delay > (((DelayAverageBuffer[0] + DelayAverageBuffer[1] + DelayAverageBuffer[2] + DelayAverageBuffer[3])/4) + 0x1000) ) goto _skip;	/*Ƀ[gx傫̓XLbvĂ݂B*/

#define		T1	ntp.StaTimeStamp
#define		T2	ntp.RcvTimeStamp
#define		T3	ntp.SndTimeStamp
#define		T4	LocalTimeStamp

	SNTPSyncTimerStartStop( 0 );	/*UA^C}[̒~*/
	SelfDateTime( &LocalTimeStamp );	/*IԂ̋L^*/

	/* 덷 = ((T2 - T1) + (T3 - T4)) / 2*/
	Error = __div2( __add( __sub(T2,T1), __sub(T3,T4) ) );

#define	DEFAULT_GRA_VALUE		((__CPU_CLOCK__ / 8 / 128) - 1)
#define	COMPENSATION_VALUE		(long)(DELTA128 / 1)
#define	LOCK_RANGE				0xf0000000UL
#define	MULTIPLY				1

	if( (Error.integer == 0x00000000UL) && ((Error.small_number & LOCK_RANGE) == 0x00000000UL) )
	{
		if( (long)Error.small_number <= (0x02000000 * 4) )
		{
			if( (long)Error.small_number <= (0x02000000 * 2) )
			{
				if( (long)Error.small_number <= (0x02000000 * 1) )
				{
					NewGRAValue = DEFAULT_GRA_VALUE - (0 * MULTIPLY);
					area = 1;
				}
				else
				{
					NewGRAValue = DEFAULT_GRA_VALUE - (1 * MULTIPLY);
					area = 2;
				}
			}
			else
			{
				if( (long)Error.small_number <= (0x02000000 * 3) )
				{
					NewGRAValue = DEFAULT_GRA_VALUE - (2 * MULTIPLY);
					area = 3;
				}
				else
				{
					NewGRAValue = DEFAULT_GRA_VALUE - (3 * MULTIPLY);
					area = 4;
				}
			}
		}
		else
		{
			if( (long)Error.small_number <= (0x02000000 * 6) )
			{
				if( (long)Error.small_number <= (0x02000000 * 5) )
				{
					NewGRAValue = DEFAULT_GRA_VALUE - (4 * MULTIPLY);
					area = 5;
				}
				else
				{
					NewGRAValue = DEFAULT_GRA_VALUE - (5 * MULTIPLY);
					area = 6;
				}
			}
			else
			{
				if( (long)Error.small_number <= (0x02000000 * 7) )
				{
					NewGRAValue = DEFAULT_GRA_VALUE - (6 * MULTIPLY);
					area = 7;
				}
				else
				{
					NewGRAValue = DEFAULT_GRA_VALUE - (7 * MULTIPLY);
					area = 8;
				}
			}
		}
	}
	else if( (Error.integer == 0xffffffffUL) && ((Error.small_number & LOCK_RANGE) == LOCK_RANGE) )
	{
		if( (long)Error.small_number >= ((-COMPENSATION_VALUE) * 4) )
		{
			if( (long)Error.small_number >= ((-COMPENSATION_VALUE) * 2) )
			{
				if( (long)Error.small_number >= ((-COMPENSATION_VALUE) * 1) )
				{
					NewGRAValue = DEFAULT_GRA_VALUE + (0 * MULTIPLY);
					area = -1;
				}
				else
				{
					NewGRAValue = DEFAULT_GRA_VALUE + (1 * MULTIPLY);
					area = -2;
				}
			}
			else
			{
				if( (long)Error.small_number >= ((-COMPENSATION_VALUE) * 3) )
				{
					NewGRAValue = DEFAULT_GRA_VALUE + (2 * MULTIPLY);
					area = -3;
				}
				else
				{
					NewGRAValue = DEFAULT_GRA_VALUE + (3 * MULTIPLY);
					area = -4;
				}
			}
		}
		else
		{
			if( (long)Error.small_number >= ((-COMPENSATION_VALUE) * 6) )
			{
				if( (long)Error.small_number >= ((-COMPENSATION_VALUE) * 5) )
				{
					NewGRAValue = DEFAULT_GRA_VALUE + (4 * MULTIPLY);
					area = -5;
				}
				else
				{
					NewGRAValue = DEFAULT_GRA_VALUE + (5 * MULTIPLY);
					area = -6;
				}
			}
			else
			{
				if( (long)Error.small_number >= ((-COMPENSATION_VALUE) * 7) )
				{
					NewGRAValue = DEFAULT_GRA_VALUE + (6 * MULTIPLY);
					area = -7;
				}
				else
				{
					NewGRAValue = DEFAULT_GRA_VALUE + (7 * MULTIPLY);
					area = -8;
				}
			}
		}
	}
	else
	{
		SelfDateTimeSet(  __add( SelfTimer, Error ) );
/*		NewGRAValue = DEFAULT_GRA_VALUE;*/
		area = 10;
	}
	SNTPSyncTimerStartStop( 1 );	/*^C}[̍ĊJ*/

_skip:
	/*\Pbg̃N[Y*/
	UDPclose( &info );

	DelayAverageBuffer[0] = DelayAverageBuffer[1];
	DelayAverageBuffer[1] = DelayAverageBuffer[2];
	DelayAverageBuffer[2] = DelayAverageBuffer[3];
	DelayAverageBuffer[3] = ntp.Delay;

	/*␳][̕\*/
	DebugPrintPara1( "area %d ", area );
	/*T[o[bZ[W̕\*/
	DebugPrintPara4( "LI=%d VN=%d La=%d Po=%d ", ntp.B.LI, ntp.B.VN, ntp.Layer, ntp.PollingPeriod );
	DebugPrintPara4( "Pr=%d De=%lx Sp=%lx Re=%lx ", (char)ntp.Precision, ntp.Delay, ntp.Spread, ntp.RefID );

	/* 덷̕\*/
	DebugPrintPara2( "%08lX.%08lX ", Error.integer, Error.small_number);

#ifdef	DEBUG_MODE
	/* x = (T4 - T1) - (T2 - T3)*/
	Delay = __sub( __sub(T4,T1), __sub(T2,T3) );
#endif	/*DEBUG_MODE*/
	DebugPrintPara2( "%08lX.%08lX\r\n", Delay.integer, Delay.small_number);

	return T3.integer;
}

/********************************************************************/
/*  SNTPvÕf                                            */
/*  芸NTPɃbZ[W𑗂āAĂ݂悤B           */
/********************************************************************/
void SNTPClientDemo( int argc, char *argv[], int handle )
{
#ifdef FID_TUTORIAL3	/*荞݃nhCxgtOgă^C~OA鎞B*/

#define	USER_BREAK	0x03
	int		count = 0;
	char	datestr[ 32 ];
	unsigned char	dip[ LENGTHIPV4 ];

	/*p[^[`FbNƑIPAhX̎擾*/
	if( argc != 2 || IPAddSplit( dip, argv[ 1 ] ) != 0 )		/*]IPAhX擾*/
	{
		SCI_Puts( handle, "PARAMETER ERROR : sntp IP ADDRESS\r\n" );
		return;
	}

	while( 1 )
	{
		/*[U[BREAK̊mF*/
		while( RecByteSize( handle ) > 0 ) if( SCI_Getc( handle ) == USER_BREAK ) return;

		/*񐔂̃[vɁANTPT[o[ɃANZXB*/
		if( !(count % SNTP_SCAN_PERIOD) ) SNTPClient( dip, handle );

		/*^C}[Ab̍XV^C~OႤB*/
		wai_flg( FID_TUTORIAL3, 0x01, TWF_ORW, NULL );
		SCI_Puts( handle, Str2DateTime( SelfTimer.integer, datestr) );
		/*[vJE^̍XV*/
		count++;
	}

#endif	/*FID_TUTORIAL3*/
}

/********************************************************************/
/*  vpJEgAbvB荞݂R[B        */
/*  荞ݏ͎̂ˑɂȂĂ܂̂ŁAˑȂ    */
/*  R[hʂB                                                */
/********************************************************************/
void SNTPSyncIndependentPart( void )
{
	unsigned long	temp;

	/*XVO̒lL*/
	temp = SelfTimer.small_number;
	/*Ԃ̍XV*/
	SelfTimer.small_number += DELTA128;
	/*b̍XV*/
	if( SelfTimer.small_number < temp )
	{
		SelfTimer.integer++;

		Str2DateTime( SelfTimer.integer, DateTimeStrings );

#ifdef TID_TUTORIAL3	/*荞݃nhLCD\^XNNꍇ*/
		iact_tsk( TID_TUTORIAL3 );
#endif	/*TID_TUTORIAL3*/

#ifdef FID_TUTORIAL3	/*荞݃nhCxgtOgă^C~OA鎞B*/
		/*bCxgtO̔s*/
		iset_flg( FID_TUTORIAL3, 0x01 );
#endif	/*FID_TUTORIAL3*/
	}
}

/********************************************************************/
/*  vp̓Ǎ                                                */
/*  up͕bAdown͏                                      */
/*  ߂l͕b                                                    */
/********************************************************************/
static unsigned long SelfDateTime( NTP_TIME_STAMP_FORMAT *self )
{
	if( self == (NTP_TIME_STAMP_FORMAT *)NULL ) return SelfTimer.integer;	/*ۑ悪́Ab̂ݓB*/
	self->integer = SelfTimer.integer;
	self->small_number = SelfTimer.small_number + (SNTPSyncTimerCounterGet() * DELTA_TIMER);
	return self->integer;
}

static void SelfDateTimeSet( NTP_TIME_STAMP_FORMAT self )
{
	SelfTimer.integer = self.integer;
	SelfTimer.small_number = self.small_number & 0xFE000000UL;
	SNTPSyncTimerCounterSet( (self.small_number % DELTA128) / DELTA_TIMER );
}

#undef	__THIS_IS_A_NTP_C_FILE__

/* ------------------------------------------------------------------------ */
/*  Copyright (C) 2003-2004 by hamayan                                      */
/* ------------------------------------------------------------------------ */
