/* ------------------------------------------------------------------------ */
/*  Hyper Operating System V4 ]vO								*/
/*                                                                          */
/*                                  Copyright (C) 1998-2002 by hamayan		*/
/*                                  http://sourceforge.jp/projects/hos/     */
/* ------------------------------------------------------------------------ */
#ifdef		__300HA__
#include	<no_float.h>
#endif		/*__300HA__*/

#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<ctype.h>

#include	"itron.h"
#include	"kernel.h"
#include	"kernel_id.h"
#include	"comm.h"
#include	"system.h"
#include	"ip.h"
#include	"nava_cfg.h"
#include	"util.h"

/********************************************************/
/*	IvVXCb`ɑΉo^\	*/
/********************************************************/
typedef	struct
{
	void	(* func)(int argc,char *argv[],int handle);
	char	*optionname;
} OPTION_LIST;

/********************************************************/
/*	PINGM										*/
/********************************************************/
typedef struct
{
	unsigned char	ttl;			/*TTL*/
	unsigned short	ident;			/*ʎq*/
	unsigned short	sequ;			/*V[PXԍ*/
} PING_RCV_INFO;

/********************************************************/
/*	PINGp IPAhX̍\							*/
/********************************************************/
typedef struct
{
	short				sz;			/*Mf[^TCY*/
	unsigned short		sequ;		/*V[PXԍ*/
	int					handle;		/*nhԍ*/
	const unsigned char	*dip;		/*MIPAhX*/
	const unsigned char	*sip;		/*MIPAhX*/
	const char			*data;		/*Mf[^*/
	PING_RCV_INFO		pri;		/*PINGM*/
} PING_REQUEST_FORMAT;

/********************************************************/
/*	O֐Q										*/
/********************************************************/
/*PING֘A*/
long	PINGReq( PING_REQUEST_FORMAT *prf );

/********************************************************************/
/*			PINGs												*/
/*	Fping -l 1472 -n 100 192.168.100.1							*/
/*	ӁI̊֐̓Gggɂ͏oĂȂ					*/
/********************************************************************/
/************************************************/
/*	̊֐łpȂ\			*/
/************************************************/
struct PING_PARAMETER
{
	short	size;
	int		count;
};
static	struct PING_PARAMETER	ppara;

/*-nɑPINGTCY擾*/
static void PingOption_l( int argc, char *argv[], int handle)
{
	ppara.size = atoi( argv[ argc + 1 ] );
}

/*-lɑPING񐔂擾*/
static void PingOption_n( int argc, char *argv[], int handle)
{
	ppara.count = atoi( argv[ argc + 1 ] );
}

void ping( int argc, char *argv[], int handle )
{
	char				linebuf[ 80 ];
	unsigned char		dip[ 4 ];
	int					i,total,arrival,lost;
	long				time;
	char				*mblk;
/*	PING_RCV_INFO		*pri;*/
	OPTION_LIST			*ol;
	PING_REQUEST_FORMAT prf;
	static const OPTION_LIST	OptionList[] =		/*IvVLIST*/
	{
		{PingOption_n,	"-n"},				/*PING̉񐔂w肷*/
		{PingOption_l,	"-l"},				/*f[^tB[hTCYw肷*/
	};

	/*̉*/
	if( argc < 2 || argc > 6 ) return;		/*p[^̃G[*/
	ppara.size = 64;						/*IvVȂ̏l*/
	ppara.count = 10;						/*IvVȂ̏l*/

	for( i = 1; i < argc; i++ )
	{
		/*IvV*/
		ol = (OPTION_LIST *)OptionList;
		while( ol < &OptionList[ sizeof(OptionList) / sizeof(OPTION_LIST) ] )
		{
			if( strcmp( ol->optionname, argv[ i ] ) == 0 )
				/*YIvV*/
				(*ol->func)( i, argv, handle );
			ol++;
		}
	}
	/*IPAhX̎擾*/
	if( IPAddSplit( dip, argv[ argc - 1 ] ) != 0 ) return;

	sprintf( linebuf, "%sging DestIP:%u.%u.%u.%u Size:%d Loop:%d\r\n",
		argv[0],dip[0],dip[1],dip[2],dip[3],ppara.size,	ppara.count
	);
	SCI_Puts( handle, linebuf );

	/*PINGpf[^̈m*/
	if( (mblk = (char *)GetMemBlock( sizeof(T_MSG) + ppara.size )) == (char *)EOF ) return;
	/*PINGőMf[^쐬*/
	for( i = (int)sizeof(T_MSG); i < (ppara.size + (int)sizeof(T_MSG)); i++ ) mblk[ i ] = i;
	/*PINGs֐ւ̃p[^[O*/
	prf.dip = dip;
	prf.sip = ThisIs;
	prf.data = &mblk[sizeof(T_MSG)];
	prf.sz = ppara.size;
	prf.sequ = 0;
	prf.handle = handle;

	/*Wvf[^̏*/
	total = arrival = lost = 0;

	/*1bPING𔭐*/
	for( i = 0; i < ppara.count; i++ )
	{
		dly_tsk( 1000 );
		/*[U[BREAK̊mF*/
#define	USER_BREAK	0x03
		while( RecByteSize( handle ) > 0 ) if( SCI_Getc( handle ) == USER_BREAK ) goto _ping_user_break;

		total++;
		/*NGXg̔s*/
		time = PINGReq( &prf );
		if( time != EOF )
		{
			arrival++;
			sprintf( linebuf, "Reply from %u.%u.%u.%u bytes=%d time=%ldms TTL=%d\r\n",
				dip[0],dip[1],dip[2],dip[3],ppara.size,time,prf.pri.ttl
			);
			SCI_Puts( handle, linebuf );
		}
		else
		{
			lost++;
			sprintf( linebuf, "Reply error from %u.%u.%u.%u\r\n", dip[0],dip[1],dip[2],dip[3] );
			SCI_Puts( handle, linebuf );
		}
	}
_ping_user_break:
	sprintf( linebuf, "    Total=%d Arrival=%d Lost=%d\r\n", total,arrival,lost );
	SCI_Puts( handle, linebuf );
	RelMemBlock( mblk );			/*v[̊J*/
}

/* ------------------------------------------------------------------------ */
/*  Copyright (C) 1998-2002 by Project HOS                                  */
/* ------------------------------------------------------------------------ */
