/* ------------------------------------------------------------------------ */
/*  Hyper Operating System V4 ]vO								*/
/*                                                                          */
/*                                  Copyright (C) 2003- by hamayan			*/
/*                                  http://sourceforge.jp/projects/hos/     */
/* ------------------------------------------------------------------------ */
#ifdef		__300HA__
#include	<no_float.h>
#endif		/*__300HA__*/

#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<ctype.h>

#include	"itron.h"
#include	"kernel.h"
#include	"kernel_id.h"
#include	"comm.h"
#include	"system.h"
#include	"ip.h"
#include	"nava_cfg.h"
#include	"tcp.h"
#include	"util.h"
#include	"rtl8019.h"			/*RTL8019ASŗL̒`*/

/********************************************************/
/*	O֐Q										*/
/********************************************************/

/*[J֐*/

/*[Jϐ*/
enum MessageIndex
{
	HELO,MAIL,RCPT,DATA,RSET,SEND,SOML,SAML,VRFY,EXPN,HELP,NOOP,QUIT,TURN,
};

typedef struct
{
	int		size;		/*Mobt@̃TCY*/
	char	*message;	/*MbZ[W*/
	char	*code;		/*MR[h*/
	char	*buffer;	/*Mobt@*/
	TcpAddressAndPortInformation	*info;	/**/
} MESSAGE_FORMAT;

static char	buffer[ 1024 ];	/*^XN痘pȂAr䂪KvƂȂB*/

/********************************************************************/
/*	T[o[̉Xe[^X҂֐B						*/
/*	info͐ڑAcode͊҂Xe[^XR[hA			*/
/*	buffer͎Mobt@ƁAbuffer_sz͂̃TCYB					*/
/*	ɎMł0ԂAsEOFԂĂB		*/
/********************************************************************/
static int RecptCommandMessage( MESSAGE_FORMAT *msg )
{
	do
	{
		if( TCPread( msg->info, msg->buffer, msg->size ) <= 0 ) return EOF;
		/*obt@󂢂LBȂƉėȂ\LB*/
		TCPRegistReceiveBufferArea( msg->info, msg->buffer, msg->size );
		TCPAnnounceReceiveBufferSize( msg->info );
	} while( strncmp( msg->buffer, msg->code, strlen(msg->code) ) != 0 );

	return 0;
}

static int TransmitMessage( MESSAGE_FORMAT *msg )
{
	long	length;

	TCPRegistReceiveBufferArea( msg->info, msg->buffer, msg->size );

	if( (length = TCPwrite( msg->info, msg->message, strlen(msg->message) )) < 0 ) return EOF;

	/*bZ[W荞*/
	if( length == 0 )
	{
		do
		{
			if( TCPread( msg->info, msg->buffer, msg->size ) <= 0 ) return EOF;
			TCPRegistReceiveBufferArea( msg->info, msg->buffer, msg->size );
			TCPAnnounceReceiveBufferSize( msg->info );
		} while( strncmp( msg->buffer, msg->code, strlen(msg->code) ) != 0 );
	}
	else
	{
		while( strncmp( msg->buffer, msg->code, strlen(msg->code) ) != 0 )
		{
			TCPRegistReceiveBufferArea( msg->info, msg->buffer, msg->size );
			TCPAnnounceReceiveBufferSize( msg->info );
			if( TCPread( msg->info, msg->buffer, msg->size ) <= 0 ) return EOF;
		}
		TCPRegistReceiveBufferArea( msg->info, msg->buffer, msg->size );
	}

	return 0;
}

unsigned short Cntr2Read( volatile union RTL8019AS *eth );
extern const VP   mknl_idl_stk;		/* idle stack */
extern const SIZE mknl_idl_stksz;	/* idle stack size */
extern const VP kernel_int_sp;		/* interrupt stack pointer */
extern VP kernel_heap_mem[];		/* kernel heap */
extern const T_KERNEL_TCB_ROM kernel_tcb_rom[];	/* task control block for rom area */

typedef struct
{
	short	tid;			/*^XNID*/
	short	id;				/*ubNID*/
	VP		blk;			/*AhX*/
} MemControlBlock;

extern MemControlBlock	mcb[];		/*݂opv[̊Ǘ̈*/
extern int	MemControlBlock_Num;	/*Ǘ̈̃e[u*/

/********************************************************************/
/*	TCPpTv												*/
/*	R}hC												*/
/*	sendamail SMTPT[o[IPAhXAFDQN						*/
/*	sendamailSendMail̃GCAXœo^Aƌ蟭			*/
/********************************************************************/
void SendMail( int argc, char *argv[], int handle )
{
	int		i,task;
	int		ret = EOF;
	long	length;
	TcpAddressAndPortInformation info;		/*TCPڑ*/
	MESSAGE_FORMAT	msg;
	SYSTIM	systime;
	static const char EhloMailServer[] = "EHLO navajo.com\r\n";
	static const char MailFrom[] = "MAIL FROM:tospomas@tc5.so-net.ne.jp\r\n";	/*MAhXBKXύXĂˁB*/
	static const char RcptTo_01[] = "RCPT TO:tospomas@tc5.so-net.ne.jp\r\n";	/*tAhXBKXύXĂˁB*/
	static const char MailMessages[] =
	{
		"Subject: Log mail from Navajo.\r\n"
		"From: tospomas@tc5.so-net.ne.jp\r\n"	/*MAhXBKXύXĂˁB*/
		"To: tospomas@tc5.so-net.ne.jp\r\n"	/*tAhXBKXύXĂˁB*/
		"This is a log mail from navajo.\r\n"
		"\r\n"
	};

	do
	{
		/*\Pbg̐*/
		if( TCPsocket( &info ) < 0 ) break;

		/*p[^[`FbNƑIPAhX̎擾*/
		if( argc == 1 )	/*ftHgSMTPT[o[AhXgpB*/
		{
			if( !(SMTPServer[3] & ~SubNetMask[3]) )
			{
				SCI_Puts( handle, "Unknown SMTP Server.\r\n" );
				break;
			}
			memcpy( info.dip, SMTPServer, LENGTHIPV4 );
		}
		else
		{
			if( !(argc == 2 && IPAddSplit( info.dip, argv[ 1 ] ) == 0) )		/*]IPAhX擾*/
			{
				SCI_Puts( handle, "PARAMETER ERROR : sendamail IP ADDRESS\r\n" );
				break;
			}
		}

		/*[U[ŎMobt@̈o^*/
		TCPRegistReceiveBufferArea( &info, buffer, sizeof(buffer) );
		/*]|[gԍ擾*/
		info.dport = SMTP;	/*AvP[VŎwFKv*/

		/*ڑ*/
		if( TCPconnect( &info ) < 0 ) break;

		/*OC̃bZ[W荞*/
		msg.info = &info;
		msg.buffer = buffer;
		msg.size = sizeof(buffer);
		msg.code = "220";
		if( RecptCommandMessage( &msg ) != 0 ) break;

		/*HELO*/
		msg.code = "250";
		msg.message = (char *)EhloMailServer;
		if( TransmitMessage( &msg ) != 0 ) break;

		/*mail from*/
		msg.message = (char *)MailFrom;
		if( TransmitMessage( &msg ) != 0 ) break;

		/*rcpt to t悪L鎞́AJԂB*/
		msg.message = (char *)RcptTo_01;
		if( TransmitMessage( &msg ) != 0 ) break;

		/*data*/
		msg.code = "354";
		msg.message = "DATA\r\n";
		if( TransmitMessage( &msg ) != 0 ) break;

		/*message*/
		msg.code = "250";
		msg.message = buffer;
		/*ObZ[W̐*/
		/*VXe^C}[l̎擾*/
		get_tim( &systime );
		sprintf( buffer, "%sTIMER %u:%lu ", MailMessages, systime.utime, systime.ltime );

		/*IDLE STACǨ*/
		for( i = 0; i < mknl_idl_stksz; i++ ) if( ((char *)mknl_idl_stk)[ i ] != 0 ) break;
		length = strlen(buffer);
		sprintf( buffer + length, "Id:%d/%ld", i, mknl_idl_stksz );

		/*INT STACǨ*/
		for( i = 0; i < 512; i++ ) if( ((char *)kernel_int_sp - 512)[ i ] != 0 ) break;
		length = strlen(buffer);
		sprintf( buffer + length, " In:%d/512", i );

		/*CNTR2̌*/
		length = strlen(buffer);
		sprintf( buffer + length, " Cntr2:%04x\r\n\r\n", Cntr2Read( (volatile union RTL8019AS *)ETH0_START_ADDRESS ) );

		/*TASK STACǨ*/
		strcat( buffer, "TASK STACK" );
		for( task = 0; task < TMAX_TSKID; task++ )
		{
			for( i = 0; i < kernel_tcb_rom[ task ].stksz; i++ ) if( ((char *)kernel_tcb_rom[ task ].stk)[ i ] != 0 ) break;
			length = strlen(buffer);
			sprintf( buffer + length, " T%d:%d/%ld", task + 1, i, kernel_tcb_rom[ task ].stksz );
		}

		/*v[Ǘ̈̌*/
		strcat( buffer, "\r\n\r\nMEMORY POOL" );

		for( i = 0; i < MemControlBlock_Num; i++ )
		{
			if( mcb[i].blk != (VP)0 )
			{
				length = strlen(buffer);
				sprintf( buffer + length, " T=%d", mcb[i].tid );
			}
		}

		/*bZ[W̏I*/
		strcat( buffer, "\r\n\r\n.\r\n" );

		if( TransmitMessage( &msg ) != 0 ) break;

		/*QUIT*/
		msg.code = "221";
		msg.message = "QUIT\r\n";
		if( TransmitMessage( &msg ) != 0 ) break;

		ret = 0;
	} while( 0 );

	if( ret == 0 )	/*ɏI*/
		TCPclose( &info );
	else	/*ُI*/
		TCPForceCloseState( &info );	/*I*/
}

/* ------------------------------------------------------------------------ */
/*                                  Copyright (C) 2003- by hamayan			*/
/* ------------------------------------------------------------------------ */
