/*************************************************************************/
/*	񏈗Library													 */
/*	                                Copyright (C) 1998-2008 by hamayan	 */
/*************************************************************************/
#include	<stdio.h>		/**/
#include	<string.h>		/* 񑀍 Header File */
#include	<machine.h>		/* Compiler Header File */
#include	<sh2/7040s.h>	/* SH7040 Header File   */

#include	"derivative.h"

/*************************************************************************/
/*	ϐ̊F													 */
/*************************************************************************/

/*************************************************************************/
/*	vg^Cv錾													 */
/*************************************************************************/

/*************************************************************************/
/*	Binary to Hex														 */
/*************************************************************************/
int bin2hex( char *dst, const void *src, int size )
{
	int i;
	const unsigned char *ptr = (const unsigned char *)src;
	static const char ascii[] = "0123456789ABCDEF";

	for( i = 0; i < size; i++ )
	{
		*dst++ = ascii[ *ptr >> 4 ];
		*dst++ = ascii[ *ptr & 0x0f ];
		ptr++;
	}

    *dst = '\0';
	return size * 2;
}

/*************************************************************************/
/*	Hex to Binary														 */
/*	Asize͋łȂ΂ȂȂ									 */
/*************************************************************************/
int hex2bin( const char *src, int size )
{
	int i,ret;
	unsigned char temp1,temp2;

	for( i = ret = 0; i < size; i++ )
	{
		ret <<= 8;

		temp1 = *src++;
		temp2 = (temp1 >= 'a') ? temp1 - ('a' - 10) : (temp1 >= 'A') ? temp1 - ('A' - 10) : temp1 - '0';
		ret += temp2 << 4;

		temp1 = *src++;
		temp2 = (temp1 >= 'a') ? temp1 - ('a' - 10) : (temp1 >= 'A') ? temp1 - ('A' - 10) : temp1 - '0';
		ret += temp2;
	}

	return ret;
}

/*************************************************************************/
/*	HEXBINob`													 */
/*************************************************************************/
void Blk_hex2bin( char *dst, const char *src, int size )
{
	/*f[^e̕\*/
	for( ; size > 0; size -= 2 )
	{
		*dst++ = hex2bin( src, sizeof(char) );
		src += 2;
	}
}

/********************************************************************/
/*	itoa A8̂												*/
/********************************************************************/
char *itoa8( char dest[], unsigned long value )
{
	dest[0] = (value < 10000000UL) ? '0' : (value / 10000000UL) + '0';
	value %= 10000000UL;
	dest[1] = (value < 1000000UL) ? '0' : (value / 1000000UL) + '0';
	value %= 1000000UL;
	dest[2] = (value < 100000UL) ? '0' : (value / 100000UL) + '0';
	value %= 100000UL;
	dest[3] = (value < 10000UL) ? '0' : (value / 10000UL) + '0';
	value %= 10000UL;
	dest[4] = (value < 1000UL) ? '0' : (value / 1000UL) + '0';
	value %= 1000UL;
	dest[5] = (value < 100UL) ? '0' : (value / 100UL) + '0';
	value %= 100UL;
	dest[6] = (value < 10UL) ? '0' : (value / 10UL) + '0';
	dest[7] = (value % 10UL) + '0';
	dest[8] = '\0';

	return dest;
}

/********************************************************************/
/*	itoa A6̂												*/
/********************************************************************/
char *itoa6( char dest[], int value )
{
	dest[0] = (value < 100000) ? '0' : (value / 100000) + '0';
	value %= 100000;
	dest[1] = (value < 10000) ? '0' : (value / 10000) + '0';
	value %= 10000;
	dest[2] = (value < 1000) ? '0' : (value / 1000) + '0';
	value %= 1000;
	dest[3] = (value < 100) ? '0' : (value / 100) + '0';
	value %= 100;
	dest[4] = (value < 10) ? '0' : (value / 10) + '0';
	dest[5] = (value % 10) + '0';
	dest[6] = '\0';

	return dest;
}

/********************************************************************/
/*	itoa A5̂												*/
/********************************************************************/
char *itoa5( char dest[], int value )
{
	dest[0] = (value < 10000) ? '0' : (value / 10000) + '0';
	value %= 10000;
	dest[1] = (value < 1000) ? '0' : (value / 1000) + '0';
	value %= 1000;
	dest[2] = (value < 100) ? '0' : (value / 100) + '0';
	value %= 100;
	dest[3] = (value < 10) ? '0' : (value / 10) + '0';
	dest[4] = (value % 10) + '0';
	dest[5] = '\0';

	return dest;
}

/********************************************************************/
/*	itoa A4̂												*/
/********************************************************************/
char *itoa4( char dest[], int value )
{
	dest[0] = (value < 1000) ? '0' : (value / 1000) + '0';
	value %= 1000;
	dest[1] = (value < 100) ? '0' : (value / 100) + '0';
	value %= 100;
	dest[2] = (value < 10) ? '0' : (value / 10) + '0';
	dest[3] = (value % 10) + '0';
	dest[4] = '\0';

	return dest;
}

/********************************************************************/
/*	itoa A3̂												*/
/********************************************************************/
char *itoa3( char dest[], int value )
{
	dest[0] = (value < 100) ? '0' : (value / 100) + '0';
	value %= 100;
	dest[1] = (value < 10) ? '0' : (value / 10) + '0';
	dest[2] = (value % 10) + '0';
	dest[3] = '\0';

	return dest;
}

/********************************************************************/
/*	Dump list														*/
/********************************************************************/
void dump( const void *src, int size )
{
  char *ptr,buf[16];
  int  i,j;
  VP   blk;

  /*L̎؂o*/
  blk = GetMemBlock( 128 );
  /*DUMP̕\*/
  for( i = 0; i < size; i += 16 )
  {
    sprintf( buf, "%08lX:", (unsigned long)src );
    strcpy( (char *)blk, buf );
    for( j = 0; j < 16; j++ )
    {
      if( j == 8 ) strcat( blk, " " );
      sprintf( buf, "%02X,", *((const unsigned char *)src + j) );
      strcat( (char *)blk, buf );
    }
    strcat( blk, " " );
    for( j = 0; j < 16; j++ )
    {
      if( j == 8 ) strcat( blk, " " );
      sprintf( buf, "%c", ( isprint(*((const char *)src + j)) ) ? *((const char *)src + j) : '.' );
      strcat( (char *)blk, buf );
    }
    strcat( (char *)blk, "\r\n" );
    SCI_Puts( SCI_1, (const char *)blk );
    src = (const void *)((char *)src + 16);
  }

  /*L̕ԋp*/
  RelMemBlock( blk );
}

/*************************************************************************/
/*	tyю̐`FbN									 */
/*	0AԈĂ(-1)ԂB								 */
/*************************************************************************/
int CheckDateAndTimeStrings( const char *str )
{
	int year,month,day,hour,minute,second;
	/*2008/04/01 12:34:56 */
	/*01234567890123456789*/
	enum DATE_POSITION
	{
		Y1000, Y100, Y10, Y1, SLA_1,
		M10, M1, SLA_2,
		D10, D1, SPA_1,
		H10, H1, COL_1,
		Mi10, Mi1, COL_2,
		S10, S1,
	};
	static const int the_days_of_month[] =
	{
		31,28,31,30,31,30,
		31,31,30,31,30,31,
	};

	/*`FbN*/
	if( isdigit( str[ Y10 ] ) == 0 ) return (-1);
	if( isdigit( str[ Y1 ] ) == 0 ) return (-1);
	if( isdigit( str[ M10 ] ) == 0 ) return (-1);
	if( isdigit( str[ M1 ] ) == 0 ) return (-1);
	if( isdigit( str[ D10 ] ) == 0 ) return (-1);
	if( isdigit( str[ D1 ] ) == 0 ) return (-1);
	if( isdigit( str[ H10 ] ) == 0 ) return (-1);
	if( isdigit( str[ H1 ] ) == 0 ) return (-1);
	if( isdigit( str[ Mi10 ] ) == 0 ) return (-1);
	if( isdigit( str[ Mi1 ] ) == 0 ) return (-1);
	if( isdigit( str[ S10 ] ) == 0 ) return (-1);
	if( isdigit( str[ S1 ] ) == 0 ) return (-1);

	/*ɓWJ*/
	year = ((str[ Y1000 ] & 0x0f) * 1000)  /*N*/
		 + ((str[ Y100 ] & 0x0f) * 100)
		 + ((str[ Y10 ] & 0x0f) * 10)
		 + ((str[ Y1 ] & 0x0f) * 1);

	/*̃`FbN*/
	month = ((str[ M10 ] & 0x0f) * 10)  /**/
		 + ((str[ M1 ] & 0x0f) * 1);
	if( month < 1 || month > 12 ) return (-1);

	/*̃`FbN*/
	day = ((str[ D10 ] & 0x0f) * 10)  /**/
		 + ((str[ D1 ] & 0x0f) * 1);
	if( month == 2 && (year % 4) == 0 )  /*܂2*/
	{
		if( day < 1 || day > 29 ) return (-1);
	}
	else
	{
		if( day < 1 || day > the_days_of_month[ month - 1 ] )
			return (-1);
	}

	/*̃`FbN*/
	hour = ((str[ H10 ] & 0x0f) * 10)  /**/
		 + ((str[ H1 ] & 0x0f) * 1);
	if( hour > 23 ) return (-1);

	/*̃`FbN*/
	minute = ((str[ Mi10 ] & 0x0f) * 10)  /**/
		 + ((str[ Mi1 ] & 0x0f) * 1);
	if( minute > 59 ) return (-1);

	/*b̃`FbN*/
	second = ((str[ S10 ] & 0x0f) * 10)  /*b*/
		 + ((str[ S1 ] & 0x0f) * 1);
	if( second > 59 ) return (-1);

	return 0;
}

/*************************************************************************/
/*	IPAhX̐`FbN									 */
/*	0AԈĂ(-1)ԂB								 */
/*************************************************************************/
int CheckIPAddressStrings( const char *str, unsigned char self_ip[] )
{
	int ip[ 4 ];
	enum IP_POSITION
	{
		A100, A10, A1, DOT_1,
		B100, B10, B1, DOT_2,
		C100, C10, C1, DOT_3,
		D100, D10, D1,
	};

	/*`FbN*/
	if( isdigit( str[ A100 ] ) == 0 ) return (-1);
	if( isdigit( str[ A10 ] ) == 0 ) return (-1);
	if( isdigit( str[ A1 ] ) == 0 ) return (-1);

	if( isdigit( str[ B100 ] ) == 0 ) return (-1);
	if( isdigit( str[ B10 ] ) == 0 ) return (-1);
	if( isdigit( str[ B1 ] ) == 0 ) return (-1);

	if( isdigit( str[ C100 ] ) == 0 ) return (-1);
	if( isdigit( str[ C10 ] ) == 0 ) return (-1);
	if( isdigit( str[ C1 ] ) == 0 ) return (-1);

	if( isdigit( str[ D100 ] ) == 0 ) return (-1);
	if( isdigit( str[ D10 ] ) == 0 ) return (-1);
	if( isdigit( str[ D1 ] ) == 0 ) return (-1);

	/*ɓWJ*/
	ip[0] = ((str[ A100 ] & 0x0f) * 100)
		 + ((str[ A10 ] & 0x0f) * 10)
		 + ((str[ A1 ] & 0x0f) * 1);

	ip[1] = ((str[ B100 ] & 0x0f) * 100)
		 + ((str[ B10 ] & 0x0f) * 10)
		 + ((str[ B1 ] & 0x0f) * 1);

	ip[2] = ((str[ C100 ] & 0x0f) * 100)
		 + ((str[ C10 ] & 0x0f) * 10)
		 + ((str[ C1 ] & 0x0f) * 1);

	ip[3] = ((str[ D100 ] & 0x0f) * 100)
		 + ((str[ D10 ] & 0x0f) * 10)
		 + ((str[ D1 ] & 0x0f) * 1);

	/*`FbN*/
	if( ip[0] > 255 ) return (-1);
	if( ip[1] > 255 ) return (-1);
	if( ip[2] > 255 ) return (-1);
	if( ip[3] > 255 ) return (-1);

	/*펞͈ɃRs[s*/
	self_ip[0] = (unsigned char)ip[0];
	self_ip[1] = (unsigned char)ip[1];
	self_ip[2] = (unsigned char)ip[2];
	self_ip[3] = (unsigned char)ip[3];

	return 0;
}

/*************************************************************************/
/*	|[gԍ̐`FbN									 */
/*	0AԈĂ(-1)ԂB								 */
/*************************************************************************/
int CheckPortNumberStrings( const char *str, unsigned short *port )
{
	long temp;
	enum PORT_POSITION
	{
		P10000, P1000, P100, P10, P1,
	};

	/*`FbN*/
	if( isdigit( str[ P10000 ] ) == 0 ) return (-1);
	if( isdigit( str[ P1000 ] ) == 0 ) return (-1);
	if( isdigit( str[ P100 ] ) == 0 ) return (-1);
	if( isdigit( str[ P10 ] ) == 0 ) return (-1);
	if( isdigit( str[ P1 ] ) == 0 ) return (-1);

	/*ɓWJ*/
	temp = ((str[ P10000 ] & 0x0f) * 10000)
		 + ((str[ P1000] & 0x0f) * 1000)
		 + ((str[ P100 ] & 0x0f) * 100)
		 + ((str[ P10 ] & 0x0f) * 10)
		 + ((str[ P1 ] & 0x0f) * 1);

	/*`FbN*/
	if( temp < 1 || temp > 65535 ) return (-1);

	*port = (unsigned short)temp;  /*肭sA|[gԍɃRs[*/

	return 0;
}

/*************************************************************************/
/*	񏈗Library													 */
/*	                                Copyright (C) 1998-2008 by hamayan	 */
/*************************************************************************/
