/********************************************************************/
/*	HOS-V4 (ITRON version4.0)										*/
/*	SCI֘A															*/
/*							Copyright (C) 1998-2002 by hamayan		*/
/*                          http://sourceforge.jp/projects/hos/     */
/********************************************************************/

#include	<stdio.h>
#include	<string.h>

#include	"h83052f.h"
#include	"itron.h"
#include	"kernel.h"
#include	"kernel_id.h"
#include	"comm.h"
#include	"akilan.h"

/*foCX\*/
struct TSerialHandle SCI[ 2 ];

/********************************************************************/
/*			Oobt@Ή^memcpy								*/
/*	d͓]As͓]An͓]TCY							*/
/*	p̓|C^Asz̓obt@TCY									*/
/********************************************************************/
static void Rmemcpy( char *d, const char *s, int n, int *p, int sz )
{
	int i;

	for(i = 0;i < n;i++)
	{
		d[ i ] = s[ *p ];		/*obt@̓Ǐo*/
		*p += 1;				/*݃|C^XV*/
		if( *p == sz ) *p = 0;	/*Ǎ݃|C^̊ۂ*/
	}
}

/********************************************************************/
/*	SCI													*/
/*	LN^ 8bitApeBAXgbvrbg 1bit ɐݒ	*/
/*	B															*/
/*	 comm.hɋLqĂ{[[gݒ肵܂B			*/
/********************************************************************/
void SCI_Init( int handle, unsigned char rate )
{
	volatile char	c;
	volatile int	count;
	
	/*SCIǗ\̂̉BʂɃAhX蓖ĂĂ邾Ȃ̂ŁASCI̊蓖ĂsĂ*/
	SCI[0].sci = (struct __SCI0_REG__ *)&SCI0;
	SCI[1].sci = (struct __SCI0_REG__ *)&SCI1;
	/*Mobt@̃|C^NA*/
	SCI[ handle ].ss.wptr = SCI[ handle ].ss.rptr = SCI[ handle ].sr.wptr = SCI[ handle ].sr.rptr = 0;
	/* SCI */
	SCI[ handle ].sci->SCR.BYTE = 0x00;			/*SCR0NA*/
	SCI[ handle ].sci->SMR.BYTE = 0x00;			/*8bitApeBASTOP1*/
	SCI[ handle ].sci->BRR = rate;				/*{[[g͈Ŏ擾*/
	/*\tg[vɂ鎞ԑ҂A猋\*/
	for( count = 1000; count > 0; count-- ){}
	SCI[ handle ].sci->SCR.BYTE = 0x70;			/*M荞݂gp*/
	c = SCI[ handle ].sci->SSR.BYTE;			/*_~[[h*/
	SCI[ handle ].sci->SSR.BYTE = 0x80;			/*G[tÕNA*/
}

/********************************************************************/
/*	SCIMobt@Mf[^ԐM								*/
/*	Mobt@̃|C^obt@ɎcĂbyteԂ		*/
/********************************************************************/
int RecByteSize( int handle )
{
	int		ret;

	ret = SCI[ handle ].sr.wptr;				/*݃|C^̒l擾*/
	if( ret < SCI[ handle ].sr.rptr )			/*Oobt@\Ă̂*/
		ret += SERIAL_BUFFER_SIZE;				/*݃|C^Ƀobt@TCYZ*/

	return ret - SCI[ handle ].sr.rptr;			/*c byteԂ*/
}

/********************************************************************/
/*	SCIM													*/
/*	̏͊݃nȟĂяo󂯂					*/
/*																	*/
/*	|C^ƓǍ|C^r݃|C^Ɍ1	*/
/*	ɓǍ݃|C^ƓlɂȂĂ܂Ă͏㏑Ă܂B*/
/*	͎̎Mobt@݂̂Ńobt@ɂ͏oȂ	*/
/********************************************************************/
static void SCI_Rec( int handle )
{
	int		w;
	char	c;

	c = SCI[ handle ].sci->RDR;					/*f[^̎荞*/
	if( SCI[ handle ].sci->SSR.BYTE & 0x38 ) SCI[ handle ].sci->SSR.BYTE &= 0x87;
	else SCI[ handle ].sci->SSR.BYTE &= 0xbf;	/*RDRFtÕNA*/
	w = SCI[ handle ].sr.wptr;					/*݃|C^̒l擾*/
	if( ++w == SERIAL_BUFFER_SIZE ) w = 0;	/*|C^i߁Aۂ߂s*/
	if( w != SCI[ handle ].sr.rptr )
	{
		SCI[ handle ].sr.buf[ SCI[ handle ].sr.wptr ] = c;
		SCI[ handle ].sr.wptr = w;
	}
}

/********************************************************************/
/*	SCIM												*/
/*	MɔB肠gpȂ				*/
/********************************************************************/
void SCI_TEI1( int handle )
{
	SCI[ handle ].sci->SSR.BYTE &= 0x7f;			/*TDREbit̃NA*/
}

/********************************************************************/
/*	SCIMobt@f[^擾									*/
/*	Mobt@wbytẽf[^Ԃ						*/
/*	handle̓`lԍAbuf͕ۑ̈Asz͎擾TCY			*/
/*	Ԃl͎ۂɎ擾łbyteTCYAAُ킪L鎞-1		*/
/********************************************************************/
int SCI_read( int handle, char *buf, int sz )
{
	int			size,*p;
	char		*s;

	size = RecByteSize( handle );	/*Mobt@̃f[^TCY߂*/
	if( !size ) return 0;			/*Mf[^0ԂďI*/
	if( size > sz ) size = sz;		/*Mf[^vȂszv擾*/
	if( handle == SCI_1 )
	{
		p = &SCI[ handle ].sr.rptr;	/*Oobt@̃|C^̃AhXݒ*/
		s = SCI[ handle ].sr.buf;	/*Oobt@̃AhXݒ*/
	}
	else return -1;
	Rmemcpy( buf, s, size, p, SERIAL_BUFFER_SIZE );	/*Oobt@Ήmemcpy*/

	return size;
}

/********************************************************************/
/*	SCIM|C^NA										*/
/*	handle̓`lԍAbuf͕ۑ̈Asz͎擾TCY			*/
/********************************************************************/
void SCI_Purge( int handle )
{
	SCI[ handle ].sr.wptr = SCI[ handle ].sr.rptr = 0;
}

/********************************************************************/
/*	SCIꕶM												*/
/*	handle̓`lԍ											*/
/*	߂l̓f[^-1ALΈꕶԂB				*/
/********************************************************************/
int  SCI_Getc( int handle )
{
	int			c;

	if( SCI[ handle ].sr.wptr == SCI[ handle ].sr.rptr ) return -1;	/* Mobt@ */
	/* FIFO1o */
	c = SCI[ handle ].sr.buf[ SCI[ handle ].sr.rptr++ ];
	/* |C^XV */
	if( SCI[ handle ].sr.rptr == SERIAL_BUFFER_SIZE ) SCI[ handle ].sr.rptr = 0;

	return c & 0x00ff;
}

/********************************************************************/
/*	M荞ݗp荞݃nh									*/
/*	CxgtOgpĊY̋NsB					*/
/********************************************************************/
void Int_SCI_Recv( VP_INT handle )
{
	/*M */
	SCI_Rec( handle );
}

/********************************************************************/
/*	SCIMG[											*/
/********************************************************************/
void SCI_Err( VP_INT handle )
{
	SCI[ handle ].sci->SSR.BYTE &= 0xcf;
}

/********************************************************************/
/*	SCI񑗐M												*/
/*	handle̓`lԍAstr͑M							*/
/*	ɏI0ԂAɏIȂ-1ԂB			*/
/********************************************************************/
int SCI_Puts( int handle, const char *str )
{
	int				len;
	ER				ercd;
	SCI_MSG_BLOCK	*smb;

	len = strlen( str );
	if( len > (256 - 64) ) return -1;	/*ɑf[^TCY̏𒴂Ă鎞*/
	
	while( len >= SCI_MSG_SIZE )
	{
		ercd = get_mpf( MPID_SCI, (VP)&smb );	/*Œ蒷ubN烁擾*/
		if( ercd != E_OK ) return -1;		/*ubN琳Ɏ擾łȂ*/

		smb->sz = SCI_MSG_SIZE;
		memcpy( smb->buf, str, SCI_MSG_SIZE );
		snd_mbx( MID_SCI, (T_MSG *)smb );
		str += SCI_MSG_SIZE;
		len -= SCI_MSG_SIZE;
	}
	if( len )
	{
		ercd = get_mpf( MPID_SCI, (VP)&smb );	/*Œ蒷ubN烁擾*/
		if( ercd != E_OK ) return -1;		/*ubN琳Ɏ擾łȂ*/

		smb->sz = len;
		memcpy( smb->buf, str, len );
		snd_mbx( MID_SCI, (T_MSG *)smb );
	}
	return 0;
}

/********************************************************************/
/*	SCIꕶM													*/
/********************************************************************/
void SCI_Putc( int handle, char c )
{
	while( !SCI[ handle ].sci->SSR.BIT.TDRE ){}		/*TDREbit𒲂ׂď݉\ɂȂ܂ő҂*/
	SCI[ handle ].sci->TDR = c;						/*f[^M*/
	SCI[ handle ].sci->SSR.BIT.TDRE = 0;			/*TDREbit̃NA*/
}

/********************************************************************/
/*	SCIMTASK														*/
/********************************************************************/
void SCI_Snd( VP_INT handle )
{
	char	*str,*limit;
	SCI_MSG_BLOCK	*smb;

	while( 1 )
	{
		/*N҂*/
		rcv_mbx( MID_SCI, (T_MSG **)&smb );
		str = smb->buf;
		limit = &smb->buf[smb->sz];
		while( str < limit )
		{
#if 0
			while( !SCI[ handle ].sci->SSR.BIT.TDRE ) dly_tsk( 10 );	/*TDREbit𒲂ׂď݉\ɂȂ܂ő҂*/
#else
			while( !SCI[ handle ].sci->SSR.BIT.TDRE ){}			/*TDREbit𒲂ׂď݉\ɂȂ܂ő҂*/
#endif
			SCI[ handle ].sci->TDR = *str++;					/*f[^M*/
			SCI[ handle ].sci->SSR.BIT.TDRE = 0;				/*TDREbit̃NA*/
		}
		rel_mpf( MPID_SCI, smb );
	}
}
