/* ------------------------------------------------------------------------ */
/*  Hyper Operating System V4  TvvO                           */
/*   OSp^C}                                                             */
/*                                                                          */
/*                                  Copyright (C) 1998-2002 by Project HOS  */
/*                                  http://sourceforge.jp/projects/hos/     */
/* ------------------------------------------------------------------------ */

#include	<stdio.h>
#include	<string.h>

#include	"h83068f.h"
#include	"itron.h"
#include	"kernel.h"
#include	"kernel_id.h"
#include	"ostimer.h"
#include	"itu.h"

/*GRAXVpϐ*/
unsigned short NewGRAValue;

/********************************************************************/
/*	VXe^C}[												*/
/********************************************************************/
/* OSp^C} */
void ostim_init(VP_INT TimeFactor)
{
	ITU.TSTR.BIT.STR0 = 0;			/*ITU0~*/
	ITU.TSNC.BIT.SYNC0 = 0;			/*ch0͓Ɨ*/
	ITU.TMDR.BIT.PWM0 = 0;			/*ch0͒ʏ퓮*/
	ITU0.TCR.BYTE = 0xa3;			/*1010 0011:RyA}b`ATCNTNA*/
									/*オGbWA/8NbN*/
	ITU0.GRA = TimeFactor;			/*RyA}b`A̒l*/
	ITU0.TIOR.BYTE = 0x88;			/*1000 1000:RyA}b`o͋֎~*/
	ITU.TISRA.BIT.IMIEA0 = 1;		/*RyA}b`AŊ*/
	ITU.TSTR.BIT.STR0 = 1;			/*ITU0X^[g*/
}

/* 荞݃nhTv */
void ostim_hdr(VP_INT exinf)		/* OS^C}pnh */
{
	ITU.TISRA.BIT.IMFA0 = 0;		/*ݏ̃NA*/
	isig_tim();						/* ^CeBbN̋ */
}

/********************************************************************/
/*	SNTPT[o[^C}[JE^[                        */
/*	ˑ                                                    */
/********************************************************************/
void SNTPSyncTimerCounterInit( void )
{
	ITU.TSTR.BIT.STR2 = 0;			/*ITU2~*/
	ITU.TSNC.BIT.SYNC2 = 0;			/*ch4͓Ɨ*/
	ITU.TMDR.BIT.PWM2 = 0;			/*ch4͒ʏ퓮*/
	ITU2.TCR.BYTE = 0xa3;			/*1010 0001:RyA}b`ATCNTNA*/
									/*オGbWA/8NbN*/
	ITU2.GRA = ((__CPU_CLOCK__ / 8 / 128) - 1);	/*RyA}b`A̒l*/
	NewGRAValue = ((__CPU_CLOCK__ / 8 / 128) - 1);	/*GRȀ*/
	ITU2.TIOR.BYTE = 0x88;			/*1000 1000:RyA}b`o͋֎~*/
	ITU.TISRA.BIT.IMIEA2 = 1;		/*RyA}b`AŊ*/
	ITU.TSTR.BIT.STR2 = 1;			/*ITU2X^[g*/
}

void SNTPSyncIndependentPart( void );

/********************************************************************/
/*	SNTPT[o[^C}[JE^[荞݃nh              */
/*	ˑ                                                    */
/********************************************************************/
void SNTPSyncTimerCounterInt( void )
{
	ITU.TISRA.BIT.IMFA2 = 0;		/*ݏ̃NA*/
	ITU2.GRA = NewGRAValue;			/*RyA}b`A̒lXV*/
	SNTPSyncIndependentPart();		/*ˑƗ̌ĂяoB*/
}

/********************************************************************/
/*	SNTPT[o[^C}[JE^[                          */
/*	ˑ                                                    */
/********************************************************************/
void SNTPSyncTimerCounterSet( unsigned short value )
{
/*	ITU.TSTR.BIT.STR2 = 0;*/	/*^C}[~*/
	ITU2.TCNT = value;
/*	ITU.TSTR.BIT.STR2 = 1;*/	/*^C}[ĊJ*/
}

/********************************************************************/
/*	SNTPT[o[^C}[JE^[ǂݏo                      */
/*	ˑ                                                    */
/********************************************************************/
volatile unsigned short SNTPSyncTimerCounterGet( void )
{
	return ITU2.TCNT;
}

/********************************************************************/
/*	SNTPT[o[^C}[JE^[                          */
/*	ˑ                                                    */
/*	0̎Ƀ^C}[~A1ōĊJB                      */
/********************************************************************/
void SNTPSyncTimerStartStop( int StartStop )
{
	ITU.TSTR.BIT.STR2 = StartStop;	/*ITU2~/ĊJ*/
}

/********************************************************************/
/*	I_^CvLED̐p										*/
/********************************************************************/
void DynamicScanLEDUpdateInit(VP_INT TimeFactor)
{
	ITU.TSTR.BIT.STR1 = 0;			/*ITU1~*/
	ITU.TSNC.BIT.SYNC1 = 0;			/*ch1͓Ɨ*/
	ITU.TMDR.BIT.PWM1 = 0;			/*ch1͒ʏ퓮*/
	ITU1.TCR.BYTE = 0xa3;			/*1010 0011:RyA}b`ATCNTNA*/
									/*オGbWA/8NbN*/
	ITU1.GRA = TimeFactor;			/*RyA}b`A̒l*/
	ITU1.TIOR.BYTE = 0x88;			/*1000 1000:RyA}b`o͋֎~*/
	ITU.TISRA.BIT.IMIEA1 = 1;		/*RyA}b`AŊ*/
	ITU.TSTR.BIT.STR1 = 1;			/*ITU1X^[g*/
}

/********************************************************************/
/*	ێĂϐ									*/
/********************************************************************/
#include	"ntp.h"

#define		TIME_SEG_A		0x40
#define		TIME_SEG_B		0x20
#define		TIME_SEG_C		0x08
#define		TIME_SEG_D		0x02
#define		TIME_SEG_E		0x01
#define		TIME_SEG_F		0x80
#define		TIME_SEG_G		0x04
#define		TIME_SEG_DOT	0x10

#define		TIME_ZERO		(TIME_SEG_A | TIME_SEG_B | TIME_SEG_C | TIME_SEG_D | TIME_SEG_E | TIME_SEG_F)
#define		TIME_ONE		(TIME_SEG_B | TIME_SEG_C)
#define		TIME_TWO		(TIME_SEG_A | TIME_SEG_B | TIME_SEG_D | TIME_SEG_E | TIME_SEG_G)
#define		TIME_THREE		(TIME_SEG_A | TIME_SEG_B | TIME_SEG_C | TIME_SEG_D | TIME_SEG_G)
#define		TIME_FOUR		(TIME_SEG_B | TIME_SEG_C | TIME_SEG_F | TIME_SEG_G)
#define		TIME_FIVE		(TIME_SEG_A | TIME_SEG_C | TIME_SEG_D | TIME_SEG_F | TIME_SEG_G)
#define		TIME_SIX		(TIME_SEG_A | TIME_SEG_C | TIME_SEG_D | TIME_SEG_E | TIME_SEG_F | TIME_SEG_G)
#define		TIME_SEVEN		(TIME_SEG_A | TIME_SEG_B | TIME_SEG_C)
#define		TIME_EIGHT		(TIME_SEG_A | TIME_SEG_B | TIME_SEG_C | TIME_SEG_D | TIME_SEG_E | TIME_SEG_F | TIME_SEG_G)
#define		TIME_NINE		(TIME_SEG_A | TIME_SEG_B | TIME_SEG_C | TIME_SEG_D | TIME_SEG_F | TIME_SEG_G)
#define		TIME_BLANK		(0x00)
#define		TIME_DOT		(0x10)

const unsigned char TimeSeg[] =
{
	TIME_ZERO, TIME_ONE, TIME_TWO, TIME_THREE,
	TIME_FOUR, TIME_FIVE, TIME_SIX, TIME_SEVEN,
	TIME_EIGHT, TIME_NINE, TIME_BLANK, TIME_BLANK,
	TIME_BLANK, TIME_BLANK, TIME_DOT, TIME_BLANK,
};

#define		DATE_SEG_A		0x01
#define		DATE_SEG_B		0x04
#define		DATE_SEG_C		0x10
#define		DATE_SEG_D		0x80
#define		DATE_SEG_E		0x20
#define		DATE_SEG_F		0x02
#define		DATE_SEG_G		0x08
#define		DATE_SEG_DOT	0x40

#define		DATE_ZERO	(DATE_SEG_A | DATE_SEG_B | DATE_SEG_C | DATE_SEG_D | DATE_SEG_E | DATE_SEG_F)
#define		DATE_ONE	(DATE_SEG_B | DATE_SEG_C)
#define		DATE_TWO	(DATE_SEG_A | DATE_SEG_B | DATE_SEG_D | DATE_SEG_E | DATE_SEG_G)
#define		DATE_THREE	(DATE_SEG_A | DATE_SEG_B | DATE_SEG_C | DATE_SEG_D | DATE_SEG_G)
#define		DATE_FOUR	(DATE_SEG_B | DATE_SEG_C | DATE_SEG_F | DATE_SEG_G)
#define		DATE_FIVE	(DATE_SEG_A | DATE_SEG_C | DATE_SEG_D | DATE_SEG_F | DATE_SEG_G)
#define		DATE_SIX	(DATE_SEG_A | DATE_SEG_C | DATE_SEG_D | DATE_SEG_E | DATE_SEG_F | DATE_SEG_G)
#define		DATE_SEVEN	(DATE_SEG_A | DATE_SEG_B | DATE_SEG_C)
#define		DATE_EIGHT	(DATE_SEG_A | DATE_SEG_B | DATE_SEG_C | DATE_SEG_D | DATE_SEG_E | DATE_SEG_F | DATE_SEG_G)
#define		DATE_NINE	(DATE_SEG_A | DATE_SEG_B | DATE_SEG_C | DATE_SEG_D | DATE_SEG_F | DATE_SEG_G)
#define		DATE_BLANK	(0x00)
#define		DATE_DOT	(0x40)


const unsigned char DateSeg[] =
{
	DATE_ZERO, DATE_ONE, DATE_TWO, DATE_THREE,
	DATE_FOUR, DATE_FIVE, DATE_SIX, DATE_SEVEN,
	DATE_EIGHT, DATE_NINE, DATE_BLANK, DATE_BLANK,
	DATE_BLANK, DATE_BLANK, DATE_DOT, DATE_BLANK,
};

/* 荞݃nhTv */
void DynamicScanLEDUpdate(VP_INT exinf)
{
	static int	row = 0;

	ITU.TISRA.BIT.IMFA1 = 0;		/*ݏ̃NA*/

	P4DR.BYTE = 0x00;
	PADR.BYTE = 0x00;
	/*̌*/
	P6DR.BIT.B1 = (row & 0x01) ? 1 : 0;	/*SEL0*/
	P6DR.BIT.B2 = (row & 0x02) ? 1 : 0;	/*SEL1*/
	P8DR.BIT.B0 = (row & 0x04) ? 1 : 0;	/*SEL2*/
	/*o*/
	P4DR.BYTE = TimeSeg[ DateTimeStringsFor7SegLed[ row + 8 ] & 0x0f ];
	PADR.BYTE = DateSeg[ DateTimeStringsFor7SegLed[ row ] & 0x0f ];

	row++;
	row &= 0x07;
}

/* ------------------------------------------------------------------------ */
/*  Copyright (C) 1998-2002 by Project HOS                                  */
/* ------------------------------------------------------------------------ */
