/****************************************************************************/
/*	HOS-V4 (ITRON version4.0)												*/
/*	RTL8019AS ʂ̒`sB											*/
/*                                  Copyright (C) 1998-2002 by hamayan		*/
/*                                  http://sourceforge.jp/projects/hos/     */
/****************************************************************************/
#include	<stdio.h>
#include	<string.h>

#undef DEBUG_MODE

#include	<itron.h>
#include	<kernel.h>
#include	"kernel_id.h"
#include	"system.h"
#include	"comm.h"
#include	"ip.h"

#if defined( __RTL8019AS_CONNECT_16BIT_BUS__ ) || defined( __NETCLOCK_3068_20__ ) || defined( __NETCLOCK3_3069_20__ )
#include	"rtl8019.h"			/*RTL8019ASŗL̒`*/
#elif defined( __AX88796B_16BIT_SIZE__ )
#include	"ax88796b.h"			/*RTL8019ASŗL̒`*/
#endif

/********************************************************/
/*	֐yѕϐ`									*/
/********************************************************/
static	unsigned char	myMAC[ 6 ];	/*MACAhX̕ۑp*/
static	int		RtlWrite( volatile union RTL8019AS *eth, unsigned short offset, const WD *wd );
static	int		PacketTransmit( volatile union RTL8019AS *eth, unsigned short );
static	void	swap( char *a,char *b );
static	volatile unsigned char	bnry( volatile union RTL8019AS *eth, unsigned char count );
static	volatile unsigned char	curr( volatile union RTL8019AS *eth, unsigned char count );
#ifdef		__RTL8019AS_CONNECT_16BIT_BUS__
static	void	BlockSwap( char *source, int size );
#endif

/********************************************************************/
/*			[gDMAgĎMf[^obt@]			*/
/*	rd͎Mf[^̊i[										*/
/*	펞0ԂB												*/
/*	]vf[^TCYMobt@TCYzĂ鎞G[	*/
/*	ԍԂďIB												*/
/********************************************************************/
int RtlRead( volatile union RTL8019AS *eth, RD *rd )
{
#if	defined( __RTL8019AS_CONNECT_16BIT_BUS__ )
	short	*ptr,*limit;
#elif	defined( __AX88796B_16BIT_SIZE__ )
	long	*ptr,*limit;
#else
	char	*ptr,*limit;
#endif

	if( rd->size > MTU_SIZE ) return PHISICAL_READ_SIZE_OVER;

	/*[gDMA܂ő҂*/
	while( eth->page0.read.cr & (REMOTEread | REMOTEwrite) ) dly_tsk( 5 );
	/*Page 0 ISR Register Initialize*/
	eth->page0.write.cr = PAGE0 | FORCEREMOTEstop | RTLstart;
	/*Page 0 Remote Buffer Address Set*/
	eth->page0.write.rsar0 = rd->add;	/*擾AhX̐ݒ*/
	eth->page0.write.rsar1 = rd->add >> 8;
	/*Page 0 Transmit Data Size Set*/
	eth->page0.write.rbcr0 = rd->size;
	eth->page0.write.rbcr1 = rd->size >> 8;
	/*Page 0 Remote Read Execute*/
	eth->page0.write.cr = PAGE0 | REMOTEread | RTLstart;
	/*f[^荞*/
#if	defined( __RTL8019AS_CONNECT_16BIT_BUS__ )
	limit = rd->buf + (((rd->size & 1) ? rd->size + 1 : rd->size) >> 1);
	ptr = (short *)rd->buf;
#elif	defined( __AX88796B_16BIT_SIZE__ )
	limit = rd->buf + ((rd->size - 1) / sizeof(long)) + 1;
	ptr = (long *)rd->buf;
#else
	limit = rd->buf + rd->size;
	ptr = (char *)rd->buf;
#endif
	while( ptr < limit ) *ptr++ = *eth->page0.read.remoteDMAport;

	/*Page 0 Clear Status*/
	eth->page0.write.cr = PAGE0 | FORCEREMOTEstop | RTLstart;

	return 0;
}

/********************************************************************/
/*			[gDMAgđMf[^RTLɏ			*/
/*	offset͏ݐAhXAwd͑Mf[^i[\	*/
/*	펞0ԂB												*/
/*	MTCYԈĐݒ肳Ăꍇ̓G[ԍԂ		*/
/*	IB														*/
/********************************************************************/
static int RtlWrite( volatile union RTL8019AS *eth, unsigned short offset, const WD *wd )
{
#if	defined( __RTL8019AS_CONNECT_16BIT_BUS__ )
	short	*ptr,*limit;
#elif	defined( __AX88796B_16BIT_SIZE__ )
	long	*ptr,*limit;
#else
	char	*ptr,*limit;
#endif

	/*]TCY̊mF*/
	if( wd->size > sizeof(ETHERNETFRAME) ) return PHISICAL_WRITE_SIZE_OVER;

	/*[gDMA܂ő҂*/
	while( eth->page0.read.cr & (REMOTEread | REMOTEwrite) ) dly_tsk(5);

	/*Page 0 ISR Register Initialize*/
	eth->page0.write.cr = PAGE0 | FORCEREMOTEstop | RTLstart;
	/*Page 0 Remote Buffer Address Set*/
	eth->page0.write.rsar0 = offset;
	eth->page0.write.rsar1 = *((char *)&offset);
	/*Page 0 Transmit Data Size Set*/
	eth->page0.write.rbcr0 = wd->size;
	eth->page0.write.rbcr1 = *((char *)&wd->size);
	/*Page 0 Remote Write Execute*/
	eth->page0.write.cr = PAGE0 | REMOTEwrite | RTLstart;

	/*f[^̈̃AhX擾*/
#if	defined( __RTL8019AS_CONNECT_16BIT_BUS__ )
	limit = (short *)wd->ef + (((wd->size & 1) ? wd->size + 1 : wd->size) >> 1);
	ptr =  (short *)wd->ef;
	BlockSwap( (char *)wd->ef, wd->size );
#elif	defined( __AX88796B_16BIT_SIZE__ )
	limit = (long *)wd->ef + ((wd->size - 1) / sizeof(long)) + 1;
	ptr =  (long *)wd->ef;
#else
	limit = (char *)wd->ef + wd->size;
	ptr =  (char *)wd->ef;
#endif
	while( ptr < limit ) *eth->page0.write.remoteDMAport = *ptr++;

	/*Page 0 Wait for DMA Transmitting*/
	eth->page0.write.cr = PAGE0 | FORCEREMOTEstop | RTLstart;
	/*CxgtOgDMA]҂*/
	if( twai_flg( FID_RTLINTSND, RTL_ISR_RDC, TWF_ANDW, NULL, 10 ) == E_OK )
		clr_flg( FID_RTLINTSND, ~RTL_ISR_RDC );
	else
		eth->page0.write.isr = RDC;

	/*Page 0 Clear Status*/
	return PacketTransmit( eth, wd->size );
}

/********************************************************************/
/*					MR}h̔s								*/
/*	size͑MTCY											*/
/*	ɑM0											*/
/*	ُ펞̓G[ԍԂB										*/
/********************************************************************/
static int PacketTransmit( volatile union RTL8019AS *eth, unsigned short size )
{
	FLGPTN			p_flgptn;

	/*My[WX^[gWX^ɐ擪AhX*/
	eth->page0.write.cr &= 0x3b;	/*00111011:PAGE0TXPbit̂݃NA*/
	/*MoCgJEgWX^ɑMbyte*/
	eth->page0.write.tbcr0 = size;
	eth->page0.write.tbcr1 = size >> 8;
	/*MJnR}hs*/
/*	eth->page0.write.cr = PAGE0 | PACKETsend | TXPstart | RTLstart;*/
	eth->page0.write.isr = 0x0a;			/*M֘ÃXe[^XNA*/
	eth->page0.write.cr |= TXPstart;		/*pPbgMR}h̔s*/
	if( twai_flg( FID_RTLINTSND, RTL_ISR_PTX | RTL_ISR_TXE, TWF_ORW, &p_flgptn, 10 ) == E_OK )
	{
		/*CxgtOĒu*/
		clr_flg( FID_RTLINTSND, ~(RTL_ISR_TXE | RTL_ISR_PTX) );
		if( p_flgptn & RTL_ISR_TXE ) return PACKETTRANSMIT_TX_ERROR;
		else return 0;
	}

	/*FLAG𐳏ɎMłȂ*/
	eth->page0.write.isr = TXE | PTX;
	return PACKETTRANSMIT_TIME_OUT;
}

/********************************************************************/
/*			RTLM												*/
/*	ʑwĂяoB͑Mf[^ւ̃|C^			*/
/*	߂l͐0AsŃG[ԍԂB					*/
/*	݂́AMp̃^XN炵Ă΂Ȃ̂ŁAZ}tH𗘗p	*/
/*	ȂB														*/
/********************************************************************/
int sndRTL( volatile union RTL8019AS *eth, const WD* wd )
{
	return RtlWrite( eth, SNDBUFFERTOP, wd );
}

/********************************************************************/
/*			M												*/
/********************************************************************/
void RtlSendIvent( volatile union RTL8019AS *eth )
{
	IP_RECORD		*ipr;
	WD				wd;

	/*vZXe[uɓo^Bۂ̏AobNOEhT[rXȂ̂ŏI͂Ȃ*/
	RegistProcessTable( _BACK_GROUND_, FALSE  );
	while( 1 )
	{
		/*[{bNXApPbg[߂ꂽbZ[WM҂*/
		rcv_mbx( MID_ETH0SND, (T_MSG **)&ipr );
		wd.size = ipr->sz;					/*]TCYw*/
		wd.ef = (ETHERNETFRAME *)ipr->data;	/*f[^obt@̈w*/
		sndRTL( eth, &wd );						/*RTLM*/
		RelMemBlock( ipr );					/*v[̊J*/
	}
	/*vZXe[u폜*/
	RelocateProcessTable();
}

/********************************************************************/
/*			M												*/
/********************************************************************/
void RtlRecIvent( volatile union RTL8019AS *eth )
{
	int				i;
	volatile unsigned char	bn,cu;
	RD				rd;
	KANRI			kanri;
	IP_RECORD		*ipr;
#ifdef DEBUG_MODE
	char	buf[ 80 ];
#endif

	/*vZXe[uւ̓o^*/
	RegistProcessTable( _BACK_GROUND_, FALSE  );
	while( 1 )
	{
		/*荞݃Cxg҂*/
		wai_flg( FID_RTLINT, RTL_ISR_PRX, TWF_ANDW, NULL );
		clr_flg( FID_RTLINT, ~RTL_ISR_PRX );
		/*[vȂAobt@̑SẴpPbg*/
		for( i = 0; i < INT_NEST_LIMIT; i++ )
		{
			bn = bnry( eth, 0 );					/*݂BNRYWX^̓e擾*/
			cu = curr( eth, 0 );					/*݂CURRWX^̓e擾*/
			if( bn == cu ) break;					/*ǂݏo[v𔲂*/
			/*sȒl擾́A~߂*/
			if( bn < RECSTARTPAGE || bn >= RECENDPAGE )
			{
				DebugPrintPara2( "curr = %d bnry = %d\r\n", cu, bn );
				bnry( eth, cu );
				break;
			}
			/*Ǘ̓ǂݏo*/
			rd.add	= bn * 0x100;						/*Mobt@̊Jnʒuw*/
			rd.size	= sizeof(KANRI);					/*Ǘ̓]TCYw*/
#ifdef		__RTL8019AS_CONNECT_16BIT_BUS__
			rd.buf = (short *)&kanri;					/*f[^̊i[w*/
#else
			rd.buf = (char *)&kanri;					/*f[^̊i[w*/
#endif

			RtlRead( eth, &rd );						/*Ǘǂݏo*/
#ifndef		__RTL8019AS_CONNECT_16BIT_BUS__
			swap( (char *)&kanri.PacketSize.b[0], (char *)&kanri.PacketSize.b[1] );	/*GfBA̕ϊ*/
#endif
			kanri.PacketSize.sz -= 4;					/*Ǘ񕪂Z*/
			/*MXe[^X̌*/
			if( kanri.ReceiveStatus & PRX )				/*G[Ȃ荞ގo*/
			{
				/*̎MpPbgAhX̌*/
				if( kanri.NextPacket < RECSTARTPAGE || kanri.NextPacket >= RECENDPAGE )
				{
/*					DebugPrintPara1( "NextPacket = %d Illegal Size\r\n", kanri.NextPacket );*/
					/*MɁÃG[́AXe[^X̍XVxĂ\LB炵B*/
					i--;
					continue;
				}
				/*MpPbgTCYُȎATCY\*/
				if( kanri.PacketSize.sz > MTU_SIZE )
				{
/*					DebugPrintPara2( "Rcv Packet Size = %d bnry = %d\r\n", kanri.PacketSize.sz, kanri.NextPacket );*/
					/*MɁÃG[́AXe[^X̍XVxĂ\LB炵B*/
					i--;
					continue;
				}
				/*펞̓pPbg捞*/
				rd.add = bn * 0x100 + sizeof(KANRI);	/*ǂݏow*/
				rd.size = kanri.PacketSize.sz;			/*M̐ݒ*/
				/*MTCYŒ蒷v[擾*/
#ifndef	__INDIVISUAL_MPF__
				ipr = (IP_RECORD *)ETH0RcvGetMemBlock( kanri.PacketSize.sz + IP_RECORD_HEADER_SIZE );
#else
				get_mpf( MPID_ETH0_RCV_LARGE, (VP)ipr );
#endif

#ifdef		__RTL8019AS_CONNECT_16BIT_BUS__
				rd.buf = (short *)ipr->data;			/*荞ݐAhXw*/
#else
				rd.buf = (char *)ipr->data;				/*荞ݐAhXw*/
#endif
				if( RtlRead( eth, &rd ) != 0 )			/*f[^̓ǂݏo*/
				{
					DebugPrint( "RTLRcv RelMem Error\r\n" );
#ifndef	__INDIVISUAL_MPF__
					RelMemBlock( ipr );					/*v[̊J*/
#else
					rel_mpf( MPID_ETH0_RCV_LARGE, (VP)ipr );
#endif
					break;
				}

#ifdef		__RTL8019AS_CONNECT_16BIT_BUS__
				BlockSwap( (char *)rd.buf, rd.size );
#endif

				bnry( eth, kanri.NextPacket );			/*BNRYWX^̍XV*/
				ipr->handle = ETH0;						/*foCXnh*/
				ipr->sz = kanri.PacketSize.sz;			/*f[^TCY*/
				/*LINKwɓ]*/
				snd_mbx( MID_ETH0RCV, (T_MSG *)ipr );
			}
			else										/*炩̃G[L*/
			{
#if 1
				if( kanri.ReceiveStatus & 0x02 )		/*CRCG[*/
				{
					DebugPrint("Recieve Packet CRC ERROR\r\n");
					break;
				}
				if( kanri.ReceiveStatus & 0x04 )		/*FAEG[*/
				{
					DebugPrint("Recieve Packet FAE ERROR\r\n");
					break;
				}
				if( kanri.ReceiveStatus & 0x08 )		/*FIFO OVER RUNG[*/
				{
					DebugPrint("Recieve Packet FIFO OVER RUN ERROR\r\n");
					break;
				}
				if( kanri.ReceiveStatus & 0x10 )		/*pPbgG[*/
				{
					DebugPrint("Recieve Packet MPA ERROR\r\n");
					break;
				}
#endif
				i--;	/*G[͖ǁAXe[^X̍XVĂȂ*/
			}
		}
		/*̏I*/
	}

	RelocateProcessTable();
	ext_tsk();						/*TASK̏I*/
}

/********************************************************************/
/*			OVER WRITEG[									*/
/*	DP83902̃}jAǂތOVER WRITEG[̓\t	*/
/*	gRESETsɂȂĂB̃\tgRESET̋@\͒ǉB	*/
/********************************************************************/
void RtlOverWrite( volatile union RTL8019AS *eth )
{
	int				i,Resend;
	volatile unsigned char	bn,cu,temp;
	KANRI			kanri;
	RD				rd;
	IP_RECORD		*ipr;

	RegistProcessTable( _BACK_GROUND_, FALSE );

	while( 1 )
	{
		/*CxgtO҂҂*/
		wai_flg( FID_RTLINTOVW, RTL_ISR_OVW, TWF_ANDW, NULL );
		clr_flg( FID_RTLINTOVW, ~RTL_ISR_OVW );

#ifdef DEBUG_MODE
		SCI_Putc( SCI_1, 'o' );
#endif
		/*TXPbit̒lۑ*/
		temp = eth->page0.read.cr;
		/*STOPR}h̔s*/
#if 0	/*ŃTXyhƁA肭sȂHH*/
		sus_tsk( TID_ETH0_SND );	/*ETH0̑M^XNTXyh*/
#endif
		eth->page0.write.cr = PAGE0 | FORCEREMOTEstop | RTLstop;
		/*1.6msȏ̑҂*/
		dis_dsp();				/*fBXpb`̋֎~*/
		dly_tsk( 2 );			/**/
		ena_dsp();				/*fBXpb`̋*/
		/*RBCR̃NA*/
		eth->page0.write.rbcr0 = 0x00;
		eth->page0.write.rbcr1 = 0x00;
		/*TXP̒l0̎ResendtO0NA*/
		if( temp & TXPstart )
		{
			/*݃Xe[^XWX^PTX܂TXE𒲂ׂĂǂ炩1ȂResend0*/
			/*łȂResend0NA*/
			if( eth->page0.read.isr & (PTX | TXE) ) Resend = FALSE;
			else Resend = TRUE;
		}
		else Resend = FALSE;
		/*[vobN[hɂ*/
#ifdef		__RTL8019AS_CONNECT_16BIT_BUS__
		eth->page0.write.dcr = 0x00 | FT8byte | ARoff | LPBKon | LAS16 | BIGendian | WTS16;
#else
		eth->page0.write.dcr = 0x80 | FT8byte | ARoff | LPBKon | LAS16 | LITTLEendian | WTS8;
#endif
		eth->page0.write.tcr = 0xe0 | OFSToff | ATDoff | LBInternal | CRCon;
		/*X^[g[hɂ*/
		eth->page0.write.cr = PAGE0 | FORCEREMOTEstop | RTLstart;
		/*MOobt@pPbg菜*/
		for( i = 0; i < INT_NEST_LIMIT; i++ )
		{
			bn = bnry( eth, 0 );	/*݂BNRYWX^̓e擾*/
			cu = curr( eth, 0 );	/*݂CURRWX^̓e擾*/

			if( bn == cu ) break;	/*ǂݏo[v𔲂*/

			if( bn < RECSTARTPAGE || bn >= RECENDPAGE )
			{
				bnry( eth, cu );
				break;
			}
			/*Ǘ̓ǂݏo*/
			rd.add	= bn * 0x100;						/*Mobt@̊Jnʒuw*/
			rd.size	= sizeof(KANRI);					/*Ǘ̓]TCYw*/
#ifdef		__RTL8019AS_CONNECT_16BIT_BUS__
			rd.buf = (short *)&kanri;					/*f[^̊i[w*/
#else
			rd.buf = (char *)&kanri;					/*f[^̊i[w*/
#endif
			RtlRead( eth, &rd );						/*Ǘǂݏo*/
#ifndef		__RTL8019AS_CONNECT_16BIT_BUS__
			swap( (char *)&kanri.PacketSize.b[0], (char *)&kanri.PacketSize.b[1] );	/*GfBA̕ϊ*/
#endif
			kanri.PacketSize.sz -= 4;					/*Ǘ񕪂Z*/
			/*MXe[^X̌*/
			if( kanri.ReceiveStatus & PRX )				/*G[Ȃ荞ގo*/
			{
				/*MpPbgTCYُȎATCY\*/
				if( kanri.PacketSize.sz > MTU_SIZE )
				{
					bnry( eth, cu );
					continue;
				}
				/*펞̓pPbg捞*/
				rd.add = bn * 0x100 + sizeof(KANRI);	/*ǂݏow*/
				rd.size = kanri.PacketSize.sz;			/*M̐ݒ*/
				/*Œ蒷v[擾*/
#ifndef	__INDIVISUAL_MPF__
				ipr = (IP_RECORD *)ETH0RcvGetMemBlock( kanri.PacketSize.sz + IP_RECORD_HEADER_SIZE );
#else
				get_mpf( MPID_ETH0_RCV_LARGE, (VP)ipr );
#endif



#ifdef		__RTL8019AS_CONNECT_16BIT_BUS__
				rd.buf = (short *)ipr->data;			/*荞ݐAhXw*/
#else
				rd.buf = (char *)ipr->data;				/*荞ݐAhXw*/
#endif
				if( RtlRead( eth, &rd ) != 0 )			/*f[^̓ǂݏo*/
				{
#ifndef	__INDIVISUAL_MPF__
					RelMemBlock( ipr );					/*v[̊J*/
#else
					rel_mpf( MPID_ETH0_RCV_LARGE, (VP)ipr );
#endif
					break;
				}

#ifdef		__RTL8019AS_CONNECT_16BIT_BUS__
				BlockSwap( (char *)rd.buf, rd.size );
#endif

				bnry( eth, kanri.NextPacket );		/*BNRYWX^̍XV*/
				ipr->handle = ETH0;					/*foCXnh*/
				ipr->sz = kanri.PacketSize.sz;		/*f[^TCY*/
				/*LINKwɓ]*/
				snd_mbx( MID_ETH0RCV, (T_MSG *)ipr );
			}
			else		/*ɃpPbgMłȂ*/
				bnry( eth, kanri.NextPacket );		/*BNRYWX^̍XV*/
		}
		/*[vobN[hʏ퓮샂[hɉ*/
#ifdef		__RTL8019AS_CONNECT_16BIT_BUS__
		eth->page0.write.dcr = 0x00 | FT8byte | ARoff | LPBKoff | LAS16 | BIGendian | WTS16;
#else
		eth->page0.write.dcr = 0x80 | FT8byte | ARoff | LPBKoff | LAS16 | LITTLEendian | WTS8;
#endif
		eth->page0.write.tcr = 0xe0 | OFSToff | ATDoff | LBNormal | CRCon;
		/*ResendtOĂȂ瑗MR}h̍Ĕs*/
		if( Resend == TRUE ) eth->page0.write.cr = PAGE0 | FORCEREMOTEstop | TXPstart | RTLstart;
#if 0	/*ŃTXyhƁA肭sȂHH*/
		rsm_tsk( TID_ETH0_SND );	/*ETH0̑M^XNTXyh*/
#endif
		/*̏I*/
	}
	RelocateProcessTable();
	ext_tsk();
}

/********************************************************************/
/*			swap֐												*/
/*	ab̓eւB									*/
/********************************************************************/
static void swap( char *a, char *b )
{
	char	temp;

	temp = *a;*a = *b;*b = temp;
}

/********************************************************************/
/*			bnry̎擾yѐݒ										*/
/*	count0̎͌ݒl̂ݕԂAȊOBNRYWX^ݒ	*/
/********************************************************************/
static volatile unsigned char bnry( volatile union RTL8019AS *eth, unsigned char count )
{
	volatile unsigned char	bn;

#ifdef DEBUG_MODE
	char		buf[ 64 ];

	if( count != 0 && (count < RECSTARTPAGE || count >= RECENDPAGE) )
		DebugPrintPara1( "BNRY ILLEGAL SIZE =%02x\r\n",count );
#endif

	if( count >= RECSTARTPAGE ) eth->page0.write.bnry = count;
	bn = eth->page0.read.bnry;
	return bn;
}

/********************************************************************/
/*			curr̎擾yѐݒ										*/
/*	count0̎͌ݒn̂ݕԂAȊOCURRWX^ݒ	*/
/********************************************************************/
static volatile unsigned char curr( volatile union RTL8019AS *eth, unsigned char count )
{
	volatile unsigned char	cu,temp;

	/*݂ƃfBXpb`֎~*/
	loc_cpu();
	/*݂PAGEWX^ێ*/
	temp = eth->page0.read.cr;
	/*PAGE1ɐݒ*/
	eth->page0.write.cr &= 0x3f;
	eth->page0.write.cr |= PAGE1;
	if( count >= RECSTARTPAGE ) eth->page1.write.curr = count;
	cu = eth->page1.read.curr;
	/*PAGEWX^߂*/
	eth->page0.write.cr = temp;
	/*݂ƃfBXpb`*/
	unl_cpu();

	return cu;
}

/************************************************************************/
/*			RTLMACAhX擾									*/
/************************************************************************/
unsigned char	*GetRtlMac( void )
{
	return myMAC;
}

/************************************************************************/
/*					ETHERNET荞ݏ								*/
/************************************************************************/
void ETH0InterruptOperation( volatile union RTL8019AS *eth )
{
#ifdef		__RTL8019AS_CONNECT_16BIT_BUS__
	volatile short	isr,temp;
#else
	volatile char	isr,temp;
#endif

	/*݂PAGEWX^ێ*/
	temp = eth->page0.read.cr;
	/*PAGE0ɐݒ*/
	eth->page0.write.cr &= 0x3f;
	/*MXe[^X̊mF*/
	isr = eth->page0.read.isr;
	eth->page0.write.isr = isr;				/*Xe[^XNA*/
	/*PAGEWX^߂*/
	eth->page0.write.cr = temp;
	/*݂ISRCxgƂĒʐM*/
	if( isr & (RTL_ISR_RDC | RTL_ISR_TXE | RTL_ISR_PTX) )
		iset_flg( FID_RTLINTSND , isr );	/*CxgFLAG̔s*/
	if( isr & RTL_ISR_PRX )
		iset_flg( FID_RTLINT , isr );		/*CxgFLAG̔s*/
	if( isr & RTL_ISR_OVW )
		iset_flg( FID_RTLINTOVW , isr );	/*OVER WRITECxg͕ʃCxgōs*/
}

/************************************************************************/
/*	Block Swap															*/
/************************************************************************/
#ifdef		__RTL8019AS_CONNECT_16BIT_BUS__
static void BlockSwap( char *source, int size )
{
	char	temp,*ptr,*limit;

	ptr = source;
	limit = &source[ size ];

	while( ptr < limit )
	{
		temp = *(ptr + 1);
		*(ptr + 1) = *ptr;
		*ptr = temp;
		ptr += 2;
	}
}
#endif	

/************************************************************************/
/*	Cntr2 Counter̓ǂݏo												*/
/*	Ԃl͕16AʂǂݏolAʂO̒l		*/
/************************************************************************/
unsigned short Cntr2Read( volatile union RTL8019AS *eth )
{
	volatile unsigned char	temp,new;
	static unsigned char old = 0;

	/*݂ƃfBXpb`֎~*/
	loc_cpu();
	/*݂PAGEWX^ێ*/
	temp = eth->page0.read.cr;
	/*PAGE0ɐݒ*/
	eth->page0.write.cr &= 0x3f;
	new = eth->page0.read.cntr2;
	/*PAGEWX^߂*/
	eth->page0.write.cr = temp;
	/*݂ƃfBXpb`*/
	unl_cpu();

	return (new << 8) | old;
}
