/* ------------------------------------------------------------------------ */
/*  Hyper Operating System V4 ]vO								*/
/*  DHCP֘A̒`                                                          */
/*                                  Copyright (C) 1998-2002 by hamayan		*/
/*                                  http://sourceforge.jp/projects/hos/     */
/* ------------------------------------------------------------------------ */
#define	DHCP_SERVER		67		/*DHCP SERVER*/
#define	DHCP_CLIENT		68		/*DHCP CLIENT*/

/********************************************************/
/*	DHCPpt[̍\								*/
/********************************************************/
typedef struct
{
	char		op;			/*IyR[h*/
	char		htype;		/*n[hEGA^Cv*/
	char		hlen;		/*n[hEGAAhX*/
	char		hops;		/*zbv*/

	unsigned long	xid;	/*gUNVhc*/
	unsigned short	secs;	/*b*/
	short		flags;		/*gp(0Œ)*/

	unsigned long	ciaddr;		/*NCAghoAhX*/
	unsigned long	yiaddr;		/*[U[hoAhX*/
	unsigned long	siaddr;		/*T[o[hoAhX*/
	unsigned long	giaddr;		/*Q[gEGChoAhX*/

	char		chaddr[16];	/*NCAgn[hEGAAhX*/
	char		sname[64];	/*T[o[zXg*/
	char		file[128];	/*Nt@C*/
	char		options[64 + 4];	/*͉ϒ + matsui55̃oO񍐑Ή*/
} DHCP;

/********************************************************/
/*	DHCPpt[̍\								*/
/********************************************************/
typedef struct
{
	unsigned long	lease_ip;			/*ݏoꂽA[U[hoAhX*/
	unsigned long	dhcp_server_ip;		/*DHCPT[o[AhX*/
	unsigned long	sub_net_mask;		/*Tulbg}XN*/
	unsigned long	domain_name_ip;		/*hCl[AhX*/
	unsigned long	gateway;			/*Q[gEGCAhX*/

	unsigned long	renew_time_value;	/*XV*/
	unsigned long	rebinding_time_value;	/*oCh*/
	unsigned long	lease_time;			/*ݏoL*/
} DHCP_NETWORK_INFO;

/********************************************************/
/*	x_[̈̒`								*/
/********************************************************/
#define	MAGIC_CODE			{99,130,83,99}

#define	DHCP_TAG_PAD				0
#define	DHCP_TAG_SUBNET_MASK		1
#define	DHCP_TAG_TIME_OFFSET		2
#define	DHCP_TAG_ROUTER				3
#define	DHCP_TAG_TIME_SERVER		4
#define	DHCP_TAG_NAME_SERVER		5
#define	DHCP_TAG_DOMAIN_NAME_SERVER	6
#define	DHCP_TAG_LOG_SERVER			7
#define	DHCP_TAG_QUOTE_SERVER		8
#define	DHCP_TAG_LPR_SERVER			9
#define	DHCP_TAG_IMPRESS_SERVER		10
#define	DHCP_TAG_RESOURCE_LOCATION_SERVER	11
#define	DHCP_TAG_HOST_NAME			12
#define	DHCP_TAG_BOOT_FILE_SIZE		13
#define	DHCP_TAG_MERIT_DUMP_FILE	14
#define	DHCP_TAG_DOMAIN_NAME		15
#define	DHCP_TAG_SWAP_SERVER		16
#define	DHCP_TAG_ROOT_PATH			17
#define	DHCP_TAG_EXTENSIONS_PATH	18
#define	DHCP_TAG_IP_FORWARDING_ENABLE_DISABLE	19
#define	DHCP_TAG_NON_LOCAL_SOURCE_ROUTING_ENABLE_DISABLE	20
#define	DHCP_TAG_POLICY_FILTER		21
#define	DHCP_TAG_MAXIMUM_DATAGRAM_REASSEMBLY_SIZE	22
#define	DHCP_TAG_DEFAULT_IP_TIME_TO_LIVE	23
#define	DHCP_TAG_PATH_MTU_AGING_TIMEOUT	24
#define	DHCP_TAG_PATH_MTU_PLATEAU_TABLE	25
#define	DHCP_TAG_INTERFACE_MTU		26
#define	DHCP_TAG_ALL_SUBNETS_ARE_LOCAL	27
#define	DHCP_TAG_BROADCAST_ADDRESS	28
#define	DHCP_TAG_PERFORM_MASK_DISCOVERY	29

#define	DHCP_TAG_DHCP_REQUEST_IP_ADDRESS	50
#define	DHCP_TAG_DHCP_IP_ADDRESS_LEASE_TIME	51
#define	DHCP_TAG_DHCP_MESSAGE_TYPE	53
#define	DHCP_TAG_DHCP_SERVER_ID		54
#define	DHCP_TAG_DHCP_PARAMETER_REQUEST_LIST	55
#define	DHCP_TAG_DHCP_RENEW_TIME_VALUE	58
#define	DHCP_TAG_DHCP_REBINDING_TIME_VALUE	59
#define	DHCP_TAG_DHCP_CLIENT_ID		61
#define	DHCP_TAG_DHCP_PAD			251

#define	DHCP_DISCOVER		0x01
#define	DHCP_OFFER			0x02
#define	DHCP_REQUEST		0x03
#define	DHCP_DECLINE		0x04
#define	DHCP_PACK			0x05
#define	DHCP_PNAK			0x06
#define	DHCP_RELEASE		0x07
#define	DHCP_INFRM			0x08

int UdpDhcpClient( int handle, DHCP_NETWORK_INFO *dnf, int mode );
int	RequesetDHCP( int handle, DHCP_NETWORK_INFO *dnf );
int	UpdateDHCP( int handle, DHCP_NETWORK_INFO *dnf );

