/* ------------------------------------------------------------------------ */
/*  Hyper Operating System V4 ]vO                                */
/*  IP֘A̒`                                                            */
/*                                  Copyright (C) 1998-2002 by hamayan      */
/*                                  http://sourceforge.jp/projects/hos/     */
/* ------------------------------------------------------------------------ */

#define IP_COPY(a,b)     memcpy( (char *)a, (char *)b, LENGTHIPV4 )
#define IP_COMPAER(a,b)  ( memcmp(a, b, LENGTHIPV4 ) )

/*TYPE FIELD*/
#define TYPEIP        0x0800
#define TYPEARP       0x0806
#define TYPERARP      0x8035
#define TYPEETHERNET  0x0001
#define TYPEIEEE      0x0006
#define TYPEDOD       0x0800

#define TYPEICMP      1
#define TYPETCP       6
#define TYPEUDP       17

/*f[^ FIELD*/
#define LENGTHMAC     6    /*MAC ADDRESS*/
#define LENGTHIPV4    4    /*IPV4ɂAhX*/
#define LENGTHIPV6    8    /*IPV6ɂAhX*/
#define IPVERSION     4    /*IP̃o[WԍARS*/

#define  TTL          128    /*őHOP*/

#define PACKETSIZE     1536
#define USER_AREA_SIZE 1500

/*foCXnh`*/
#define L0          0    /*local host*/
#define ETH0        1    /*ETH0:݂RTL8019AS*/
#define ARC0        2    /*ARC0*/

/********************************************************/
/*  epPbg HEADER\                             */
/********************************************************/
typedef struct
{
  unsigned short ident; /*ʎq*/
  unsigned short sequ;  /*V[PXԍ*/
} PING_HEAD;

typedef struct
{
  unsigned char type;   /*^Cv*/
  unsigned char code;   /*R[h*/
  unsigned short checksum; /*`FbNT*/
} ICMP_HEAD;

typedef struct
{
  unsigned short sport;    /*M|[gԍ*/
  unsigned short dport;    /*M|[gԍ*/
  unsigned short length;   /*UDPf[^*/
  unsigned short checksum; /*`FbNT*/
} UDP_HEAD;

typedef struct
{
  unsigned short sport;  /*M|[gԍ*/
  unsigned short dport;  /*M|[gԍ*/
  struct
  {
    unsigned short  H;    /*V[PXԍ*/
    unsigned short  L;    /*V[PXԍ*/
  } SequNum;
  struct
  {
    unsigned short  H;    /*mFԍԍ*/
    unsigned short  L;    /*mFԍԍ*/
  } AckNum;
  unsigned short control;     /*wb_[ƃtO*/
  unsigned short WindowSize;  /*EChETCY*/
  unsigned short checksum;    /*`FbNT*/
  unsigned short Uptr;        /*ً}|C^*/
/*  char    option[ 4 ];  */  /*ϒ(0`44byte)̃f[^鎖L̂̕dataɑ*/
} TCP_HEAD;

/********************************************************/
/*  IP headpPbg\                               */
/********************************************************/
typedef struct
{
  struct
  {
    unsigned char  ver   :4; /*o[W*/
    unsigned char  length:4; /*f[^ ۂ4{*/
  } top;                     /*ԍŏ1char*/
  unsigned char  tos;        /*TOS*/
  unsigned short  length;    /*Sf[^Awb_[܂*/
  unsigned short  ident;     /*ʎq*/
  struct
  {
    unsigned short  Bit   :3;  /*rbgtO*/
    unsigned short  Offset:13; /*tOgItZbg*/
  } flag;
  unsigned char  ttl;        /**/
  unsigned char  protocolNumber; /*vgRԍ*/
  unsigned short  checksum;      /*`FbNT*/
  unsigned char  sIP[ LENGTHIPV4 ];  /*MIPAhX*/
  unsigned char  dIP[ LENGTHIPV4 ];  /*IPAhX*/
} IP_HEAD;                /*IP HEADER*/

/********************************************************/
/*  Bs\G[pPbg\(TYPE 3)                */
/********************************************************/
typedef struct
{
  char     NullFeild[4]; /*gpAK0*/
  IP_HEAD  ip_head;      /*IPwb_[*/
  union
  {
    UDP_HEAD udp_head;   /*UDPwb_[*/
    TCP_HEAD tcp_head;   /*TCPwb_[*/
  } data;
} TYPE_3;

/********************************************************/
/*  PINGpPbg\(TYPE 0,8)                        */
/********************************************************/
typedef struct
{
  PING_HEAD head;       /*HEADER*/
  char      data[ 64 ]; /*肠*/
} PING;

/********************************************************/
/*  ICMPpPbg\                                  */
/********************************************************/
typedef struct
{
  ICMP_HEAD  head; /*HEADER*/
  union
  {
    PING   ping;  /*PING*/
    TYPE_3 type3; /*擞Bs\G[*/
  } data;
} ICMP;

/********************************************************/
/*  UDPpPbg\                                   */
/********************************************************/
typedef struct
{
  UDP_HEAD head;       /*HEADER*/
  char     data[ 18 ]; /*肠*/
} UDP;

/********************************************************/
/*  TCPpPbg\                                   */
/********************************************************/
typedef struct
{
  TCP_HEAD head;      /*HEADER*/
  char     data[ 4 ]; /*肠*/
} TCP;

/********************************************************/
/*  IP FRAME\                                        */
/********************************************************/
typedef struct
{
  IP_HEAD head; /*HEADER*/
/*  char  option[ 4 ];*/ /*IvVL炵A肠̈̂ݎ擾*/
  union
  {
    ICMP icmp; /*ICMP bZ[W*/
    UDP  udp;  /*UDPt[*/
    TCP  tcp;  /*TCPt[*/
  } data;
} IP;  /*IP HEADER + DATA*/

/********************************************************/
/*  ETHERNET FRAME\                                  */
/********************************************************/
typedef struct
{
  unsigned char  your[ LENGTHMAC ];  /*Transmit Side MAC Address*/
  unsigned char  me[ LENGTHMAC ];  /*Myself MAC Address*/
  unsigned short type; /*Protocol Type*/
  union
  {
    char UserArea[ USER_AREA_SIZE ];  /*[U[f[^*/
#ifdef    __ARP_DEFINE__
    ARP  arp; /*ARP\*/
#endif
    IP   ip;  /*IP̃wb_[̍\*/
  } data;     /*ETHERNET FRAMẼf[^̈*/
} ETHERNETFRAME; /*ETHERNET FRAME*/

/********************************************************/
/*  ϒtB[h̐擪AhXi[                */
/********************************************************/
typedef struct
{
  VP    adr[2];        /*tB[h̐擪AhXi[*/
} VARIABLE_LENGTH_FIELD;

#define    IP_VAR_FLD    adr[0]  /*IPt[̃f[^̈̈ʒu*/
#define    TCP_VAR_FLD    adr[1]  /*TCPt[̃f[^̈̈ʒu*/
/********************************************************/
/*  IPwf[^n̍\                                */
/********************************************************/
typedef struct
{
  T_MSG  msgque;        /*bZ[Wwb_[̈A{IɃVXeǗ*/
  short  handle;        /*foCXnh*/
  short  sz;          /*f[^TCY*/
  VARIABLE_LENGTH_FIELD  vrf;  /*ϒtB[h̃AhXi[*/
  char  data[64];
} IP_RECORD;          /**/

/********************************************************/
/*  TCP/UDPwb_[`FbNTptB[h`         */
/********************************************************/
typedef struct
{
  unsigned char sip[ 4 ];      /*MIPAhX*/
  unsigned char dip[ 4 ];      /*IPAhX*/
  unsigned char ZeroField;      /*K0*/
  unsigned char ProNumber;      /*vgRԍ*/
  unsigned short Length;        /*f[^*/
} TCP_UDP_HEADER_CHECK_SUM;

/********************************************************/
/*  UDPf[^tB[hANZX`                     */
/********************************************************/
typedef struct
{
  TCP_UDP_HEADER_CHECK_SUM  c_sum;
  UDP              udp;    /*UDP HEADER*/
/*  char            data[ 18 ];*/  /*f[^̈ATCY18͎荇*/
} UDP_DATA_FIELD_ACCESS;

/********************************************************/
/*  TCPf[^tB[hANZX`                     */
/********************************************************/
typedef struct
{
  TCP_UDP_HEADER_CHECK_SUM  c_sum;
  TCP              tcp;    /*TCP HEADER*/
  char            data[ 4 ];  /*f[^̈ATCY4͎荇*/
} TCP_DATA_FIELD_ACCESS;

#define  IP_RECORD_HEADER_SIZE    (sizeof(T_MSG) + sizeof(short) + sizeof(short) + sizeof(VARIABLE_LENGTH_FIELD))
#define  ETHERNETFRAME_HEADER_SIZE  (LENGTHMAC + LENGTHMAC + sizeof(unsigned short))
#define  IP_HEADER_SIZE        sizeof(IP_HEAD)

#define  UDP_HEADER_SIZE     sizeof(UDP_HEAD)
#define  UDP_MIN_DATA_SIZE   (46 - IP_HEADER_SIZE - UDP_HEADER_SIZE)
#define  TCP_HEADER_SIZE     sizeof(TCP_HEAD)
#define  TCP_MIN_DATA_SIZE   (46 - IP_HEADER_SIZE - TCP_HEADER_SIZE)

#define  ICMP_HEADER_SIZE    sizeof(ICMP_HEAD)
#define  PING_HEADER_SIZE    sizeof(PING_HEAD)

#define ICMPTopAddress( adr )    (ICMP *)((char *)adr + IP_HEADER_SIZE)
#define PINGTopAddress( adr )    (PING *)((char *)adr + ICMP_HEADER_SIZE)
#define ICMPTYPE3TopAddress( adr )  (TYPE_3 *)((char *)adr + ICMP_HEADER_SIZE)

#define IPTopAddress( adr )     (IP *)((char *)adr + IP_RECORD_HEADER_SIZE + ETHERNETFRAME_HEADER_SIZE)
#define ArpTopAddress( adr )    (ARP *)((char *)adr + IP_RECORD_HEADER_SIZE + ETHERNETFRAME_HEADER_SIZE)
#define UDPTopAddress( adr )    (UDP *)((char *)adr + IP_HEADER_SIZE)
#define TCPTopAddress( adr )    (TCP *)((char *)adr + IP_HEADER_SIZE)
#define ICMPTopAddress( adr )   (ICMP *)((char *)adr + IP_HEADER_SIZE)
#define PINGTopAddress( adr )   (PING *)((char *)adr + ICMP_HEADER_SIZE)
#define ICMPTYPE3TopAddress( adr )  (TYPE_3 *)((char *)adr + ICMP_HEADER_SIZE)

/********************************************************/
/*  LINKG[`                                      */
/********************************************************/
/*G[x`*/
#define PHISICAL_WRITE_SIZE_OVER  -2  /*t@Crtl.cA֐RTLWRITẼTCY`FbN*/
#define PHISICAL_WRITE_TIME_OUT   -3  /*t@Crtl.cA֐RTLWRITẼ^CAEgŃ[v𔲂*/
#define PACKETTRANSMIT_TIME_OUT   -4  /*t@Crtl.cA֐PACKETTRANSMIT̃^CAEgŃ[v𔲂*/
#define PHISICAL_READ_SIZE_OVER   -5  /*t@Crtl.cA֐RTLREAD̃TCY`FbN*/
#define IPLAYERTRANSMIT_UNKNOWN_IP -6  /*t@Clink.cA֐IPLayerTransmit̕sIPAhX*/
#define PACKETTRANSMIT_TX_ERROR   -7  /*MɁAdՓ˂AFIFÕA_[G[*/
