/********************************************************************/
/*  Hyper Operating System V4 ]vO                        */
/*  ARPɊ֘A鏈B                             */
/*  ʑwłlinkwĂяo󂯂ARPt[e   */
/*  ɉARPe[u̍쐬AARPsB܂ȊOɂARP   */
/*  e[ůǗsB                                          */
/*                          Copyright (C) 1998-2002 by Project HOS  */
/*                          http://sourceforge.jp/projects/hos/     */
/********************************************************************/

#include  <stdio.h>
#include  <string.h>

#include  "itron.h"
#include  "kernel.h"
#include  "kernel_id.h"
#include  "system.h"
#include  "comm.h"
#include  "arp.h"
#include  "ip.h"
#include  "nava_cfg.h"

/*#define    __MULTICAST_USE__*/

unsigned char *GetRtlMac( void );

/********************************************************/
/*  ֐yѕϐ`                                    */
/********************************************************/
static int ArpTableUpdate( unsigned char *mac, unsigned char *ip, short handle );

int compare( char *, char *, int );
ER  LinkLayerTransmit( IP_RECORD *ipr );
int RequestRARP( const unsigned char * );
unsigned char* GetMyIP( void );

/********************************************************/
/*  ARPe[u̍\                                   */
/********************************************************/
typedef struct
{
  unsigned char  mac[ 6 ];    /*MACAhX*/
  unsigned char  ip[ 4 ];    /*IPAhX*/
  short    handle;      /*foCXnh*/
  SYSTIM    life;      /*̃R[h̐*/
} ARPTABLE;

/*CODE FIELD*/
#define REQUEST_ARP   0x0001
#define ANSWER_ARP    0x0002
#define REQUEST_RARP  0x0001

#define IPENTRY      32
#define TEN_MINUTES    ((unsigned long)1000*60*10)
static ARPTABLE  ArpTable[ IPENTRY ];

/********************************************************************/
/*  ARPɊւ鏉                                               */
/********************************************************************/
void arpInit( void )
{
  /*LOCAL LOOP̐ݒ*/
  memset( &ArpTable[ 0 ].mac, 0, sizeof(ArpTable[ 0 ].mac) );
  IP_COPY( &ArpTable[ 0 ].ip, LocalHost );
  ArpTable[ 0 ].handle = L0;
  /*BROAD CAST̐ݒ*/
  memset( &ArpTable[ 1 ].mac, 0xff, sizeof(ArpTable[ 1 ].mac) );
  IP_COPY( &ArpTable[ 1 ].ip, BroadCast );
  ArpTable[ 1 ].handle = ETH0;
}

/********************************************************************/
/*  ARPv                                                         */
/*  ɂ́AMACAhXƁAIPAhXƁAvshandle         */
/*  sLOCALHOSTȂAARPvƂȂ邵AȊÕfoCX      */
/*  ȂAƂȂB                                              */
/********************************************************************/
static void RequestARP(
  const unsigned char *mac,
  const unsigned char *dip,
  const unsigned char *sip, short handle )
{
  IP_RECORD      *ipr;
  ETHERNETFRAME    *ef_arp;
  ARP          *arp;

  /*ubN烁擾擾*/
  ipr = (IP_RECORD *)GetMemBlock( IP_RECORD_HEADER_SIZE + ETHERNETFRAME_HEADER_SIZE + sizeof(ARP) );
  arp = ArpTopAddress( ipr );
  /*IPAhXLOCAL HOST̏ꍇ[vobN[hɂ*/
  if( handle != L0 ) ipr->handle = handle;
  else
  {
    if( IP_COMPAER( LocalHost, dip ) == 0 ) ipr->handle = L0;
    else ipr->handle = ETH0;
  }
  ipr->sz = ARP_PACKETSIZE;

  /*ETHERNETt[̐*/
  ef_arp = (ETHERNETFRAME *)ipr->data;
  /*MACAhX̐ݒ*/
  memcpy( ef_arp->me, (char *)GetRtlMac(), sizeof(ef_arp->me) );
  /*ARP TYPE̐ݒ*/
  ef_arp->type = TYPEARP;

  /*ARPpPbg̐*/
  arp->HardType = TYPEETHERNET;    /*n[hEGA^Cv*/
  arp->ProtocolType = TYPEDOD;    /*vgR^Cv:DOD IP0x0800*/
  arp->MACAddressLength = LENGTHMAC;  /*n[hEGAAhX:܂MACAhX̎*/
  arp->IPAddressLength = LENGTHIPV4;  /*vgRAhX:܂IPAhX̎*/
  if( handle == L0 )
  {
    /*ETHERNETt[̑MACAhX̓u[hLXg*/
    memset( ef_arp->your, 0xff, sizeof(ef_arp->your) );
    /*MACAhXNA*/
    memset( arp->dMAC, 0, sizeof(arp->dMAC) );
    /*IPAhX*/
    /*Local Loop Backǂ𔻒*/
    if( IP_COMPAER( LocalHost , dip ) == 0 )
    {
      arp->Code = ANSWER_ARP;    /*CODE TYPEɐݒ*/
      IP_COPY( arp->dIP, ThisIs );
    }
    else
    {
      arp->Code = REQUEST_ARP;  /*CODE TYPEvɐݒ*/
      IP_COPY( arp->dIP, dip );
    }
  }
  else
  {
    /*ETHERNETt[̑MACAhX̐*/
    memcpy( ef_arp->your, mac, sizeof(ef_arp->your) );
    /*CODE TYPEɐݒ*/
    arp->Code = ANSWER_ARP;
    /*MACAhX*/
    memcpy( arp->dMAC, mac, sizeof(arp->dMAC) );
    /*IPAhX*/
    IP_COPY( arp->dIP, dip );
  }
  /*vn[hEGAAhX̐ݒ*/
  memcpy( arp->sMAC, (char *)GetRtlMac(), sizeof(arp->sMAC) );
  /*vvgRAhX̐ݒ*/
  IP_COPY( arp->sIP, sip );
  /*PAD̕t*/
  memset( arp->padding, arp->dIP[ 3 ], sizeof(arp->padding) );
  /*IPwɃf[^M*/
  LinkLayerTransmit( ipr );
}

/********************************************************************/
/*  ARPM                                                         */
/*  iprIP RECORD̃f[^np\                      */
/********************************************************************/
void ARPRcv( IP_RECORD *ipr )
{
  ARP        *arp;

  /*ARP̈̐擪AhX擾*/
  arp = ArpTopAddress( ipr );

  switch ( arp->Code )
  {
    /*ARPv̎M*/
    case REQUEST_ARP :
      /*ARP TABLEɓo^*/
      ArpTableUpdate( arp->sMAC, arp->sIP, ipr->handle );
      /*ARPvs*/
      RequestARP( arp->sMAC, arp->sIP, arp->dIP, ipr->handle );
      break;
    /*ARP̎M*/
    case ANSWER_ARP :
      /*ARP TABLEɓo^*/
      ArpTableUpdate( arp->sMAC, arp->sIP, ipr->handle );
      break;
    /*ԈR[ȟoAj*/
    default :
      break;
  }

  RelMemBlock( ipr );  /*JďI*/
}

/********************************************************************/
/*  ARP TABLEXV                                                   */
/*  mac͓o^MACAhXAip͓o^vIPAhXAhandle̓f    */
/*  oCXԍ                                                      */
/********************************************************************/
static int ArpTableUpdate( unsigned char *mac, unsigned char *ip, short handle )
{
  ARPTABLE  *arp;
  SYSTIM    systime;

  /*݂̎擾*/
  get_tim( &systime );

  /*ɓo^Ă邩mF*/
  arp = &ArpTable[ 2 ]; /*LOCAL HOSTBROADCAT̃GgO\񂵂Ă̂ŁAQn܂*/
  while( arp < &ArpTable[ IPENTRY ] )
  {
    /*o^Ă*/
    if( arp->handle == handle && /*(03/01/28 C)if̕тtɂāAłԂZ*/
      IP_COMPAER( arp->ip, ip ) == 0 )
    {
      /*MACAhX̏*/
      memcpy( arp->mac, mac, sizeof(ArpTable[0].mac) );
      /*VԂ̏*/
      arp->life.ltime = systime.ltime + TEN_MINUTES;
      if( arp->life.ltime < systime.ltime ) arp->life.utime = systime.utime + 1;
      else arp->life.utime = systime.utime;
      return 0;
    }
    arp++;
  }
  /*o^*/
  arp = &ArpTable[ 2 ]; /*LOCAL HOSTBROADCAT̃GgO\񂵂Ă̂ŁAQn܂*/
  while( arp < &ArpTable[ IPENTRY ] )
  {
    /*Ԃ0̗̈{*/
    if( systime.utime < arp->life.utime ){}
    else if( (systime.utime == arp->life.utime) && (systime.ltime < arp->life.ltime) ){}
    else
    {
      /*MACAhX̏*/
      memcpy( arp->mac, mac, sizeof(ArpTable[0].mac) );
      /*IPAhX̏*/
      IP_COPY( arp->ip, ip );
      /*VԂ̏*/
      arp->life.ltime = systime.ltime + TEN_MINUTES;
      if( arp->life.ltime < systime.ltime ) arp->life.utime = systime.utime + 1;
      else arp->life.utime = systime.utime;
      /*foCXnh̏*/
      arp->handle = handle;
      return 0;
    }
    arp++;
  }

  /*󂫂*/
  return -1;
}

void IPArpTableUpdate( unsigned char *mac, unsigned char *ip, short handle )
{
  ArpTableUpdate( mac, ip, handle );
}

/********************************************************************/
/*  MAC ADDRESS擾                                                 */
/*  ARP TABLEMACAhX擾邪AYAhX́A  */
/*  ARPv𔭍sBܘ_maćAMACAhX̊i[AipIP   */
/*  AhX                                                        */
/*  TIME OUTsAMACAhX擾łȂ-1A   */
/*  擾łȂfoCXԍԂB                              */
/*  ARCNET[eBOolɕύX(2003/1/7)                    */
/********************************************************************/
short GetMacAddress( unsigned char *mac, const unsigned char *ip )
{
  int      i;
  ARPTABLE    *arp;
  unsigned char  dip[4];
  SYSTIM      systime;
  static const unsigned char NullMacAdr[] = {0x00,0x00,0x00,0x00,0x00,0x00};

  /*LOCAL HOST𔻒f*/
  if(  IP_COMPAER( LocalHost, ip ) == 0 || IP_COMPAER( ThisIs, ip ) == 0 ) return L0;
  /*BROAD CAST𔻒f*/
  if(  IP_COMPAER( BroadCast, ip ) == 0 || IP_COMPAER( SubNetBroadCast, ip ) == 0 )
  {
    memcpy( mac, &ArpTable[ 1 ].mac, sizeof(ArpTable[ 1 ].mac) );
    return ArpTable[ 1 ].handle;
  }

  /*NETWORK GROUP𔻒f*/
  for( i = 0; i < sizeof(dip); i++ ) dip[ i ] = ip[ i ] & SubNetMask[ i ];  /*NET MASKƃAh*/

  if(  IP_COMPAER( NetWorkAddress, dip ) != 0 )
  {
    IP_COPY( dip, GateWay );
  }
  else
  {
    IP_COPY( dip, ip );
  }

  /*Tulbgu[hLXǧo*/
  if( (ip[ 3 ] | SubNetMask[ 3 ]) == 0xff
    && (ip[ 2 ] | SubNetMask[ 2 ]) == 0xff
    && (ip[ 1 ] | SubNetMask[ 1 ]) == 0xff
    && (ip[ 0 ] | SubNetMask[ 0 ]) == 0xff
  )
  {
    memset( mac, 0xff, sizeof(ArpTable[0].mac) );
    return ETH0;  /*foCXԍԂ*/
  }

  /*o^ĂTABLE{*/
  arp = &ArpTable[ 2 ];          /*LOCAL HOSTBROADCAT̃GgO\񂵂Ă̂ŁAQn܂*/
  /*݂̎擾*/
  get_tim( &systime );
  while( arp < &ArpTable[ IPENTRY ] )
  {
    /*o^Ă*/
    if(  IP_COMPAER( arp->ip, dip ) == 0 )
    {
      /*Ԃ̊mFFYIPLƂĂԂ؂ĂꍇL*/
      if( (arp->life.utime > systime.utime) || ((arp->life.utime == systime.utime) && (arp->life.ltime > systime.ltime)) )
      {
        memcpy( mac, arp->mac, sizeof(ArpTable[0].mac) );
        return arp->handle;          /*foCXԍԂ*/
      }
    }
    arp++;
  }
  /*YAhXĂꍇ*/
  /*[vɂȂ̂hׂARPv𔭍sĔĂ܂*/
  RequestARP( NullMacAdr, dip, ThisIs, L0 );

  return -1;
}
