/********************************************************************/
/*  IPt[Ɋւ鏈sB                            */
/*  IP֘ÃvgRƂICMPATCPAUDPAIGMPL邪Kvɉ  */
/*  Ă̊֐ĂяoAMĂ΂ꂽ肷B      */
/*                          Copyright (C) 1998-2002 by Project HOS  */
/*                          http://sourceforge.jp/projects/hos/     */
/********************************************************************/

#include  <stdio.h>
#include  <string.h>

#include  "itron.h"
#include  "kernel.h"
#include  "kernel_id.h"
#include  "system.h"
#include  "comm.h"
#include  "icmp.h"
#include  "ip.h"
#include  "nava_cfg.h"

static void PurgeMbx( ID mid );

const char Type3Code[] = 
{
  ICMP_TYPE3_CODE0_ERROR,    /*0:No route to host*/
  ICMP_TYPE3_CODE1_ERROR,    /*1:No route to host*/
  ICMP_TYPE3_CODE2_ERROR,    /*2:Connection Refused*/
  ICMP_TYPE3_CODE3_ERROR,    /*3:Connection Refused*/
  ICMP_TYPE3_CODE4_ERROR,    /*4:Message too long*/
  ICMP_TYPE3_CODE5_ERROR,    /*5:No route to host*/
  ICMP_TYPE3_CODE6_ERROR,    /*6:Network is unreacheable*/
  ICMP_TYPE3_CODE7_ERROR,    /*7:No route to host*/
  ICMP_TYPE3_CODE8_ERROR,    /*8:No route to host*/
  ICMP_TYPE3_CODE9_ERROR,    /*9:Network is unreacheable*/
  ICMP_TYPE3_CODE10_ERROR,   /*10:No route to host*/
  ICMP_TYPE3_CODE11_ERROR,   /*11:Network is unreacheable*/
  ICMP_TYPE3_CODE12_ERROR,   /*12:No route to host*/
  ICMP_TYPE3_CODE13_ERROR,   /*13:*/
  ICMP_TYPE3_CODE14_ERROR,   /*14:*/
  ICMP_TYPE3_CODE15_ERROR,   /*15:*/
};

/********************************************************/
/*  IPMɈnf[^̍\̒`            */
/*  LINKwQ                                        */
/********************************************************/
typedef struct
{
  int           sz;
  unsigned char *usr;
} RcvFrameDataAndSize;

/********************************************************/
/*  PINGM                                        */
/********************************************************/
typedef struct
{
  unsigned char  ttl;   /*TTL*/
  unsigned short ident; /*ʎq*/
  unsigned short sequ;  /*V[PXԍ*/
} PING_RCV_INFO;

/********************************************************/
/*  PINGp IPAhX̍\                         */
/********************************************************/
typedef struct
{
  short               sz;     /*Mf[^TCY*/
  unsigned short      sequ;   /*V[PXԍ*/
  int                 handle; /*nhԍ*/
  const unsigned char *dip;   /*MIPAhX*/
  const unsigned char *sip;   /*MIPAhX*/
  const char          *data;  /*Mf[^*/
  PING_RCV_INFO       pri;    /*PINGM*/
} PING_REQUEST_FORMAT;

/********************************************************/
/*  ֐yѕϐ`                                    */
/********************************************************/
unsigned char *GetMyIP( void );
int            IPLayerTransmit( IP_RECORD *ipr );
void           UDPRcv( IP_RECORD *ipr );
void           TCPRcv( IP_RECORD *ipr );
long           PINGReq( PING_REQUEST_FORMAT *prf );

/********************************************************************/
/*  16bit`GbNT̐                                         */
/*  aɂ́AvZΏۂ̐擪AhXAsz͌vZΏۂ̃TCYłA */
/*  WORDTCYƂȂ̂ŁA2ŊĂœn܂B             */
/*  ߂l̓`GbNTvZ                                    */
/********************************************************************/
unsigned short MakeCheckSum16( const unsigned short *a,unsigned short sz )
{
  unsigned long  sum = 0;
  unsigned short  *limit = (unsigned short *)&a[ sz / 2 ];

  while( a < limit ) sum += *a++;

  sum = (sum & 0xffff) + (sum >> 16);
  sum = (sum & 0xffff) + (sum >> 16);
  return ~sum;
}

/********************************************************************/
/*  IPt[̐                                                */
/*  dip͑IPAhXAsip͑MAhXAɃvg    */
/*  RԍAipr̓pPbgۑ̈                                 */
/*  ߂l̓G[ԍ                                              */
/********************************************************************/
int IPMake( IP_RECORD *ipr, const unsigned char *dip, const unsigned char *sip, unsigned char protoNum )
{
  IP     *ip;
  SYSTIM st;
  int    i;
  short  fix_sz;

  /*IP̈̐擪AhX擾*/
  ip = IPTopAddress( ipr );
  /*IPt[\ATCY̍ČvZ*/
  ipr->sz += IP_HEADER_SIZE;
  /*t[TCYs鎞̓pfBOs*/
  if( ipr->sz < 46 )
  {
    fix_sz = 46;
    memset( &ipr->data[ipr->sz + ETHERNETFRAME_HEADER_SIZE], 0, fix_sz - ipr->sz );
  }
  else fix_sz = ipr->sz;

  /*IPt[̍\*/
  ip->head.top.ver = IPVERSION;    /*IPV4̃o[W*/
  ip->head.top.length = 5;         /*IPwb_[݂̒͌Œ蒷ƂȂĂ邪A͕ϐň*/
  ip->head.tos = 0;                /*TOS*/
  ip->head.length = ipr->sz;       /*f[^*/
  get_tim(&st);                    /*VXe^C}[̒l̎擾*/
  ip->head.ident = st.ltime;       /*VXe^C}[̒ln*/
  ip->head.flag.Bit = 0;           /*rbgtO*/
  ip->head.flag.Offset = 0;        /*tOItZbg*/
  ip->head.ttl = TTL;              /*ttl*/
  ip->head.protocolNumber = protoNum;  /*vgRԍ*/
  ip->head.checksum = 0;           /*`FbNT0NA*/
  IP_COPY( ip->head.sIP, sip );
  IP_COPY( ip->head.dIP, dip );

  /*`FbNŤvZ*/
  ip->head.checksum = MakeCheckSum16( (const unsigned short *)ip, IP_HEADER_SIZE );
  ipr->sz = fix_sz;

  /*(03/01/28 ǉ) đ10܂ōsBłAMACAhX擾łȂ́AG[Ԃ*/
  for( i = 0; i < 10; i++ )      /*Ȃ݂ɁAv1000msƌԂ́A*/
  {
    if( IPLayerTransmit( ipr ) == 0 ) return 0;    /*I*/
    dly_tsk( 100 );
  }

  /*擾v[J*/
  RelMemBlock( ipr );

  /*ُI*/
  return IPLAYERTRANSMIT_UNKNOWN_IP;
}

/********************************************************************/
/*  ICMP̐                                                      */
/*  dip͑IPAhXAsip͑MAɃ^CvƃR[h    */
/*  ߂l̓G[ԍ                                              */
/********************************************************************/
int ICMPMake( IP_RECORD *ipr, const unsigned char *dip, const unsigned char *sip, char type, char code )
{
  ICMP      *icmp;

  /*ICMP̈̐擪AhX擾*/
  icmp = ipr->vrf.IP_VAR_FLD;
  /*ICMPt[\*/
  icmp->head.type = type;    /*ICMP^Cv̐ݒ*/
  icmp->head.code = code;    /*ICMPR[h̐ݒ*/
  icmp->head.checksum = 0;   /*ICMP`FbNT0NA*/
  /*f[^TCY̍ČvZ*/
  ipr->sz += ICMP_HEADER_SIZE;
  /*`FbNŤvZ*/
  icmp->head.checksum = MakeCheckSum16( (const unsigned short *)icmp, ipr->sz + (ipr->sz & 1) );
  /*IPt[̐֐Ă*/
  return IPMake( ipr, dip, sip, TYPEICMP );
}

/********************************************************************/
/*  PING̐                                                      */
/*  prf PINGNGXgptH[}bg                          */
/*  f[^̍őTCÝHŗLB                                  */
/*  ߂ĺAɎMȂ-1AȂΉ            */
/*  ֐ł݂ƂȂ̂ŁAƂǁEEE            */
/********************************************************************/
long PINGReq( PING_REQUEST_FORMAT *prf )
{
  char      *linebuf;
  ER        ercd;
  IP_RECORD    *ipr;
  IP        *ip;
  ICMP      *icmp;
  PING      *ping;
  SYSTIM      NewTime,OldTime;

  /*ubN烁擾*/
  ipr = (IP_RECORD *)GetMemBlock(
    IP_RECORD_HEADER_SIZE +
    ETHERNETFRAME_HEADER_SIZE +
    IP_HEADER_SIZE + ICMP_HEADER_SIZE +
    PING_HEADER_SIZE + prf->sz + (prf->sz & 1) );

  ipr->handle = L0;        /*̏LOCAL*/
  /*PING̈̐擪AhX擾*/
  ip    = IPTopAddress( ipr );
  icmp  = ICMPTopAddress( ip );
  ping  = PINGTopAddress( icmp );

  /*PING̍\*/
  ping->head.ident = MID_PINGRCV;           /*PING̎ʎqA^CAEg͋LqĂȂ*/
  ping->head.sequ = prf->sequ;              /*V[PXԍ*/
  memcpy( ping->data, prf->data, prf->sz ); /*f[^̃Rs[*/
  if( prf->sz & 1 ) ping->data[ prf->sz ] = 0;  /*]TCY̎ApfBOB*/

  /*ICMP֐ɓn*/
  ipr->sz = prf->sz + PING_HEADER_SIZE;      /*PING̃f[^TCY*/
  ipr->vrf.IP_VAR_FLD = icmp;            /*ϒtB[hAhXi[*/
  /*߂l̓e󋵂𔻒f*/
  switch ( ICMPMake( ipr, prf->dip, prf->sip, ECHO_REQ, 0 ) )  /*PING̔sAPING̏ꍇCODE=0ƂȂ*/
  {
    case 0 : break;
    case IPLAYERTRANSMIT_UNKNOWN_IP :
      SCI_Puts( prf->handle, "PINGReq:Unknown IP\r\n" );
      goto _err_end;
    case PHISICAL_WRITE_SIZE_OVER :
      SCI_Puts( prf->handle, "PINGReq:RTL write size error\r\n" );
      goto _err_end;
    case PHISICAL_WRITE_TIME_OUT :
      SCI_Puts( prf->handle, "PINGReq:RTL dma time out\r\n" );
      goto _err_end;
    case PACKETTRANSMIT_TIME_OUT :
      SCI_Puts( prf->handle, "PINGReq:RTL transmit time out\r\n" );
      goto _err_end;
    case PACKETTRANSMIT_TX_ERROR :
      SCI_Puts( prf->handle, "PINGReq:RTL transmit tx error\r\n" );
      goto _err_end;
    default :
      SCI_Puts( prf->handle, "PINGReq:PINGReq Another error\r\n" );
      goto _err_end;
  }
  
  get_tim( &OldTime );              /*PINGM̃VXe̎擾*/
  ercd = trcv_mbx( MID_PINGRCV, (T_MSG **)&ipr, 5000 );  /*bZ[W҂*/
  /*҂ԂIɉꂽׂ*/
  if( ercd == E_TMOUT  || ercd == E_RLWAI )
  {
    SCI_Puts( prf->handle, "ICMP no answer\r\n" );
    return EOF;              /*ُI*/
  }
  get_tim( &NewTime );          /*PINGM̃VXe̎擾*/

  /*PING̈̐擪AhX擾*/
  icmp = ipr->vrf.IP_VAR_FLD;
  ping = PINGTopAddress( icmp );
  /*V[PXԍ̃`FbN*/
  if( ping->head.sequ != prf->sequ )
  {
    linebuf = (char *)GetMemBlock( 128 );  /*Ɨ̈̊l*/
    sprintf( linebuf, "Sequence Number ERROR ! CORECT = %d VAIOLATION = %d\r\n", prf->sequ, ping->head.sequ );
    SCI_Puts( prf->handle, linebuf );
    RelMemBlock( (VP)linebuf );  /*v[̊J*/
    goto  _err_end;
  }
  /*f[^tB[h̃`FbN*/
  if( memcmp( prf->data, ping->data, prf->sz ) != 0 )
  {
    SCI_Puts( prf->handle, "Data Field ERROR\r\n" );
    goto  _err_end;
  }

  /*I*/
  prf->sequ++;
  /*PING̏*/
  ip = IPTopAddress( ipr );
  prf->pri.ttl  = ip->head.ttl;       /*TTL̎擾*/
  prf->pri.ident  = ping->head.ident; /*ʎq̎擾*/
  prf->pri.sequ  = ping->head.sequ;   /*V[PXԍ̎擾*/
  /*v[̕ԋp*/
  RelMemBlock( (VP)ipr );             /*v[̊J*/
  PurgeMbx( MID_PINGRCV );            /*[{bNX̃p[W*/
  return NewTime.ltime - OldTime.ltime;

_err_end:  /*ُI*/
  RelMemBlock( (VP)ipr );            /*v[̊J*/
  PurgeMbx( MID_PINGRCV );           /*[{bNX̃p[W*/

  return EOF;
}

/********************************************************************/
/*  PING̉                                                      */
/*  mblḱAIPt[ۑubN                  */
/*  PINGvAɕςĕԓBő咷1536byte              */
/*  ߂l̓G[ԍ                                              */
/********************************************************************/
static int PINGAns( IP_RECORD *ipr )
{
  unsigned char  temp;
  short      len;
  IP        *ip;
  ICMP      *icmp;
  PING      *ping;

  /*IPAICMPAPING̈̐擪AhX擾*/
  ip    = IPTopAddress( ipr );
  icmp = ipr->vrf.IP_VAR_FLD;
  ping  = PINGTopAddress( icmp );

  /*ICMP̃^Cvɂ*/
  icmp->head.type = ECHO_ANS;
  /*ICMP`FbNT0NA*/
  icmp->head.checksum = 0;
  /*PINGtB[h̃TCY擾*/
  /*`FbNŤvZ*/

  len = ip->head.length - (ip->head.top.length * 4);
  if( len & 1 )
    ((char *)icmp)[ len ] = 0;  /*̎0pfBO*/
  icmp->head.checksum = MakeCheckSum16( (const unsigned short *)icmp, len + (len & 1));

  /*TCYĐݒ*/
  ipr->sz = ip->head.length;
  /*IP:TTL炷*/
  ip->head.ttl--;
  /*IP:`FbNTNA*/
  ip->head.checksum = 0;
  /*IPƑMIPւ*/
  for( len = 0; len < (int)sizeof(ip->head.sIP); len++ )
  {
    temp = ip->head.sIP[ len ];
    ip->head.sIP[ len ] = ip->head.dIP[ len ];
    ip->head.dIP[ len ] = temp;
  }
  /*pPbgTCY̕s␳B*/
  if( ipr->sz < 46 )
  {
    len = 46;
    memset( &ipr->data[ipr->sz + ETHERNETFRAME_HEADER_SIZE], 0, len - ipr->sz );
  }
  else len = ipr->sz;

  /*IP̃`FbNŤvZ*/
  ip->head.checksum = MakeCheckSum16(
    (const unsigned short *)ip, ip->head.length + (ip->head.length & 1));

  ipr->sz = len;

  /*ICMP֐ɓn*/
  return IPLayerTransmit( ipr );
}

/********************************************************************/
/*  TYPE 3 G[(|[gBs\)̐                             */
/*  ip͑IPAhXAdata͑Mf[^Asz͂̃TCY      */
/*  sz͎󂯎IPwb_[(IvV܂)ƁAIPf[^O      */
/*  ̐擪8byteƂȂB                                       */
/*  ߂l͎芸AICMP̃G[ɑ΂G[̔śA    */
/*  ֎~ĂׁB                                              */
/********************************************************************/
void ICMPType3Answer( const unsigned char *dip, const unsigned char *sip, const char *data, short sz )
{
  IP_RECORD    *ipr;
  IP        *ip;
  ICMP      *icmp;
  TYPE_3      *type3;

  /*ubN烁擾*/
  ipr = (IP_RECORD *)GetMemBlock(
    IP_RECORD_HEADER_SIZE +
    ETHERNETFRAME_HEADER_SIZE +
    IP_HEADER_SIZE +
    ICMP_HEADER_SIZE + sizeof(long) + sz );

  ipr->handle = L0;        /*̏LOCAL*/
  ip    = IPTopAddress( ipr );      /*IPwb_[ʒu̎擾*/
  icmp  = ICMPTopAddress( ip );      /*ICMPwb_[ʒu̎擾*/
  type3  = ICMPTYPE3TopAddress( icmp );  /*TYPE3wb_[ʒu̎擾*/
  ipr->vrf.IP_VAR_FLD = icmp;        /*ϒtB[h̃AhXۑ*/

  /*Bs\G[̍\*/
  /*NULL FIELD*/
  memset( type3->NullFeild, 0, 4 );
  /*IP HEADERIPf[^O̐擪8bytẽRs[*/
  memcpy( &type3->ip_head, data, sz );
  /*TYPE3̃f[^TCY*/
  ipr->sz = sz + ICMP_HEADER_SIZE + sizeof(long);
  /*ICMP֐ɓn*/
  /*߂l̓e󋵂𔻒f*/
  switch ( ICMPMake( ipr, dip, sip, NOT_ARRIVAL, 3 ) )
  {
    case 0 :
      break;
    case IPLAYERTRANSMIT_UNKNOWN_IP :
      DebugPrint( "ICMPType3Answer:Unknown IP\r\n" );
      break;
    case PHISICAL_WRITE_SIZE_OVER :
      DebugPrint( "ICMPType3Answer:RTL write size error\r\n" );
      break;
    case PHISICAL_WRITE_TIME_OUT :
      DebugPrint( "ICMPType3Answer:RTL dma time out\r\n" );
      break;
    case PACKETTRANSMIT_TIME_OUT :
      DebugPrint( "ICMPType3Answer:RTL transmit time out\r\n" );
      break;
    default :
      DebugPrint( "ICMPType3Answer:PINGReq Another error\r\n" );
      break;
  }
}

/********************************************************************/
/*  IPM                                                          */
/*  iprIP RECORD̃f[^np\                      */
/*  Bs\G[̏ꍇAICMPt[̃f[^ɁAMIP    */
/*  t[ƁATCP܂UDPwb_[8BYTEĂ̂ŁA|[   */
/*  gԍAY|[gԍ̃R[obN𒲂ׁAR[ob  */
/*  Nݒ肳ĂȂ΁AR[obN֐ɓBs\𑗐MB*/
/********************************************************************/
void IPRcv( IP_RECORD *ipr )
{
  short    MemoryRelease;
  IP      *ip;
  ICMP    *icmp;
  PING    *ping;

  /*IP̈̐擪AhX擾*/
  ip = IPTopAddress( ipr );
  /*ϔ̐擪AhX擾*/
  ipr->vrf.IP_VAR_FLD = (VP)((char *)ip + (ip->head.top.length << 2));
  /*`FbNŤvZ*/
  if( MakeCheckSum16( (unsigned short *)ip, ip->head.top.length << 2 ) )
  {
    DebugPrint( "IP Rcv Check Sum Error\r\n" );
    RelMemBlock( ipr );
    return;
  }

  MemoryRelease = TRUE;
  /*vgRԍׂăT[rX̎ނ*/
  switch (ip->head.protocolNumber)
  {
    case TYPEICMP :
      if( IP_COMPAER( ip->head.dIP, BroadCast ) == 0 ) break;  /*u[hLXg͎󂯓Ȃ*/
      icmp = ipr->vrf.IP_VAR_FLD;      /*ϔɂICMPĂ*/
      switch (icmp->head.type)
      {
        /*PINGv*/
        case  ECHO_ANS :
          ping = PINGTopAddress( icmp );
          if( snd_mbx( MID_PINGRCV, (T_MSG *)ipr ) == E_OK ) MemoryRelease = FALSE;
          break;
        /*PINGvꂽ*/
        case ECHO_REQ :
          MemoryRelease = ( PINGAns( ipr ) == IPLAYERTRANSMIT_UNKNOWN_IP ) ? TRUE : FALSE;
          /*MɎsĂ΍폜sAAMō폜Ă܂̂ŁAł͍폜Ȃ*/
          break;
        /*擞Bs\*/
        case NOT_ARRIVAL :
          /*UDPTCP𒲂ׂāȀUDP܂TCPɔC*/
          if( icmp->data.type3.ip_head.protocolNumber == TYPEUDP )
          {
            UDPRcv( ipr );
            MemoryRelease = FALSE;    /*ō폜̂ŁAł͍폜Ȃ*/
          }
          else if( icmp->data.type3.ip_head.protocolNumber == TYPETCP )
          {
            TCPRcv( ipr );
            MemoryRelease = FALSE;    /*ō폜̂ŁAł͍폜Ȃ*/
          }
          else{}
          break;
        /*^CX^vv*/
        case TIME_STAMP_REQ :
        /*^CX^v*/
        case TIME_STAMP_ANS :
        /*AhX}XN̗v*/
        case ADDRESS_MASK_REQ :
        /*AhX}XN̉*/
        case ADDRESS_MASK_ANS :
        default :
          DebugPrint( "ICMP Another Service\r\n" );
          break;
      }
      break;
    case TYPETCP :
      if( IP_COMPAER( ip->head.dIP, BroadCast ) == 0 ) break;  /*u[hLXg͎󂯓Ȃ*/
      TCPRcv( ipr );
      MemoryRelease = FALSE;    /*ō폜̂ŁAł͍폜Ȃ*/
      break;
    case TYPEUDP :
      UDPRcv( ipr );
      MemoryRelease = FALSE;    /*ō폜̂ŁAł͍폜Ȃ*/
      break;
    default:
      DebugPrint( "Reciving Unknown IP\r\n" );
      break;
  }
  /*KvȂ烁JďI*/
  if( MemoryRelease == TRUE ) RelMemBlock( ipr );  /*v[̊J*/
}

/********************************************************************/
/*  [{bNX̕spȃ[NA                            */
/********************************************************************/
static void PurgeMbx( ID mid )
{
  T_MSG*  msg;

  while( prcv_mbx(mid, (T_MSG **)&msg) == E_OK ) RelMemBlock( (VP)msg );
}
