/********************************************************************/
/*  HOS-V4 (ITRON4.0dl)                                           */
/*  LINKw(w̒)̏SB                  */
/*  wETHERNETt[AIPAARPARARPɃf[^   */
/*  n̂ƁAvgRf[^āAETHERNET  */
/*  t[𐶐Awɓn̂dB                          */
/*                          Copyright (C) 1998-2002 by Project HOS  */
/*                          http://sourceforge.jp/projects/hos/     */
/********************************************************************/

#include  <stdio.h>
#include  <string.h>

#include  "itron.h"
#include  "kernel.h"
#include  "kernel_id.h"
#include  "system.h"
#include  "comm.h"
#include  "arp.h"
#include  "ip.h"
#include  "nava_cfg.h"

unsigned char  *GetRtlMac( void );

/********************************************************/
/*  Mobt@pPbg\                            */
/********************************************************/
typedef struct
{
  unsigned short    size;      /*SIZE*/
  ETHERNETFRAME*    ef;        /*EtherNett[*/
} WD;

/********************************************************/
/*  ֐yѕϐ`                                    */
/********************************************************/
/*RTL8019AS֐*/
int   sndRTL( WD * );        /*RTLM*/
short GetMacAddress( unsigned char *mac, const unsigned char *ip );
void  ARPRcv( IP_RECORD *ipr );
void  IPRcv( IP_RECORD *ipr );
void  IPArpTableUpdate( unsigned char *mac, unsigned char *ip, short handle );

/********************************************************************/
/*  t[M                                                */
/*  MfoCXʂ̏s                                  */
/********************************************************************/
void LinkLayerRecieve( VP_INT exinf )
{
  IP_RECORD    *ipr;
  ETHERNETFRAME  *ef;
  ARP        *arp;
  IP        *ip;

  RegistProcessTable( _BACK_GROUND_, FALSE );
  while( 1 )
  {
    rcv_mbx( MID_ETH0RCV, (T_MSG **)&ipr );  /*bZ[W҂*/
    ef = (ETHERNETFRAME *)ipr->data;
    /*t[^CvǂݏoăvgRʂ*/
    switch ( ef->type )
    {
      case TYPEIP :          /*IPvgR*/
        /*IP̈̐擪AhX擾*/
        ip = IPTopAddress( ipr );
        /*ȈĂ̗v̎*/
        if( IP_COMPAER( ip->head.dIP, ThisIs ) == 0 )
        {
          /*ARP Table̍XV*/
          IPArpTableUpdate( ef->me, ip->head.sIP, ipr->handle );
          /*IPwɓn*/
          IPRcv( ipr );
        }
        /*u[hLXgpPbg̏B*/
        else if( IP_COMPAER( ip->head.dIP, BroadCast ) == 0 ) IPRcv( ipr );  /*~ebhu[hLXg*/

#ifdef  __DHCP_USE__
        /*DHCPv݂̂̏BDHCPŃAhX̎擾́AIPAhX0LɂȂĂB*/
        else if( ThisIs[0] == 0 && ThisIs[1] == 0 && ThisIs[2] == 0 && ThisIs[3] == 0 ) IPRcv( ipr );  /*DHCPT[o[̒ɂ́AjLXgŐڑĂ^CvL(݂͂)B*/
#endif  /*__DHCP_USE__*/

        else RelMemBlock( ipr );        /*v[̊J*/

        break;
      case TYPEARP :          /*ARPvgR*/
        /*ARP̈̐擪AhX擾*/
        arp = ArpTopAddress( ipr );
        /*ȈĂ̗vfȈĂł͂Ȃ͎̂Ă*/
        if( IP_COMPAER( ThisIs, arp->dIP ) == 0 ) ARPRcv( ipr );  /*ARPM*/

        else RelMemBlock( ipr );    /*v[̊J*/

        break;
      case TYPERARP :          /*RARPvgR*/
      default :            /*IEEE802.3̃t[ǂ𔻒f*/
        RelMemBlock( ipr );      /*v[̊J*/
        break;
    }
  }
  RelocateProcessTable();
  ext_tsk();            /*TASK̏I*/
}

/********************************************************************/
/*  LINKwłETHERNETt[̑M                            */
/*  ARP痘pĂB                                           */
/*  ef͖ܘ_ETHERNETt[Asz͓]Ahandle̓foCXԍ  */
/*  ߂lɂ̓G[R[hԂB                                  */
/********************************************************************/
ER LinkLayerTransmit( IP_RECORD *ipr )
{
  if( ipr->handle == L0 )
  {
    /*[vobN*/
    return snd_mbx( MID_ETH0RCV, (T_MSG *)ipr );
  }
  else if( ipr->handle == ETH0 )
  {
    return snd_mbx( MID_ETH0SND, (T_MSG *)ipr );
  }
  else return (ER)-1;
}

/********************************************************************/
/*  IPwłETHERNETt[̑M                              */
/*  ef͖ܘ_ETHERNETt[Asz͓]                        */
/********************************************************************/
int IPLayerTransmit( IP_RECORD *ipr )
{
  unsigned char  mac[ 6 ];
  short      handle;
  ETHERNETFRAME  *efs = (ETHERNETFRAME *)ipr->data;
  IP        *ip;
  IP_RECORD    *mblk;

  /*IP̈̐擪AhX擾*/
  ip    = IPTopAddress( ipr );
  /*IPAhXMACAhX擾*/
  handle  = GetMacAddress( mac, ip->head.dIP );

  switch ( handle )
  {
    case L0 :
      efs->type = TYPEIP;            /*IPTYPEݒ*/
      IP_COPY( ip->head.dIP, ThisIs );    /*AhXĂɕύX*/
      ipr->sz += ETHERNETFRAME_HEADER_SIZE;  /*t[TCYZ*/
      mblk = (IP_RECORD *)GetMemBlock( ipr->sz + IP_RECORD_HEADER_SIZE );  /*ubN̎擾*/
      mblk->sz = ipr->sz;
      mblk->handle = L0;            /*foCXnh*/
      memcpy( mblk->data, ipr->data, ipr->sz );  /*Rs[*/
      RelMemBlock( ipr );            /*(03/01/28 ǉ) spɂȂv[̊J*/
      snd_mbx( MID_ETH0RCV, (T_MSG *)mblk );  /*[vobN*/
      break;
    case ETH0 :
      memcpy( efs->your, mac, sizeof(efs->your) );    /*MACAhXRs[*/
      memcpy( efs->me, GetRtlMac(), sizeof(efs->me) );  /*MACAhXRs[*/
      efs->type = TYPEIP;          /*IPTYPEݒ*/
      /*]TCYw*/
      ipr->sz += sizeof(efs->your) + sizeof(efs->me) + sizeof(efs->type);
      snd_mbx( MID_ETH0SND, (T_MSG *)ipr );
      break;
    default :                  /*MACAhX擾łȂ͈UI*/
      return IPLAYERTRANSMIT_UNKNOWN_IP;
  }

  return 0;
}
