/* ------------------------------------------------------------------------ */
/*  Hyper Operating System V4 ]vO                                */
/*  TCPvgRX^bN                                                   */
/*                                  Copyright (C) 1998-2002 by hamayan      */
/*                                  http://sourceforge.jp/projects/hos/     */
/* ------------------------------------------------------------------------ */
#ifdef    __300HA__
#include  <no_float.h>
#endif    /*__300HA__*/
#include  <stdio.h>
#include  <string.h>

#include  "itron.h"
#include  "kernel.h"
#include  "kernel_id.h"

#undef    DEBUG_MODE

#include  "system.h"
#include  "comm.h"
#include  "icmp.h"
#include  "ip.h"
#include  "nava_cfg.h"
#include  "tcp.h"

#define   TCP_TIME_OUT_LIMIT  60000

/********************************************************************/
/*  \PbgyA`                                                */
/********************************************************************/
#define  MAX_TCP_PORT_NUM  8

typedef struct
{
  unsigned char  DestIp[4];  /*IP ADDRESS*/
  unsigned short SelfPort;   /*|[gԍ*/
  unsigned short DestPort;   /*|[gԍ*/
  ID        mid;             /*^[{bNXIDԍ*/
  ID        callback_id;     /*R[obNpIDԍ*/
/*  SYSTIM      LastTime;*/  /*ANeBuN[Y̍Ō̃ANZX*/
  void (* callBack)( IP *ip, TCP *tcp, ID id );  /*R[obN֐*/
} TCP_SOCKET_PAIR;

static TCP_SOCKET_PAIR  socket_pair_table[ MAX_TCP_PORT_NUM ];

/********************************************************/
/*  TCPwb_[AIvVtB[h`               */
/********************************************************/
typedef  struct
{
  unsigned char  kind;
  unsigned char  len;
  unsigned short  mss;
} MSSOptionField;

/********************************************************/
/*  ֐yѕϐ`                                    */
/********************************************************/
extern  char Type3Code[];
/*IP֘A֐*/
unsigned short MakeCheckSum16( const unsigned short *a,unsigned short sz );
int IPMake( IP_RECORD *ipr, const unsigned char *dip, const unsigned char *sip, unsigned char protocolNumber );
static unsigned short GetMSSSize( TCP *tcp );

static void RcvType3Error( IP_RECORD *ipr );
static int AnswerNumberUpdate( TcpAddressAndPortInformation *info, IP_RECORD *ipr );
static unsigned long GetSequenceNumber( void );
static unsigned short GetPortNumber( void );
void TCPForceCloseState( TcpAddressAndPortInformation *info );
void TCPForceCloseStateWithoutRST( TcpAddressAndPortInformation *info );

static int SendWithState( TcpAddressAndPortInformation *info, unsigned char state, MSSOptionField *mof );
#define  TCPReadPacketReplyAnswerNumber(info)  SendWithState(info,TCP_ACK,(MSSOptionField *)0)

static void TCPPurgeMbx( ID mid );

static void WriteSequenceNumberUpdate( TcpAddressAndPortInformation *info, int size );
#define  SequenceNumberUpdate(info)  WriteSequenceNumberUpdate(info,0)

static int TWaitForState( TcpAddressAndPortInformation *info, IP_RECORD **ipr, int check_state, TMO tmout );
#define  WaitForState(info,ipr,state)  TWaitForState(info,ipr,state,TMO_FEVR)

static void TCPReadPacketRecordInit( RcvPacketRecord record[] );
static int SequenceRagLead( unsigned long ref, unsigned long rcv );

/********************************************************************/
/*  TCP̏                                                     */
/********************************************************************/
void TCPInit( void )
{
}

/********************************************************************/
/*  \PbgyA̓o^                                              */
/*  󂫂-1ԂāAI0ԂB                   */
/*  T[o[̏ꍇ́AsT[o[ׂɁA|[gA    */
/*  ̃vZX҂󂯂鎖B                        */
/*  sT[o[̃RlNV̋ʂ́A\PbgyAŋʂB  */
/********************************************************************/
static int RegistSocketPairTable( TcpAddressAndPortInformation *info )
{
  TCP_SOCKET_PAIR *spt = socket_pair_table;

  /*sȃ|[gԍƕsȃ[{bNXID͓o^łȂ*/
  if( !info->sport || info->mid <= 0 || info->mid > TMAX_MBXID ) return EOF;

  /*ɓ|[gԍgpłȂBAÃ`FbN̓NCAĝݍsB*/
  if( info->server == FALSE )
  {
    dis_dsp();
    while( spt < &socket_pair_table[ MAX_TCP_PORT_NUM ] )
    {
      if( spt->SelfPort == info->sport )
      {
        ena_dsp();
        return EOF;  /*gp*/
      }
      spt++;
    }
    ena_dsp();
  }

  /*󂫗̈*/
  spt = socket_pair_table;
  dis_dsp();
  while( spt < &socket_pair_table[ MAX_TCP_PORT_NUM ] )
  {
    if( spt->SelfPort == 0 )
    {
      spt->SelfPort = info->sport;    /*|[gԍ*/
      ena_dsp();
      *((long *)spt->DestIp) = *((long *)info->dip);  /*IPAhX*/
      spt->DestPort = info->dport;  /*|[gԍ*/
      spt->mid      = info->mid;    /*^XNԒʐMp[{bNXID*/
      spt->callback_id  = info->callback_id; /*R[obÑIuWFNgID*/
      spt->callBack = info->callback;  /*R[obN֐̓o^*/
      return 0;
    }
    spt++;
  }
  ena_dsp();
  return EOF;
}

/********************************************************************/
/*  \PbgyẢ                                              */
/*  ̂Y[{bNXID-1ԂāAI      */
/*  0ԂB                                                       */
/*  self́ARlNV폜ꍇTRUEĂB    */
/*  Ƃ̐ڑ̂ݍ폜鎞́AFALSEB                   */
/********************************************************************/
static int RelSocketPairTable( ID mid, BOOL self )
{
  TCP_SOCKET_PAIR    *spt = socket_pair_table;

  dis_dsp();
  while( spt < &socket_pair_table[ MAX_TCP_PORT_NUM ] )
  {
    if( spt->mid == mid )
    {
      if( self == TRUE )
      {
        spt->mid = 0;       /*nh*/
        spt->SelfPort = 0;  /*Ǐ𖢎gpɂ*/
      }
      *((unsigned long *)spt->DestIp) = 0L;  /*𖢎gpɂ*/
      spt->DestPort = 0;  /*𖢎gpɂ*/
      ena_dsp();
      return 0;
    }
    spt++;
  }
  ena_dsp();
  return EOF;
}

/********************************************************************/
/*  RSTM                                                     */
/*  OƂāAo[seqɂ͑̊mFԍAo[ackɂ  */
/*  ̃V[PXԍĂƂB                    */
/********************************************************************/
int RSTTransmit( const RST_INFORMATION *rst_info, unsigned char state )
{
  int    ret;
  TcpAddressAndPortInformation *info;    /*TCPڑ*/

  /*ƂɕKvȃ̎؂oB*/
  info = (TcpAddressAndPortInformation *)GetMemBlock( sizeof(TcpAddressAndPortInformation) );
  /*RESETXe[g𑗐M*/
  IP_COPY( info->dip, rst_info->dip );
  IP_COPY( info->sip, rst_info->sip );
  info->dport = rst_info->dport;
  info->sport = rst_info->sport;
  info->WindowSz = 0;
  info->sequNo = rst_info->seq;
  info->answerNo = rst_info->ack;
  info->state = TCP_RST | state;
  info->UrgencyPtr = 0;  /*ً}|C^FH*/
  info->OptionSz = 0;
  info->SndDataSz = 0;
  ret = TCPSend( info );
  RelMemBlock( info );  /*v[̊J*/

  return ret;
}

/********************************************************************/
/*  TCP̐                                                       */
/*  ip͑IPAhXAdata͑Mf[^Asz͂̃TCY      */
/*  dport͑|[gԍAsport͎|[gԍ                    */
/*  ߂l͐ɑMȂ-1AȂΉ              */
/********************************************************************/
int TCPSend( TcpAddressAndPortInformation *info )
{
  unsigned short varid;
  IP_RECORD      *ipr;
  IP             *ip;
  TCP            *tcp;
  TCP_UDP_HEADER_CHECK_SUM  *c_sum;

  /*ubN烁擾*/
  varid = info->SndDataSz + info->OptionSz;
  if( varid < TCP_MIN_DATA_SIZE )  /*f[^̃TCY18byteȂ18byteɕ⑫*/
    ipr = GetMemBlock( IP_RECORD_HEADER_SIZE + ETHERNETFRAME_HEADER_SIZE + IP_HEADER_SIZE + TCP_HEADER_SIZE + TCP_MIN_DATA_SIZE );
  else if( varid & 1 )  /*Mf[^TCYȂɂ*/
    ipr = GetMemBlock( IP_RECORD_HEADER_SIZE + ETHERNETFRAME_HEADER_SIZE + IP_HEADER_SIZE + TCP_HEADER_SIZE + varid + 1 );
  else
    ipr = GetMemBlock( IP_RECORD_HEADER_SIZE + ETHERNETFRAME_HEADER_SIZE + IP_HEADER_SIZE + TCP_HEADER_SIZE + varid );

  ip   = IPTopAddress( ipr );  /*IPwb_[ʒu̎擾*/
  tcp  = TCPTopAddress( ip );  /*TCPwb_[ʒu̎擾*/
  ipr->vrf.IP_VAR_FLD = tcp;  /*ϒtB[h̃AhXۑ*/

  ipr->handle = L0;  /*̏LOCAL*/
  /*TCP HEADER̍\*/
  tcp->head.sport = info->sport;  /*|[gԍ*/
  tcp->head.dport = info->dport;  /*|[gԍ*/
  tcp->head.SequNum.H  = *((unsigned short *)&info->sequNo);  /*V[PXԍ*/
  tcp->head.SequNum.L  = info->sequNo;
  tcp->head.AckNum.H  = *((unsigned short *)&info->answerNo);  /*mFԍ*/
  tcp->head.AckNum.L  = info->answerNo;
  tcp->head.control = ((TCP_HEADER_SIZE + info->OptionSz) >> 2) << TCP_CONTROL_LENGTH_SIFT_SZ;  /*TCPf[^*/
  tcp->head.control |= info->state & TCP_CONTROL_STATE_MASK;  /*0b0011 1111*/
  tcp->head.WindowSize  = info->WindowSz;
  tcp->head.Uptr      = info->UrgencyPtr;          /*ً}|C^*/

  if( info->OptionSz )
    memcpy( tcp->data, info->OptionArea, info->OptionSz );    /*IvV̈̃Rs[*/
  if( info->SndDataSz )
    memcpy( &tcp->data[info->OptionSz], info->TCPSBuffer, info->SndDataSz );  /*f[^̈̃Rs[*/

  /* TCPt[̑S̒Zo*/
  ipr->sz = TCP_HEADER_SIZE + varid;

  /*f[^̎̏*/
  if( info->SndDataSz & 1 )
  {
    varid = ipr->sz + 1;
    tcp->data[ info->SndDataSz ] = 0;    /*f[^ɂO܂*/
  }
  else varid = ipr->sz;

  /*TCP`FbNTs*/
  c_sum = (TCP_UDP_HEADER_CHECK_SUM *)((char *)&tcp->head.sport - sizeof(TCP_UDP_HEADER_CHECK_SUM) );
  IP_COPY( c_sum->sip, info->sip );
  IP_COPY( c_sum->dip, info->dip );
  c_sum->ZeroField = 0;       /*0*/
  c_sum->ProNumber = TYPETCP; /*vgRԍ*/
  c_sum->Length = ipr->sz;    /*TCPf[^*/
  tcp->head.checksum = 0;     /*܂`FbNT0NA*/
  tcp->head.checksum =
    MakeCheckSum16( (unsigned short *)c_sum, sizeof(TCP_UDP_HEADER_CHECK_SUM) + varid );
  if( tcp->head.checksum == 0 ) tcp->head.checksum = -1;

  /*IPwɑM*/
  return IPMake( ipr, info->dip, info->sip, TYPETCP );
}

/********************************************************************/
/*  TCP̎M                                                       */
/*  ipr͎MpPbg                                           */
/*  ʂ̃`FbNA|[gԍɃR[obN֐  */
/*  NB                                                    */
/********************************************************************/
void TCPRcv( IP_RECORD *ipr )
{
  int length,first_contact,state;
  ID  mid;
  TCP_UDP_HEADER_CHECK_SUM  *c_sum;
  IP_RECORD    *ipr_tcp;
  IP   *ip;
  TCP  *tcp;
  TCP_SOCKET_PAIR  *spt;
  RST_INFORMATION  rst_info;

  /*IPAUDP̈̐擪AhX擾*/
  ip  = IPTopAddress( ipr );
  tcp = ipr->vrf.IP_VAR_FLD;

  /*ICMP̓Bs\G[Ɉ˂Nǂ𔻒f*/
  if( ip->head.protocolNumber == TYPEICMP )
  {
    RcvType3Error( ipr );
    return;
  }

  /*\PbgyA*/
  first_contact = mid = 0;
  spt = socket_pair_table;
  while( spt < &socket_pair_table[ MAX_TCP_PORT_NUM ] )
  {
    if( spt->SelfPort == tcp->head.dport &&
      spt->DestPort == tcp->head.sport &&
      IP_COMPAER( spt->DestIp, ip->head.sIP ) == 0 )
    {
      mid = spt->mid;
      break;
    }
    spt++;
  }

  if( mid == 0 )
  {
    /*YyAtȂ*/
    if( (tcp->head.control & TCP_CONTROL_STATE_MASK) == TCP_SYN )  /*SYNĂ邩H*/
    {
      spt = socket_pair_table;
      /*҂vZX̌*/
      while( spt < &socket_pair_table[ MAX_TCP_PORT_NUM ] )
      {
        if( spt->mid && *((unsigned long *)spt->DestIp) == 0L && spt->SelfPort == tcp->head.dport )
        {
          /*\PbgyAo^*/
          spt->DestPort = tcp->head.sport;
          IP_COPY( spt->DestIp, ip->head.sIP );
          first_contact = 1;
          mid = spt->mid;
          break;
        }
        spt++;
      }
    }
  }

  /*T[rXX^[gĂȂ́ARSTԂB*/
  if( mid == 0 )
  {
    if( (state = (tcp->head.control & TCP_CONTROL_STATE_MASK)) & TCP_RST )
    {
      RelMemBlock( ipr );  /*v[̊J*/
      return;  /*RST͎̏ꍇRSTԂȂB*/
    }

    IP_COPY( rst_info.dip, ip->head.sIP );
    IP_COPY( rst_info.sip, ip->head.dIP );
    rst_info.dport = tcp->head.sport;
    rst_info.sport = tcp->head.dport;
    /*肪SYN𑗂Ă͊mFԍ0ɂȂĂ̂ŁAKRIɂ炩瑗V[PXԍ0*/
    *((unsigned short *)&rst_info.seq + 0) = tcp->head.AckNum.H;
    *((unsigned short *)&rst_info.seq + 1) = tcp->head.AckNum.L;
    *((unsigned short *)&rst_info.ack + 0) = tcp->head.SequNum.H;
    *((unsigned short *)&rst_info.ack + 1) = tcp->head.SequNum.L;

    if( state & TCP_SYN ) rst_info.ack++;  /*SYN̏ꍇ͊mFԍi߂*/

    RelMemBlock( ipr );  /*v[̊J*/
    RSTTransmit( &rst_info, TCP_ACK );
    return;
  }

  /*f[^̈m*/
  ipr_tcp = (IP_RECORD *)GetMemBlock( ipr->sz );
  ipr_tcp->handle = ipr->handle;  /**/
  ipr_tcp->sz = sizeof(TCP_UDP_HEADER_CHECK_SUM) + ip->head.length - (ip->head.top.length << 2);  /*f[^TCY*/
  /*`FbNTؗptB[h̏*/
  c_sum = (TCP_UDP_HEADER_CHECK_SUM *)ipr_tcp->data;  /*`FbNTpɒ`*/
  IP_COPY( c_sum->sip, ip->head.sIP );
  IP_COPY( c_sum->dip, ip->head.dIP );

  c_sum->ZeroField = 0;                /*0*/
  c_sum->ProNumber = ip->head.protocolNumber;      /*vgRԍ*/
  c_sum->Length = ip->head.length - (ip->head.top.length << 2);    /*TCPf[^*/
  /*ipr̃f[^Rs[*/
  memcpy( &ipr_tcp->data[ sizeof(TCP_UDP_HEADER_CHECK_SUM) ], tcp, c_sum->Length );

  /*f[^̎̏*/
  if( c_sum->Length & 1 )
  {
    ipr_tcp->data[ c_sum->Length + sizeof(TCP_UDP_HEADER_CHECK_SUM) ] = 0;  /*f[^ɂO܂*/
    length = c_sum->Length + 1;
  }
  else
    length = c_sum->Length;

  /*TCP`FbNT̊mF*/
  if( tcp->head.checksum == 0xFFFF )  /*0xffff̎0ɂ*/
    tcp->head.checksum = 0;
  /*`FbNŤvZ*/
  if( MakeCheckSum16( (unsigned short *)c_sum, sizeof(TCP_UDP_HEADER_CHECK_SUM) + length ) )
  {
    DebugPrint( "TCP Rcv Check Sum Error\r\n" );
    RelMemBlock( ipr );
    RelMemBlock( ipr_tcp );
    if( first_contact == 1 )
      RelSocketPairTable( mid, FALSE );  /*\PbgyẢ*/
    return;
  }

  /*R[obN֐̌Ăяo*/
  if( (void *)spt->callBack != (void *)NADR )
    spt->callBack( ip, tcp, spt->callback_id );  /*R[obN֐o^Ă鎞*/

  RelMemBlock( ipr );
  snd_mbx( mid, (T_MSG *)ipr_tcp );
}

/********************************************************************/
/*  ICMP TYPE3̃G[M̏                            */
/********************************************************************/
static void RcvType3Error( IP_RECORD *ipr )
{
  ICMP  *icmp;
  TCP_SOCKET_PAIR  *spt;

  /*ICMPTCP̈悩|[gԍ擾*/
  icmp = ipr->vrf.IP_VAR_FLD;      /*ϔɂICMPĂ*/
  ipr->handle = Type3Code[icmp->head.code];  /*ϐhandleɕ̒lăG[`*/
  /*\PbgyAe[uY|[ggpĂAvP[VɘA*/
  spt = socket_pair_table;
  while( spt < &socket_pair_table[ MAX_TCP_PORT_NUM ] )
  {
    if( spt->SelfPort == icmp->data.type3.data.tcp_head.sport &&
      spt->DestPort == icmp->data.type3.data.tcp_head.dport &&
      IP_COMPAER( spt->DestIp, icmp->data.type3.ip_head.dIP ) == 0 )
    {
      snd_mbx( spt->mid, (T_MSG *)ipr );
      return;
    }
    spt++;
  }

  /*yAg܂ĂȂAvP[VɘA*/
  spt = socket_pair_table;
  while( spt < &socket_pair_table[ MAX_TCP_PORT_NUM ] )
  {
    if( spt->mid && spt->SelfPort == icmp->data.type3.data.tcp_head.sport )
    {
      snd_mbx( spt->mid, (T_MSG *)ipr );
      return;
    }
    spt++;
  }

  RelMemBlock( ipr );
}

/********************************************************************/
/*  MpPbgۑ̈̓o^                                      */
/*  [U[ŎMpPbg荞ޗ̈pӂB              */
/*  WindowTCÝÃTCYʒmB                      */
/********************************************************************/
void TCPRegistReceiveBufferArea( TcpAddressAndPortInformation *info, void *buffer, int size )
{
  info->TCPRBuffer = (char *)buffer;  /*̈ݒ*/
  info->WindowSz  = size;        /*WindowTCY*/
}

/********************************************************************/
/*  MpPbgۑ̈̍m                                      */
/********************************************************************/
int TCPAnnounceReceiveBufferSize( TcpAddressAndPortInformation *info )
{
  info->state  = TCP_ACK;
  info->SndDataSz = 0;
  info->OptionSz = 0;
  return TCPSend( info );
}

/********************************************************************/
/*  \PbgɎlȊ֐                                          */
/*  ʐM[_̐ڑ𐶐B                                  */
/*  ɏI0ԂAs̓VXeG[ԂB   */
/*  ӁIubLO֐łBMBXLeaseő҂B            */
/*  ԁIˑRƂCLOSED̂܂                                    */
/********************************************************************/
int TCPsocket( TcpAddressAndPortInformation *info )
{
  /*Mp[{bNX̃^*/
  if( (info->mid = MBXLease()) != EOF )  /*[{bNX݂̑oɎsƁAEOFԂB*/
  {
    info->server  = FALSE;      /*NCAgɐݒ肵Ă*/
    *((unsigned long *)info->sip) = 0;  /*lƂĂOĒu*/
    *((unsigned long *)info->dip) = 0;  /*lƂĂOĒu*/
    info->sport    = 0;        /*lƂĂOĒu*/
    info->dport    = 0;        /*lƂĂOĒu*/
    /*TCP֘A*/
    info->tmout    = TMO_FEVR;      /*^CAEgl*/
    info->UrgencyPtr  = 0;      /*ً}|C^FH*/
    info->sequNo    = GetSequenceNumber();  /*V[PXԍFnrŊǗ*/
    info->answerNo    = 0;      /*mFԍFnrŊǗ*/
    info->DestMssSz = MSS_SIZE;      /*ftHg̑ MSSTCYFnrŊǗ*/
    info->callback = (void *)NADR;    /*R[obN֐̃AhXĒu*/

    /*v[Ǘ̈؂󂯂B*/
    info->RcvRecord = GetMemBlock( sizeof(RcvPacketRecord) * RcvPacketRecord_SIZE );
    info->STATES = TCP_STATE_OPENED;  /*OPENED*/
    return 0;  /*[{bNX̑ݏo`FbN*/
  }

  return TCP_SYSTEM_ERROR;
}

/********************************************************************/
/*  CLOSE WAIT֐                                                  */
/*  Iɂ 0ԂB                                        */
/*  Msɂ́ATCP_UNKNOWN_IP_ADDRESS ԂB                   */
/********************************************************************/
static int TCPCloseWait( TcpAddressAndPortInformation *info )
{
  DebugPrint( "CLOSE WAIT\r\n" );
  /*ACK̑M*/
  if( SendWithState( info, TCP_FIN | TCP_ACK, (MSSOptionField *)0 ) != 0 ) return TCP_UNKNOWN_IP_ADDRESS;
  info->STATES = TCP_STATE_LAST_ACK;  /*Xe[g*/
  return 0;
}

/********************************************************************/
/*  LAST ACK֐                                                    */
/*  Iɂ 0ԂB                                        */
/*  Ԑ؂ɂ TCP_TIME_OUTԂB                               */
/*  ҂Ԃ̋ɂ́ATCP_RELOCATE_WAITԂB               */
/*  悩狭ؒf󂯂ꍇɂ́ATCP_DISCONNECTԂB      */
/*  mFԍقȂ鎞ɂ TCP_ILLEGAL_ANSWER_NUMԂB       */
/********************************************************************/
static int TCPLastAck( TcpAddressAndPortInformation *info )
{
  int      RetCode;
  IP_RECORD  *ipr;

  DebugPrint( "LAST ACK\r\n" );

  if( (RetCode = TWaitForState( info, &ipr, TCP_ACK , TCP_TIME_OUT_LIMIT )) == 0 )
  {
    /*mFԍ`FbNB*/
    if( AnswerNumberUpdate( info, ipr ) != 0 ) RetCode = TCP_ILLEGAL_ANSWER_NUM;
    /*LJ*/
    RelMemBlock( ipr );
  }
  return RetCode;
}

/********************************************************************/
/*  FIN WAIT 1֐                                                  */
/*  FIN WAIT 2ACLOSINGB                                 */
/*  Iɂ 0ԂB                                        */
/*  Ԑ؂ɂ TCP_TIME_OUTԂB                               */
/*  ҂Ԃ̋ɂ́ATCP_RELOCATE_WAITԂB               */
/*  悩狭ؒf󂯂ꍇɂ́ATCP_DISCONNECTԂB      */
/*  mFԍقȂ鎞ɂ TCP_ILLEGAL_ANSWER_NUMԂB       */
/********************************************************************/
static int TCPFinWait1( TcpAddressAndPortInformation *info )
{
  int          state,RetCode;
  IP_RECORD      *ipr;
  TCP          *tcp;
  TCP_DATA_FIELD_ACCESS  *tdfa;

  DebugPrint( "FIN WAIT 1\r\n" );
  state = TCP_FIN | TCP_ACK;

  while( 1 )
  {
    /*҂Ԃ̉𒲂ׂB*/
    if( (RetCode = TWaitForState( info, &ipr, state, TCP_TIME_OUT_LIMIT )) < 0 ) return RetCode;

    /*IPATCP̈̐擪AhX擾*/
    tdfa = (TCP_DATA_FIELD_ACCESS *)ipr->data;
    tcp = &tdfa->tcp;
    /*FIN_WAIT_1ł ACKAFIN󂯕tȂ*/
    state = tcp->head.control & TCP_CONTROL_STATE_MASK;
    /*mFԍ`FbNB*/
    if( AnswerNumberUpdate( info, ipr ) != 0 )
    {
      RelMemBlock( ipr );
      return TCP_ILLEGAL_ANSWER_NUM;
    }
    /*LJ*/
    RelMemBlock( ipr );
    if( info->STATES == TCP_STATE_FIN_WAIT_1 )  /*FIN_WAIT_1̎̏*/
    {
      if( state == (TCP_FIN | TCP_ACK) )    /*TIME_WAITɑJڂB*/
      {
        if( SendWithState( info, TCP_ACK, (MSSOptionField *)0 ) != 0 ) return TCP_UNKNOWN_IP_ADDRESS;
        info->STATES = TCP_STATE_TIME_WAIT;    /*Xe[g*/
        return 0;
      }
      else if( state == TCP_ACK )        /*FIN_WAIT_2ɑJڂB*/
      {
        DebugPrint( "FIN WAIT 2\r\n" );
        state = TCP_FIN;          /*̑҂*/
        info->STATES = TCP_STATE_FIN_WAIT_2;  /*Xe[g*/
      }
      else                  /*CLOSINGɑJڂB*/
      {
        DebugPrint( "CLOSING\r\n" );
        state = TCP_ACK;          /*̑҂*/
        info->STATES = TCP_STATE_CLOSING;  /*Xe[g*/
      }
    }
    else
    {
      if( info->STATES == TCP_STATE_FIN_WAIT_2 )  /*FIN_WAIT_2̎̏*/
      {
        if( SendWithState( info, TCP_ACK, (MSSOptionField *)0 ) != 0 ) return TCP_UNKNOWN_IP_ADDRESS;
      }
      info->STATES = TCP_STATE_TIME_WAIT;    /*Xe[g*/
      return 0;
    }
  }
}

/********************************************************************/
/*  \PbgN[YɎlȊ֐                                  */
/*  TCPZbVI                                               */
/*  ԁIESTABLISHEDAFINMȂǍFIN_WAIT_1A    */
/*  FIN_WAIT_2A܂́ACLOSINGɍsǍTIME_WAIT2TMSL   */
/*  ҂āAIB                                                */
/*  AvP[VN[YꍇL̂ŁAӁI        */
/********************************************************************/
int TCPclose( TcpAddressAndPortInformation *info )
{
  int    i;
  int    RetCode = 0;
  const unsigned int  timer[] = {1000,3000,5000,10000,30000,50000,50000,10};  /*AAŌ̃[v͗LłȂB*/

  if( info->STATES == TCP_STATE_CLOSED ) return RetCode;

  switch ( info->STATES )
  {
    /*悩ZbṼN[Y󂯂ꍇ*/
    case TCP_STATE_CLOSE_WAIT :
      info->STATES = TCP_STATE_CLOSE_WAIT;  /*Xe[g*/
      if( (RetCode = TCPCloseWait( info )) == 0 )
      {
        info->STATES = TCP_STATE_LAST_ACK;  /*Xe[g*/
        RetCode = TCPLastAck( info );
      }
      break;
    /*ESTABLISHEDZbṼN[Ysꍇ*/
    case TCP_STATE_ESTABLISHED :
    /*SYN_RCVDAvP[VZbVN[Y鎞*/
    case TCP_STATE_SYN_RCVD :
      for( i = 0, RetCode = EOF; i < (sizeof(timer) / sizeof(unsigned int)) - 1; i++ )
      {
        if( (RetCode = SendWithState( info, TCP_FIN | TCP_ACK, (MSSOptionField *)0 )) != 0 ) break;  /*Ms͏d*/

        /*Xe[g*/
        info->STATES = TCP_STATE_FIN_WAIT_1;

        if( (RetCode = TCPFinWait1( info )) == 0 )
        {
          DebugPrint( "TIME WAIT\r\n" );
          /********************************************************************/
          /*  {͂2TMSL(TWO_MSL_TIME)̑҂KvLB     */
          /*  Ȃɒԑ҂̂́AŌFINɑ΂ACK    */
          /*  ꂽꍇɁAFINđĂ鎖ɔĂ邩B           */
          /********************************************************************/
          break;
        }
        else if(RetCode == TCP_DISCONNECT || RetCode == TCP_RELOCATE_WAIT) break;  /*I󂯂Ă̂Ń[vEpB*/
        else
        {
          info->sequNo -= 1;  /*V[PXԍ߂BΏÖ@ł͗LB*/
          dly_tsk( timer[i] );  /*҂B*/
        }
      }
      break;
    case TCP_STATE_SYN_SENT :  /*SYN_SENTAvP[VZbVN[Y鎞*/
    default :
      break;
  }
  /*Xe[^X̍XV*/
  info->STATES = TCP_STATE_CLOSED;
  /*\[X̊J*/
  RelSocketPairTable( info->mid, TRUE );  /*\PbgyẢ*/
  dly_tsk( 100 );        /*ZbVIɑĂ[͔j*/
  TCPPurgeMbx( info->mid );  /*spȃbZ[W̃NA*/
  MBXRelease( info->mid );  /*[{bNX̕ԋp*/

  RelMemBlock( info->RcvRecord );  /*Mf[^̊ǗpJB*/

  return RetCode;
}

/********************************************************************/
/*  bindɎlȊ֐                                              */
/*  ʐM[_̃AhX𐶐                                */
/*  ɕԂ̂łOԂB                                  */
/*  ԁIˑRƂCLOSED̂܂                                    */
/********************************************************************/
int TCPbind( TcpAddressAndPortInformation *info )
{
  /*IPAhX̐ݒAȌꍇ̓VXeŌ肷*/
  if( info->sip[3] == 0 && info->sip[2] == 0 && info->sip[1] == 0 && info->sip[0] == 0 )
  {
    IP_COPY( info->sip, ThisIs );
  }

  /*T[o[*/
  info->server = TRUE;
  return 0;
}

/********************************************************************/
/*  listenɎlȊ֐                                            */
/*  |[gpbVuHɂBȍ~Y|[gLɂȂB      */
/*  펞͂OAY|[g擾łȂ́|PԂB            */
/*  ԁIOPENEDLISTENɑJ                                    */
/********************************************************************/
int TCPlisten( TcpAddressAndPortInformation *info )
{
  if( info->STATES != TCP_STATE_OPENED ) return EOF;

  if( RegistSocketPairTable( info ) == 0 )
  {
    info->STATES = TCP_STATE_LISTEN;
    return 0;
  }
  else return EOF;
}

/********************************************************************/
/*  TCPZbVJnBT[o[pB                           */
/*  RubLOC^tF[X                                  */
/*  Iɂ 0ԂB                                        */
/*  Ԑ؂ɂ́ATCP_TIME_OUT ԂB                             */
/*  ҂Ԃ̋ɂ́ATCP_RELOCATE_WAITԂB               */
/*  ԁIT[o[[ĥ݁ALISTENSYN_RCVDoRāA        */
/*  ESTABLISHEDɑJڂB                                         */
/*  pbVuI[v̎̂݁ARSTḾALISTENɑJڂB */
/*  ȂXpQbeB                                              */
/********************************************************************/
int TCPaccept( TcpAddressAndPortInformation *info )
{
#define  SYN_ACK_RETRY_LIMIT    6
  int          RetCode;
  int          SYN_ACK_Retry_Count = 0;
  IP_RECORD      *ipr;
  TCP          *tcp;
  TCP_DATA_FIELD_ACCESS  *tdfa;
  MSSOptionField    MOF;
  RST_INFORMATION    rst_info;
#ifdef DEBUG_MODE
  char  buf[64];
#endif

  while( 1 )
  {
    DebugPrint( "LISTEN\r\n" );
    /*肩SYN҂*/
    if( (RetCode = WaitForState( info, &ipr, TCP_SYN )) < 0 ) return RetCode;  /*VXeG[A҂Ԃ̉̂ǂꂩB*/

SYN_Retry:
    /*mFԍ̍XVBł͑肩̃V[PXԍ󂯎邾B*/
    AnswerNumberUpdate( info, ipr );
    /*̊l*/
    tdfa = (TCP_DATA_FIELD_ACCESS *)ipr->data;
    tcp = &tdfa->tcp;
    info->DestMssSz = GetMSSSize( tcp );  /* MSSTCYFnrŊǗ*/
    /*IPAhXA|[gԍRs[*/
    IP_COPY( info->dip, tdfa->c_sum.sip );
    info->dport = tcp->head.sport;
    DebugPrintPara4("    DIP=%u.%u.%u.%u ",info->dip[0],info->dip[1],info->dip[2],info->dip[3]);
    DebugPrintPara1("DPORT=%u\r\n",info->dport);
    /*[{bNXJ*/
    RelMemBlock( ipr );
    /*sppPbg̃NA*/
    TCPPurgeMbx( info->mid );

    /*IvV̈̐ݒ*/
SYN_ACK_Retry:
    MOF.kind    = THE_MSS_SIZE;    /*IvVtB[h̎(lrrTCY)w*/
    MOF.len      = sizeof( MOF );  /* MSSIvṼTCYw*/
    MOF.mss      = MSS_SIZE;
    /*SYNAACK̑M*/
    SendWithState( info, TCP_SYN | TCP_ACK, &MOF );
    /*Xe[g*/
    info->STATES = TCP_STATE_SYN_RCVD;

    DebugPrint( "SYN_RCVD\r\n" );
    /*肩ACK҂*/
    if( (RetCode = TWaitForState( info, &ipr, TCP_PSH | TCP_ACK, 10000 )) < 0 )
    {  /*10bƌɂ͍͖B*/
      if( RetCode == TCP_TIME_OUT )
      {  /*炪SYNAACKBȂ̂A瑗ACKBȂ̂fłȂ̂ŁAđsB*/
        if( ++SYN_ACK_Retry_Count >= SYN_ACK_RETRY_LIMIT ) return RetCode;  /*AvP[VłABORTKv*/
        info->sequNo--;
        goto SYN_ACK_Retry;
      }
      else if( RetCode == TCP_RETRY_SYN ) goto SYN_Retry;
      else if( RetCode == TCP_DISCONNECT || RetCode == TCP_SEND_RST || RetCode == TCP_IGNOER_RST )
      {
        return TCP_DISCONNECT;
      }
      else break;  /*ȊÕG[̏ꍇ́Å֐߂B*/
    }
    else
    {
      /*IPATCP̈̐擪AhX擾*/
      tdfa = (TCP_DATA_FIELD_ACCESS *)ipr->data;
      tcp = &tdfa->tcp;

      /*̒iKł́AACKPSH󂯕tȂB*/
      if( tcp->head.control & TCP_PSH ||
        (tdfa->c_sum.Length - ((tcp->head.control >> TCP_CONTROL_LENGTH_SIFT_SZ) << 2)) )
      {
        info->STATES = TCP_STATE_ESTABLISHED;
        /*̏(SYN_RCVD)ł́Af[^łȂ̂ŁA[{bNXgāAESTABLISHEDɓnĂ܂B*/
        snd_mbx( info->mid, (T_MSG *)ipr );
        break;  /*RlNVm*/
      }

      /*[JŊ҂鑊V[PXԍƁAۂɑėV[PXԍ̔rAyэXVB*/
      if( AnswerNumberUpdate( info, ipr ) == 0 )  /*mFԍmFĂB*/
      {
        info->STATES = TCP_STATE_ESTABLISHED;  /*ʏ̎Xe[g*/
        RelMemBlock( ipr );    /*[{bNXJ*/
        break;  /*RlNVm*/
      }
      else
      {
        IP_COPY( rst_info.dip, info->dip );
        IP_COPY( rst_info.sip, info->sip );
        rst_info.dport = info->dport;
        rst_info.sport = info->sport;
        *((unsigned short *)&rst_info.seq + 0) = tcp->head.AckNum.H;
        *((unsigned short *)&rst_info.seq + 1) = tcp->head.AckNum.L;
        /*acceptŃf[^Mł悤ɂ̂Ȃ΁ÃTCYmFԍXVKvB*/
        *((unsigned short *)&rst_info.ack + 0) = tcp->head.SequNum.H;
        *((unsigned short *)&rst_info.ack + 1) = tcp->head.SequNum.L;
        RelMemBlock( ipr );  /*v[̊J*/
        RSTTransmit( &rst_info, TCP_ACK );
      }
    }

    RelSocketPairTable( info->mid, FALSE );  /*݊mĂ\PbgyȂ̉*/
    dly_tsk( 100 );              /*ZbVIɑĂ[͔j*/
    TCPPurgeMbx( info->mid );        /*[{bNX̃p[W*/
    info->STATES = TCP_STATE_LISTEN;    /*Xe[g߂*/
  }

  return RetCode;
}

/********************************************************************/
/*  TCPZbVI[vB̊֐ɓ鎞̃Xe[gœ   */
/*  ςB                                                      */
/*  Iɂ 0ԂB                                        */
/*  擞Bs\ɂ́ATCP_UNREACHABLE_PORT ԂB               */
/*  Ԑ؂ɂ́ATCP_TIME_OUT ԂB                             */
/*  Msɂ́ATCP_UNKNOWN_IP_ADDRESS ԂB                   */
/*  悩狭ؒf󂯂ɂ́ATCP_DISCONNECT ԂB       */
/********************************************************************/
int TCPconnect( TcpAddressAndPortInformation *info )
{
  int          tmout,state,RetCode;
  IP_RECORD      *ipr;
  TCP          *tcp;
  TCP_DATA_FIELD_ACCESS  *tdfa;
  MSSOptionField    MOF;
  RST_INFORMATION    rst_info;
  static const TMO  TimeOutPeriod[] = {6000,24000,50000};

  /*IPAhX̐ݒAbindĂȂ sip͂ONAĂ*/
  if( info->sip[3] == 0 && info->sip[2] == 0 && info->sip[1] == 0 && info->sip[0] == 0 )
  {
    IP_COPY( info->sip, ThisIs );
  }

  /*|[g̎؂oAbindĂȂ sport͂ONAĂ*/
  if( info->sport == 0 ) info->sport = GetPortNumber();
  if( RegistSocketPairTable( info ) != 0 )
  {
    DebugPrint( "TCP:No room for port.\r\n" );
    return TCP_SYSTEM_ERROR;
  }

  while( 1 )
  {
    DebugPrint( "SYN_SENT\r\n" );
    /*IvV̈̐ݒ*/
    MOF.kind    = THE_MSS_SIZE;    /*IvVtB[h̎(lrrTCY)w*/
    MOF.len      = sizeof( MOF );  /* MSSIvṼTCYw*/
    MOF.mss      = MSS_SIZE;

#if 0
    /********************************************************************/
    /*  LISTENf[^MJnĂɗꍇLB̎    */
    /*  SYN_RCVDɑJڂB                                            */
    /********************************************************************/
    if( info->server == TRUE )
    {
      return TCPaccept( info );
    }
#endif

    /********************************************************************/
    /*  REGCnhVF[N                                          */
    /* SYN ACK҂́A6bA24bōđA80b܂ő҂                   */
    /********************************************************************/
    for( tmout = 0; tmout < sizeof(TimeOutPeriod) / sizeof(TMO); tmout++ )
    {
      /*SYN̑M*/
      if( SendWithState( info, TCP_SYN, &MOF ) != 0 ) return TCP_UNKNOWN_IP_ADDRESS;
      else info->STATES = TCP_STATE_SYN_SENT;  /*SYN_SENTɑJ*/

      RetCode = TWaitForState( info, &ipr, TCP_SYN | TCP_ACK, TimeOutPeriod[tmout] );

      if( RetCode == TCP_TIME_OUT || RetCode == TCP_SEND_RST || RetCode == TCP_IGNOER_RST ) info->STATES = TCP_STATE_OPENED;  /*OPENDɖ߂*/
      else if( RetCode < 0 ) return RetCode;
      else break;
    }

    /*[v𔲂ėR𒲂ׁARST̑MƁA^CAEg̎͏ʂɖ߂B*/
    if( RetCode == TCP_TIME_OUT || RetCode == TCP_SEND_RST || RetCode == TCP_IGNOER_RST ) return RetCode;

    /*IPATCP̈̐擪AhX擾*/
    tdfa = (TCP_DATA_FIELD_ACCESS *)ipr->data;
    tcp = &tdfa->tcp;

    /*ڑԂ̎擾*/
    state = tcp->head.control & TCP_CONTROL_STATE_MASK;
    if( state & TCP_ACK )
    {
      if( AnswerNumberUpdate( info, ipr ) == 0 )  /*mFԍmFĂB*/
      {
        /* MSSTCY擾FnrŊǗ*/
        info->DestMssSz = GetMSSSize( tcp );
        /*[{bNXJ*/
        RelMemBlock( ipr );
        /*ʏ̎Xe[g*/
        info->STATES = TCP_STATE_ESTABLISHED;
      }
      else
      {
        DebugPrint( "TCP:Illegal Answer Number.\r\n" );
        IP_COPY( rst_info.dip, info->dip );
        IP_COPY( rst_info.sip, info->sip );
        rst_info.dport = info->dport;
        rst_info.sport = info->sport;
        *((unsigned short *)&rst_info.seq + 0) = tcp->head.AckNum.H;
        *((unsigned short *)&rst_info.seq + 1) = tcp->head.AckNum.L;
        *((unsigned short *)&rst_info.ack + 0) = tcp->head.SequNum.H;
        *((unsigned short *)&rst_info.ack + 1) = tcp->head.SequNum.L;
        RelMemBlock( ipr );  /*v[̊J*/
        if( state & TCP_SYN ) rst_info.ack++;
        RSTTransmit( &rst_info, TCP_ACK );
        RelSocketPairTable( info->mid, FALSE );  /*\PbgyẢ*/
        info->STATES = TCP_STATE_OPENED;
        continue;
      }
    }
    /*ACK̑M*/
    if( SendWithState( info, TCP_ACK, (MSSOptionField *)0 ) != 0 ) return TCP_UNKNOWN_IP_ADDRESS;

    return 0;
  }
}

/********************************************************************/
/*  MSSIvVtB[hMSS擾B                      */
/*  Ɏ擾łMSSTCYԂAُ펞̓ftHgl       */
/********************************************************************/
static unsigned short GetMSSSize( TCP *tcp )
{
  unsigned short  size;
  unsigned char  *ptr;
  int        limit;

  /*IvVtB[h݂鎖mFB*/
  if( (tcp->head.control >> TCP_CONTROL_LENGTH_SIFT_SZ) <= 5 ) return MSS_SIZE;  /*MSS擾łȂ̑΍*/

  limit = ((tcp->head.control >> TCP_CONTROL_LENGTH_SIFT_SZ) << 2) - 20;

  ptr = (unsigned char *)tcp->data;  /*IvV̈̃AhX擾*/
  while( ptr < ((unsigned char *)tcp->data + limit) )  /*IvVtB[h̏TCYȉ̎*/
  {
    if( *ptr == 0x02 ) break;    /*MSSTCYtB[ho*/
    if( *ptr == 0x01 ) ptr++;    /*NOP*/
    else ptr += *(ptr + 1);
  }
  if( ptr == ((unsigned char *)tcp->data + 20) ) return MSS_SIZE;  /*~bgo*/
  *((unsigned char *)&size + 0) = *(ptr + 2);    /*TCY擾*/
  *((unsigned char *)&size + 1) = *(ptr + 3);

  return ( size ) ? size : MSS_SIZE;
}

/********************************************************************/
/*  TCPV[PXԍ                                           */
/*  V[PXԍƊmFԍ̔āA΂OA        */
/*  V[PXԍsĂ鎞͐̒lAtsĂ鎞͕̒l  */
/*  ԂB                                                        */
/********************************************************************/
static int AnswerNumberUpdate( TcpAddressAndPortInformation *info, IP_RECORD *ipr )
{
  unsigned short  RcvSz;
  unsigned long  DestsequNo;
  TCP_DATA_FIELD_ACCESS  *tdfa;
  TCP          *tcp;

  tdfa = (TCP_DATA_FIELD_ACCESS *)ipr->data;
  tcp = &tdfa->tcp;
  if( tcp->head.control & (TCP_SYN | TCP_FIN | TCP_ACK) )  /*SYNAFINAACK̎ԍ̍XV͖B*/
  {
    /*V[PXԍ擾FnrŊǗ*/
    *((volatile unsigned short *)&DestsequNo + 0) = tcp->head.SequNum.H;
    *((volatile unsigned short *)&DestsequNo + 1) = tcp->head.SequNum.L;

    if( tcp->head.control & TCP_SYN ){}  /*AV[PẌԍŏ͕KԈႤ*/
    else
    {
      /*mFԍ̊mF*/
      if( info->answerNo != DestsequNo )
      {
        /*҂mFԍƎۂɎ󂯂ԍقȂ鎞*/
        DestsequNo -= info->answerNo;
        if( DestsequNo < 0x80000000 ) SCI_Putc( SCI_1, '+' );
        else SCI_Putc( SCI_1, '-' );
        return ( DestsequNo < 0x80000000 ) ? 1 : -1;
      }
    }

    /*EChETCYRs[*/
    info->DestWindowSz  = tcp->head.WindowSize;
    /*Mf[^TCY擾*/
    RcvSz = tdfa->c_sum.Length - ((tcp->head.control >> TCP_CONTROL_LENGTH_SIFT_SZ) << 2);

    /*葤WindowTCY𖳎āA傫ȃf[^𑗂ėꍇA*/
    /*obt@̈敪荞ŁAc͔jBmFł́A󂯎B*/
    info->RcvDataSz = ( RcvSz < info->WindowSz ) ? RcvSz : info->WindowSz;

    if( info->RcvDataSz )
    {
      info->answerNo = DestsequNo + info->RcvDataSz;  /*mFԍ͑̃V[PXԍvXMTCY*/
      if( info->WindowSz ) info->WindowSz -= info->RcvDataSz;  /*WindowTCY̍XV*/
    }

    if( tcp->head.control & (TCP_SYN | TCP_FIN) )
      info->answerNo = DestsequNo + 1;  /*mFԍ͑̃V[PXԍvXP*/
  }

  return 0;
}

/********************************************************************/
/*  TCPV[PXԍ                                           */
/*  V[PXԍ̍XV                                        */
/********************************************************************/
static void WriteSequenceNumberUpdate( TcpAddressAndPortInformation *info, int size )
{
  /*V[PXԍ̍XV*/
  if( size )
  {
    info->sequNo += size;  /*f[^𑗐ḾAvXf[^TCY*/
  }
  else
  {
    if( info->state & (TCP_SYN | TCP_FIN) )  /*Xe[^X ACK̎*/
      info->sequNo += 1;      /*V[PXԍ̓f[^𑗐MȂ́AvXP*/
  }
}

/********************************************************************/
/*  V[PXԍ̏l𓾂B                                  */
/*  RFC793ǂނƁA4ʕbIōXV32bit^C}[zw肵  */
/*  B256{đ̂ʂ̒lƂB                           */
/********************************************************************/
static unsigned long GetSequenceNumber( void )
{
  SYSTIM      RefTime;

  get_tim( &RefTime );

  return RefTime.ltime << 8;
}

/********************************************************************/
/*  |[gԍ𓾂B                                              */
/*  ߂l̓|[gԍ                                              */
/********************************************************************/
static unsigned short GetPortNumber( void )
{
  static unsigned short port = 1024;
  unsigned short  PortNumber;

  dis_dsp();
  PortNumber = port++;
  port = (port > 5000) ? 1024 : port;
  ena_dsp();

  return PortNumber;
}

/********************************************************************/
/*  CLOSED                                                  */
/*  ȍ~̃ZbV𒆎~AZbVCLOSEDɖ߂B        */
/*                                                                  */
/*  2008/08/07 RST̎Mɑ΂RSTȂlɕύXB       */
/********************************************************************/
void TCPForceCloseState( TcpAddressAndPortInformation *info )
{
  RST_INFORMATION rst_info;

  if( info->STATES != TCP_STATE_CLOSED )
  {
    if( info->STATES != TCP_STATE_OPENED )  /*TCP_STATE_OPENED̏Ԃł́A\PbgyÅmsĂȂ*/
    {
      /*RSTpPbg̑M*/
      IP_COPY( rst_info.dip, info->dip );
      IP_COPY( rst_info.sip, info->sip );
      rst_info.dport = info->dport;
      rst_info.sport = info->sport;
      rst_info.seq = info->sequNo;
      rst_info.ack = info->answerNo;
      RSTTransmit( &rst_info, TCP_ACK );
    }

    /*Xe[^X̍XV*/
    info->STATES = TCP_STATE_CLOSED;
    RelSocketPairTable( info->mid, TRUE );  /*\PbgyẢ*/
    dly_tsk( 2000 );      /*ZbVIɑĂ[͔j*/
    TCPPurgeMbx( info->mid );  /*[{bNX̃p[W*/
    MBXRelease( info->mid );  /*[{bNX̕ԋp*/
    RelMemBlock( info->RcvRecord );  /*Mf[^̊ǗpJB*/
  }
}

/********************************************************************/
/*  CLOSED                                                  */
/*  ȍ~̃ZbV𒆎~AZbVCLOSEDɖ߂B        */
/*                                                                  */
/*  2008/08/07 RST̎Mɑ΂RSTȂlɕύXB       */
/********************************************************************/
void TCPForceCloseStateWithoutRST( TcpAddressAndPortInformation *info )
{
  RST_INFORMATION rst_info;

  if( info->STATES != TCP_STATE_CLOSED )
  {
    /*Xe[^X̍XV*/
    info->STATES = TCP_STATE_CLOSED;
    RelSocketPairTable( info->mid, TRUE );  /*\PbgyẢ*/
    dly_tsk( 2000 );      /*ZbVIɑĂ[͔j*/
    TCPPurgeMbx( info->mid );  /*[{bNX̃p[W*/
    MBXRelease( info->mid );  /*[{bNX̕ԋp*/
    RelMemBlock( info->RcvRecord );  /*Mf[^̊ǗpJB*/
  }
}

/********************************************************************/
/*  nhVF[N҂֐                                          */
/*  stateɊYԂė̂҂A҂ȂԂ */
/*  ́ARSTŉ킷B                                           */
/*  AAACK͌mȂB                                         */
/*  Ɏ󂯎́ATCPt[̐擪ԒnԂB             */
/*  Ԑ؂̎́ANADRԂB                                    */
/********************************************************************/
static int TWaitForState( TcpAddressAndPortInformation *info, IP_RECORD **ipr, int check_state, TMO tmout )
{
  int        state;
  unsigned long  rcv_ansnum,rcv_seqnum;
  TCP_DATA_FIELD_ACCESS  *tdfa;
  TCP        *tcp;
  RST_INFORMATION  rst_info;
  ER  ercd;

  /*悩̉҂*/
  ercd = trcv_mbx( info->mid, (T_MSG **)ipr, tmout );
  if( ercd == E_OK )
  {
    if( (*ipr)->handle >= ICMP_TYPE3_CODE15_ERROR && (*ipr)->handle <= ICMP_TYPE3_CODE0_ERROR )
    {
      RelMemBlock( (*ipr) );  /*[{bNXJ*/
      return TCP_UNREACHABLE_PORT;  /*ICMPŃG[Aė*/
    }

    /*IPATCP̈̐擪AhX擾*/
    tdfa = (TCP_DATA_FIELD_ACCESS *)(*ipr)->data;
    tcp = &tdfa->tcp;

    /*M̃Xe[^X擾*/
    state = tcp->head.control & TCP_CONTROL_STATE_MASK;

    /*mFԍƃV[PXԍ̎擾*/
    *((unsigned short *)&rcv_ansnum + 0) = tcp->head.AckNum.H;
    *((unsigned short *)&rcv_ansnum + 1) = tcp->head.AckNum.L;
    *((unsigned short *)&rcv_seqnum + 0) = tcp->head.SequNum.H;
    *((unsigned short *)&rcv_seqnum + 1) = tcp->head.SequNum.L;

    switch ( check_state )
    {
      case (TCP_SYN) :
        return 0;  /*Ƀ\PbgyAtB^[Ń`FbNĂ邩B*/

      case (TCP_SYN | TCP_ACK) :  /*SYN_SENT*/
      case (TCP_PSH | TCP_ACK) :  /*SYN_RCVD*/
        if( state & TCP_RST )
        {
          RelMemBlock( (*ipr) );  /*[{bNXJ*/
          TCPForceCloseStateWithoutRST( info );
          return TCP_DISCONNECT;
        }
        else if( check_state == (TCP_PSH | TCP_ACK) && state == TCP_SYN )
        {  /*RlNVSYN̍ē̏*/
          return TCP_RETRY_SYN;
        }
        else if(
          (check_state == (TCP_SYN | TCP_ACK) && state != (TCP_SYN | TCP_ACK)) ||
          (check_state == (TCP_PSH | TCP_ACK) && !(state & (TCP_PSH | TCP_ACK))) ||
          info->sequNo != rcv_ansnum )
        {
          IP_COPY( rst_info.dip, info->dip );
          IP_COPY( rst_info.sip, info->sip );
          rst_info.dport = info->dport;
          rst_info.sport = info->sport;
          rst_info.seq = rcv_ansnum;  /*V[PXԍ͑mFԍ*/
          rst_info.ack = rcv_seqnum;
          RelMemBlock( (*ipr) );  /*v[J*/
          if( state & (TCP_SYN | TCP_FIN) ) rst_info.ack++;
          RSTTransmit( &rst_info, TCP_ACK );
          return TCP_SEND_RST;  /*̌ASYN,ACK҂JԂKvB*/
        }
        else return 0;

      case (TCP_FIN | TCP_ACK) :
      case (TCP_FIN) :
      case (TCP_ACK) :
      default :
        if( state & TCP_RST )  /*芸RSTMɂ͐ڑ*/
        {
          RelMemBlock( (*ipr) );  /*[{bNXJ*/
          TCPForceCloseStateWithoutRST( info );
          return TCP_DISCONNECT;
        }
        break;
    }

    return 0;  /*Ɏ擾*/
  }
  else if( ercd == E_RLWAI ) return TCP_RELOCATE_WAIT;
  else if( ercd == E_TMOUT ) return TCP_TIME_OUT;
  else return TCP_SYSTEM_ERROR;
}

/********************************************************************/
/*  nhVF[NM֐                                          */
/*  stateԂ𑗂B                                           */
/*  ACK𑗐M鎞́AV[PXԍ𐧌䂷B                   */
/*  ɑMoꍇ́AOԂB                              */
/*  ɑMoȂꍇ́A̐ԂB                  */
/********************************************************************/
static int SendWithState( TcpAddressAndPortInformation *info, unsigned char state, MSSOptionField *mof )
{
  int  ret;

  info->OptionSz = (mof == (MSSOptionField *)0) ? 0 : sizeof(MSSOptionField);  /*IvVTCYFnrŊǗ*/
  info->OptionArea = (void *)mof;
  info->SndDataSz = 0;  /*Mf[^TCY*/
  info->state  = state;  /*SEND STATE*/
  if( (ret = TCPSend( info )) == 0 ) SequenceNumberUpdate( info );

  return ret;
}

/********************************************************************/
/*  [{bNX̕spȃ[NA                            */
/********************************************************************/
static void TCPPurgeMbx( ID mid )
{
  IP_RECORD      *ipr;

  while( prcv_mbx(mid, (T_MSG **)&ipr) == E_OK ) RelMemBlock( ipr );
}

/********************************************************************/
/*  MpPbgR[h̏                                */
/*  state0NAĒuB                                        */
/********************************************************************/
static void TCPReadPacketRecordInit( RcvPacketRecord record[] )
{
  RcvPacketRecord *ptr = record;

  while( ptr < &record[ RcvPacketRecord_SIZE ] )
  {
    ptr->state = 0;
    ptr++;
  }
}

static int CopyFromPacketToRcvBuffer( COPY_FROM_PACKET_TO_RCVBUFFER_INFO *info );
static int RegistPacketToTable( COPY_FROM_PACKET_TO_RCVBUFFER_INFO *info );
static void swap( RcvPacketRecord *A, RcvPacketRecord *B );
static unsigned long FindLastSequenceNumberFromTable( COPY_FROM_PACKET_TO_RCVBUFFER_INFO *copy_info, unsigned char *state, unsigned short *WinSz, unsigned long *AnsNum );

/********************************************************************/
/*  Mobt@Ƀf[^Rs[                                */
/*  ߂lɂ́ARs[Ȃ0ԂARs[łȂEOF    */
/*  B                                                            */
/********************************************************************/
static int CopyFromPacketToRcvBuffer( COPY_FROM_PACKET_TO_RCVBUFFER_INFO *copy_info )
{
  unsigned long offset;

  /*MTCY0̎A܂Xe[^X݂̂̏ꍇ̏B*/
  if( copy_info->pktSz == 0 ) return 0;

  /*V[PXԍ̃ItZbgvZ*/
  offset = copy_info->pktSeq - copy_info->original_seq;
  /*Mobt@ɃRs[\ׂ*/
  if( copy_info->rcvSz < (offset + copy_info->pktSz) ) return EOF;
  /*Rs[*/
  memcpy( (char *)copy_info->rcvBuf + offset, (char *)copy_info->pktBuf, copy_info->pktSz );

  return 0;
}

/********************************************************************/
/*  Mobt@ɃRs[łpPbg̏o^B          */
/*  ̈sœo^łȂ́AEOFԂB                 */
/*  o^ł́Az̔ԍ(̐l)ԂB                  */
/********************************************************************/
static int RegistPacketToTable( COPY_FROM_PACKET_TO_RCVBUFFER_INFO *copy_info )
{
  int  i;
  RcvPacketRecord  *record;

  /*V[PXԍ̃R[hB*/
  record = copy_info->record;
  for( i = 0; i < RcvPacketRecord_SIZE; i++ )
  {
    /*󂫂ł͖R[hłȂAV[PXԍvĂꏊ*/
    if( record->state != 0 && record->sequ  == copy_info->pktSeq )  /*L^ꂽ̈ɂ́AKstate0ȊOƂȂB*/
    {
      /*̃R[hɑ΂ď㏑sB*/
      record->state = copy_info->state;
      record->size = copy_info->pktSz;
      record->WindowSz = copy_info->WindowSz;
      record->AnsNum = copy_info->AnsNum;
      return i;
    }
    record++;
  }

  record = copy_info->record;
  for( i = 0; i < RcvPacketRecord_SIZE; i++ )
  {
    /*󂫗̈̌*/
    if( record->state == 0 )
    {
      /*R[hɓo^sB*/
      record->state = copy_info->state;
      record->sequ = copy_info->pktSeq;
      record->size = copy_info->pktSz;
      record->WindowSz = copy_info->WindowSz;
      record->AnsNum = copy_info->AnsNum;
      return i;
    }
    record++;
  }

  return EOF;
}

/********************************************************************/
/*  SWAP                                                        */
/*  A̗vfB̗vfւB                                  */
/********************************************************************/
static void swap( RcvPacketRecord *A, RcvPacketRecord *B )
{
  RcvPacketRecord  temp;

  temp = *A;
  *A = *B;
  *B = temp;
}

/********************************************************************/
/*  o^ς݂̃R[h̒AAĂV[PXԍ̈    */
/*  Ō̔ԍ𒲂ׂB                                            */
/*  o^ł́AŌ̃V[PXԍɎMpPbg̃f[^    */
/*  ZĕԂB                                                  */
/*  ̖߂l͊mFԍƂėpłB                      */
/********************************************************************/
static unsigned long FindLastSequenceNumberFromTable( COPY_FROM_PACKET_TO_RCVBUFFER_INFO *copy_info, unsigned char *state, unsigned short *WinSz, unsigned long *AnsNum )
{
  int  i,j;
  unsigned long sequ;
  RcvPacketRecord  *record;

  /*V[PXԍ̐ݒ*/
  sequ = copy_info->original_seq;
  /*MXe[g̏*/
  *state = 0;

  record = copy_info->record;
  for( j = 0; j < RcvPacketRecord_SIZE; j++ )  /*R[hSORT(ouSORT)sׂɁAd̃[vɂȂĂB*/
  {
    for( i = j; i < RcvPacketRecord_SIZE; i++ )
    {
      /*YV[PXԍ̌*/
      if( record[i].state != 0 && record[i].sequ == sequ )  /*LȃR[h݂鎞́Astate0ȊOƂȂĂB*/
      {
        /*V[PXԍ̍XV*/
        sequ = record[i].sequ + record[i].size;  /*f[^TCYAV[PXԍiގɂȂB*/
        /*MXe[g̎擾*/
        *state |= record[i].state;  /*statéALȃR[hSĂ̘_ORB*/
        /*KvȂ΁AŏImFԍWindowTCYRs[B*/
        if( WinSz != 0 ) *WinSz = record[i].WindowSz;
        if( AnsNum != (unsigned long *)0 ) *AnsNum = record[i].AnsNum;
        /*ԂւāAtɑO̕ɈړB*/
        swap( &record[j], &record[i] );
        break;
      }
    }
    /*Y郌R[hׁA[vIB*/
    if( i == RcvPacketRecord_SIZE ) break;
  }

  return sequ;
}

/********************************************************************/
/*  V[PXԍ̐i݁Ax𔻒fBrefɁÃ݂V[P   */
/*  XԍArcvɎ󂯎V[PXԍB                       */
/*  ߂lɐi݂Ȃ琳AxȂ畉Av͂OԂB          */
/********************************************************************/
static int SequenceRagLead( unsigned long ref, unsigned long rcv )
{
  return rcv - ref;
}

/********************************************************************/
/*  M                                                        */
/*  buffeŕAMf[^i[p̗̈AhXłAlen͂̃TCY */
/*  B                                                        */
/*                                                                  */
/*  TCP̏ԂESTABLISHEDłȂɂ̊֐Ă΂ƁA          */
/*  TCP_IS_NOT_ESTABLISHEDԂB                                  */
/*                                                                  */
/*  悩FINMAɃf[^MĂ鎞́A   */
/*  f[^ԂAMf[^́AEOFԂB               */
/*                                                                  */
/*  őɖA悩ICMPG[ḾA              */
/*  TCP_UNREACHABLE_PORTԂB                                    */
/*                                                                  */
/*  悩RSTḾAؒfƂȂ̂ŁATCP_DISCONNECT */
/*  ԂB                                                        */
/*                                                                  */
/*  悩PSHḾA܂ł̎Mf[^ԂB     */
/*                                                                  */
/*  Mf[^lenɒB́A܂ł̎Mf[^ԂB*/
/*                                                                  */
/*  [U[ƎɎM^CAEgԂݒ肵A^CAEg  */
/*  ̎́ATCP_TIME_OUTԂB                                    */
/*                                                                  */
/*  ʃ^XN狭Iɑ҂ԂꂽATCP_RELOCATE_WAIT   */
/*  ԂB                                                        */
/*                                                                  */
/*  悩SYNḾARST𑗐MāA            */
/*  TCP_SEND_RSTԂB                                            */
/*                                                                  */
/*  J[l݂̉^pɖ̂G[́ATCP_SYSTEM_ERRORԂB*/
/********************************************************************/
long TCPread( TcpAddressAndPortInformation *info, void *buffer, unsigned short len )
{
#define    RCV_TIME_OUT  (TCP_TIME_OUT_LIMIT * 3)
  unsigned char    state,need_ack;
  unsigned short    OriginalWindowSz;
  long        RcvByte;
  TMO          tmout;
  COPY_FROM_PACKET_TO_RCVBUFFER_INFO  copy_info;
  RST_INFORMATION    rst_info;
  IP_RECORD      *ipr;
  TCP          *tcp;
  TCP_DATA_FIELD_ACCESS  *tdfa;
  ER          ercd;
  T_RMBX        pk_rmbx;

  /*read́AESTABLISHEDłĂ΂Ȃ*/
  if( info->STATES == TCP_STATE_CLOSE_WAIT ) return EOF;  /*ɑ肩FIN󂯂Ă̂ŁAڑɓB*/
  if( info->STATES != TCP_STATE_ESTABLISHED ) return TCP_IS_NOT_ESTABLISHED;

  /*WindowTCYlen0̎́AM0ԂB*/
  if( len == 0 || info->WindowSz == 0 ) return 0;

  /*    */
  DebugPrint( "rcv ESTABLISHED\r\n" );
  tmout = info->tmout;  /*[U[̎w肵^CAEgԂgpB*/
  copy_info.rcvSz = len;  /*Mobt@̃obt@TCY*/
  copy_info.original_seq = info->answerNo;  /*JnV[PXԍ*/
  copy_info.rcvBuf = buffer;  /*Mobt@̐擪AhX*/
  copy_info.record = info->RcvRecord;  /*R[h̐擪AhX*/
  state = 0;  /*Ԃ0*/
  need_ack = 0;
  RcvByte = 0;
  OriginalWindowSz = info->WindowSz;
  TCPReadPacketRecordInit( info->RcvRecord );  /*MpPbgR[ḧ̗NA*/

  while( 1 )
  {
    /*悩̎M҂*/
    ercd = trcv_mbx( info->mid, (T_MSG **)&ipr, tmout );
    if( ercd == E_OK )  /*ML*/
    {
      /*ICMPG[ɂNł͂ȂmF*/
      if( ipr->handle >= ICMP_TYPE3_CODE15_ERROR && ipr->handle <= ICMP_TYPE3_CODE0_ERROR )
      {
        RelMemBlock( ipr );
        RcvByte = TCP_UNREACHABLE_PORT;  /*TCPł͖őɔȂBA炵̂ŁAꉞĒuB*/
        info->result = TCP_UNREACHABLE_PORT;  /*TCPł͖őɔȂBA炵̂ŁAꉞĒuB*/
        break;
      }

      /*IPATCP̈̐擪AhX擾*/
      tdfa = (TCP_DATA_FIELD_ACCESS *)ipr->data;
      tcp = &tdfa->tcp;

      /*\PbgyAɁASYN̍đ󂯂̏B*/
      if( tcp->head.control & TCP_SYN )
      {
        DebugPrintPara1( "Illegal SYN %02X", tcp->head.control & TCP_CONTROL_STATE_MASK );
        /*RST𑊎ɕԂāAʑRSTԂ`B*/
        IP_COPY( rst_info.dip, info->dip );
        IP_COPY( rst_info.sip, info->sip );
        rst_info.dport = info->dport;
        rst_info.sport = info->sport;
        *((unsigned short *)&rst_info.seq + 0) = tcp->head.AckNum.H;
        *((unsigned short *)&rst_info.seq + 1) = tcp->head.AckNum.L;
        *((unsigned short *)&rst_info.ack + 0) = tcp->head.SequNum.H;
        *((unsigned short *)&rst_info.ack + 1) = tcp->head.SequNum.L;
        RelMemBlock( ipr );  /*v[J*/
        rst_info.ack++;
        RSTTransmit( &rst_info, TCP_ACK );
        RcvByte = TCP_SEND_RST;
        info->result = TCP_SEND_RST;
        break;  /*܂łŃf[^̎ML̎lĂȂB*/
      }

      /*荞񂾃pPbgAf[^Ɋւ𔲂oB*/
      copy_info.state = tcp->head.control & TCP_CONTROL_STATE_MASK;  /*Xe[^X*/
      copy_info.pktSz = tdfa->c_sum.Length - ((tcp->head.control >> TCP_CONTROL_LENGTH_SIFT_SZ) << 2);  /*MpPbg̃f[^TCY*/

      *((volatile unsigned short *)&copy_info.pktSeq + 0) = tcp->head.SequNum.H;  /*MpPbg̃V[PXԍ*/
      *((volatile unsigned short *)&copy_info.pktSeq + 1) = tcp->head.SequNum.L;

      /*ꍇɋẮAV[PXԍt߂肷鎖B̎́Å݂mFԍԂĎ̎MɔB*/
      if( SequenceRagLead( info->answerNo, copy_info.pktSeq ) < 0 )
      {
        RelMemBlock( ipr );    /*L̊J*/
        SendWithState( info, TCP_ACK, (MSSOptionField *)0 );
        continue;
      }

      copy_info.pktBuf = (void *)&tcp->data[ ((tcp->head.control >> TCP_CONTROL_LENGTH_SIFT_SZ) << 2) - TCP_HEADER_SIZE ];  /*MpPbg̃f[^̈̐擪AhX*/
      /*[U[̗pӂobt@ɃpPbg̃f[^Rs[B*/
      if( CopyFromPacketToRcvBuffer( &copy_info ) == 0 ) RegistPacketToTable( &copy_info );
      RelMemBlock( ipr );    /*L̊J*/
      /*mFԍ̍XVBAf[^̉ZsȂ̂ŁAFIN̏ꍇ͕ʓrXVKvƂȂB*/
      info->answerNo = FindLastSequenceNumberFromTable( &copy_info, &state, 0 , 0 );

      RcvByte = info->answerNo - copy_info.original_seq;  /*Mf[^̌vZ*/
      if( OriginalWindowSz <= RcvByte )
        info->WindowSz = 0;    /*0ɂ͂Ȃ*/
      else
        info->WindowSz = OriginalWindowSz - RcvByte;  /*WindowTCY̍XV*/

      /*Xe[gʏ*/
      if( state & TCP_RST )  /*悩狭ؒf󂯂B*/
      {
        /*V[PXԍƂ̖m߂ĂؒfƂׂBΉB*/
        TCPForceCloseStateWithoutRST( info );
        RcvByte = TCP_DISCONNECT;  /*Iؒf󂯂ĂB*/
        info->result = TCP_DISCONNECT;  /*Iؒf󂯂ĂB*/
        break;
      }
      else if( state & TCP_FIN )  /*悩ZbVN[Y󂯂B*/
      {
        info->answerNo++;  /*FIN̏ꍇ́AV[PXԍ1iށB*/
        info->STATES = TCP_STATE_CLOSE_WAIT;  /*Xe[g̍XV*/
        if( RcvByte == 0 ) RcvByte = EOF;
        break;
      }
      else if( (RcvByte >= (long)(len & 0x0000ffff)) || (RcvByte >= (long)(OriginalWindowSz & 0x0000ffff)) )  /*[U[obt@tɂȂB*/
         break;
      else if( state & TCP_PSH )  /*vbVɂȂB*/
      {
        ref_mbx( info->mid, &pk_rmbx );  /*[{bNXQƂāA*/
        if( pk_rmbx.pk_msg == (T_MSG *)0 ) break;  /*ȏ̎M̓[v𔲂B*/
      }
      else
      {
        tmout = 10;  /*M݂̂̏ꍇ́A[vpBAA^CAEgԂݒ肵B*/
        need_ack = 1;
      }
    }
    else
    {
      if( RcvByte == 0 )
      {
        RcvByte = ( ercd == E_TMOUT ) ? TCP_TIME_OUT : ( ercd == E_RLWAI ) ? TCP_RELOCATE_WAIT : TCP_SYSTEM_ERROR;
        info->result = ( ercd == E_TMOUT ) ? TCP_TIME_OUT : ( ercd == E_RLWAI ) ? TCP_RELOCATE_WAIT : TCP_SYSTEM_ERROR;
        break;
        /********************************************************************/
        /*  E_TMOUTAE_RLWAIȊO̎c̃G[R[hƌƁAE_PARAE_IDA */
        /*  E_NOEXSAE_DLTƌȂ邪A݌v~XAJ[l̃oOł  */
        /*  L蓾ȂB                                                    */
        /********************************************************************/
      }
      else if( ercd == E_RLWAI ) break;
      else
      {
        if( need_ack != 0 )
        {
          /********************************************************************/
          /*  X[X^[gtšˍŁAXɓ]ubN𑝂  */
          /*  ėBubNƃubN̊Ԃ̓r؂ꂽԂɁAACKs   */
          /*  KvLB                                                  */
          /********************************************************************/
          SendWithState( info, TCP_ACK, (MSSOptionField *)0 );
          need_ack = 0;
        }
      }
    }
  }

  /*G[ȊȌꍇACKBAACKŃf[^̎ḾA͂ACKȂB*/
  if( RcvByte >= EOF )  /*FINḾAEOFԂ܂ɂȂĂ̂ŁAEOFȏΏۂɂB*/
  {
    if( (state & TCP_FIN) || (RcvByte > 0) ) SendWithState( info, TCP_ACK, (MSSOptionField *)0 );
  }

  return RcvByte;
}

/********************************************************************/
/*  TCPwrite                                                        */
/*  info͐ڑ\́Abuffer͑Mf[^̈            */
/*  len̓f[^̃TCYB                                           */
/*                                                                  */
/*  ߂ĺAIɂ0Af[^M(̐)B           */
/*                                                                  */
/*  FINMA܂łɃf[^MĂꍇɂ̓f[^   */
/*  MԂBf[^̎ḾAEOFԂB           */
/*                                                                  */
/*  擞Bs\ɂ́ATCP_UNREACHABLE_PORT ԂB               */
/*                                                                  */
/*  肩mFԍ̕ԐM̎Ԑ؂ɂ́ATCP_TIME_OUT ԂB */
/*                                                                  */
/*  Msɂ́ATCP_UNKNOWN_IP_ADDRESS ԂB                   */
/*                                                                  */
/*  悩狭ؒf󂯂ɂ́ATCP_DISCONNECT ԂB       */
/*                                                                  */
/*  TCP̏ԂESTABLISEDł͖ɂ̊֐Ă΂ꂽA         */
/*  TCP_IS_NOT_ESTABLISHEDԂBFINMɁAȂ蓾B       */
/*                                                                  */
/*  ʂ̃^XN狭Iɑ҂Ԃ̉sꂽA              */
/*  TCP_RELOCATE_WAITԂB                                       */
/*                                                                  */
/*  悩SYNḾARST𑗐MāA            */
/*  TCP_SEND_RSTԂB                                            */
/*                                                                  */
/*  J[l݂̉^pɖ̂G[́ATCP_SYSTEM_ERRORԂB*/
/********************************************************************/
long TCPwrite( TcpAddressAndPortInformation *info, void *buffer, unsigned short len )
{
  unsigned char  state;
  int    i,tmout;
  unsigned long  DestanswerNo,temp;
  IP_RECORD  *ipr;
  TCP    *tcp;
  TCP_DATA_FIELD_ACCESS  *tdfa;
  static const TMO  TimeOutPeriod[] = {1000,1000,1000,1000,1000};

#define    TRANSMIT_SCENARIO_SIZE  4  /*ő]TCY*/
  TRANSMIT_SCENARIO  scenario[ TRANSMIT_SCENARIO_SIZE ];
  /*f[^M֌W̕ϐ*/
  unsigned short    OriginalWindowSz;
  long        RcvByte;
  COPY_FROM_PACKET_TO_RCVBUFFER_INFO  copy_info;
  RST_INFORMATION    rst_info;
  ER          ercd;

  /*writéAESTABLISHEDłĂ΂Ȃ*/
  if( !(info->STATES == TCP_STATE_ESTABLISHED || info->STATES == TCP_STATE_CLOSE_WAIT) )
  {
    info->result = TCP_IS_NOT_ESTABLISHED;
    return TCP_IS_NOT_ESTABLISHED;
  }

  DebugPrint( "snd ESTABLISHED\r\n" );
  /*f[^M֌W̏*/
  copy_info.rcvSz = info->WindowSz;  /*Mobt@̃obt@TCY*/
  copy_info.original_seq = info->answerNo;  /*̊JnV[PXԍ*/
  copy_info.rcvBuf = info->TCPRBuffer;  /*Mobt@̐擪AhX*/
  copy_info.record = info->RcvRecord;  /*R[h̐擪AhX*/
  RcvByte = 0;
  info->result = 0;
  DestanswerNo = info->sequNo;  /*̊JnV[PXԍ*/
  OriginalWindowSz = info->WindowSz;
  TCPReadPacketRecordInit( info->RcvRecord );  /*MpPbgR[ḧ̗NA*/

  while( len )
  {
    /*WindowTCYƁAMSSxɑMoTCY߂B*/
    /*܂AMv𗧂ĂB*/
    if( info->DestWindowSz )
    {
      for( i = 0; i < TRANSMIT_SCENARIO_SIZE; i++ )
      {
        /*WindowTCYMSSŕBܘ_A[̉\AőȂLB*/
        scenario[i].size = (info->DestWindowSz < info->DestMssSz) ? info->DestWindowSz : info->DestMssSz;
        scenario[i].size = (len < scenario[i].size) ? len : scenario[i].size;  /*Mf[^TCY*/
        scenario[i].AnswerNoNum = (scenario[i].size) ? 1 : 0;  /*đtOݒ*/
        if( i == 0 )
        {
          scenario[0].sequNo = info->sequNo;  /*M̃V[PXԍ*/
          scenario[0].ptr = buffer;  /*obt@̑Mʒu*/
        }
        else
        {
          scenario[i].sequNo = scenario[i - 1].sequNo + scenario[i - 1].size;  /*M̃V[PXԍ*/
          scenario[i].ptr = (void *)((char *)scenario[i - 1].ptr + scenario[i - 1].size);  /*obt@̑Mʒu*/
        }
        len -= scenario[i].size;  /*Mf[^TCY̍ČvZ*/
        info->DestWindowSz -= scenario[i].size;    /*WindowTCYA炷B*/
      }
    }
    else
    {
      DebugPrint("zero\r\n");
      /*悩OLꂽ܂܁AOL̃pPbgXg̑΍􏈗*/
      scenario[0].size = 1;      /*Mf[^TCY*/
      scenario[0].AnswerNoNum = 1;  /*đtOݒ*/
      scenario[0].sequNo = info->sequNo;  /*M̃V[PXԍ*/
      scenario[0].ptr = buffer;    /*obt@̑Mʒu*/
      len -= 1;            /*Mf[^TCY̍ČvZ*/
      dly_tsk( 2000 );  /*҂*/
    }

    /*ɑM*/
    /*IvV́A*/
    info->OptionSz = 0;
    for( i = 0; i < TRANSMIT_SCENARIO_SIZE; i++ )
    {
      if( scenario[i].size == 0 )  break;  /*Mf[^ΏI*/
      info->SndDataSz = scenario[i].size;  /*MTCYw*/
      buffer = (void *)((char *)buffer + scenario[i].size);  /*ǂݏoobt@ʒui߂*/
      /*PSH̐ݒ*/
      info->state  = ( (i == (TRANSMIT_SCENARIO_SIZE - 1))  || (scenario[i].size != info->DestMssSz) ) ? TCP_ACK | TCP_PSH : TCP_ACK;
      info->sequNo = scenario[i].sequNo;  /*V[PXԍw*/
      info->TCPSBuffer = scenario[i].ptr;    /*MJnʒuw*/
      if( TCPSend( info ) == IPLAYERTRANSMIT_UNKNOWN_IP )  /*pPbg̑MƁÃUgR[h̉*/
      {
        info->sequNo = DestanswerNo;  /*V[PXԍ߂*/
        info->WindowSz = OriginalWindowSz;  /*WindowTCY߂*/
        info->result = TCP_UNKNOWN_IP_ADDRESS;
        return TCP_UNKNOWN_IP_ADDRESS;
      }
      info->sequNo += info->SndDataSz;
    }

    /*mF̎M*/
    do
    {
      /*^CAEgtŁAM҂*/
      for( tmout = 0; tmout < sizeof(TimeOutPeriod) / sizeof(TMO); tmout++ )
      {
        /*MACKɎMpPbg̏*/
        ercd = trcv_mbx( info->mid, (T_MSG **)&ipr, TimeOutPeriod[ tmout ] );
        if( ercd == E_OK )  /*ML*/
        {
          while( 1 )
          {
            /*IPATCP̈̐擪AhX擾*/
            tdfa = (TCP_DATA_FIELD_ACCESS *)ipr->data;
            tcp = &tdfa->tcp;

            /*\PbgyAɁASYN̍đ󂯂̏B*/
            if( tcp->head.control & TCP_SYN )
            {
              /*RST𑊎ɕԂāAʑRSTԂ`B*/
              IP_COPY( rst_info.dip, info->dip );
              IP_COPY( rst_info.sip, info->sip );
              rst_info.dport = info->dport;
              rst_info.sport = info->sport;
              *((unsigned short *)&rst_info.seq + 0) = tcp->head.AckNum.H;
              *((unsigned short *)&rst_info.seq + 1) = tcp->head.AckNum.L;
              *((unsigned short *)&rst_info.ack + 0) = tcp->head.SequNum.H;
              *((unsigned short *)&rst_info.ack + 1) = tcp->head.SequNum.L;
              RelMemBlock( ipr );  /*v[J*/
              rst_info.ack++;
              RSTTransmit( &rst_info, TCP_ACK );
              info->result = TCP_SEND_RST;  /*ŎML̎lĂȂB*/
              return TCP_SEND_RST;  /*ŎML̎lĂȂB*/
            }

            /*̊mFԍ擾*/
            *((unsigned short *)&copy_info.AnsNum + 0) = tcp->head.AckNum.H;
            *((unsigned short *)&copy_info.AnsNum + 1) = tcp->head.AckNum.L;
            /*WindowTCY擾*/
            copy_info.WindowSz = tcp->head.WindowSize;
            /*荞񂾃pPbgAf[^Ɋւ𔲂oB*/
            copy_info.state = tcp->head.control & TCP_CONTROL_STATE_MASK;  /*Xe[^X*/
            copy_info.pktSz = tdfa->c_sum.Length - ((tcp->head.control >> TCP_CONTROL_LENGTH_SIFT_SZ) << 2);  /*MpPbg̃f[^TCY*/

            /*MpPbg̃V[PXԍ*/
            *((volatile unsigned short *)&copy_info.pktSeq + 0) = tcp->head.SequNum.H;
            *((volatile unsigned short *)&copy_info.pktSeq + 1) = tcp->head.SequNum.L;

            /*RST̃`FbNB悪Mɑ΂RST𑗂ėꍇB*/
            if( (tcp->head.control & TCP_RST) && (copy_info.pktSeq == info->answerNo ) )
            {
              RelMemBlock( ipr );    /*L̊J*/
              TCPForceCloseStateWithoutRST( info );
              info->result = TCP_DISCONNECT;  /*Iؒf󂯂ĂB*/
              return TCP_DISCONNECT;  /*Iؒf󂯂ĂB*/
            }

            copy_info.pktBuf = (void *)&tcp->data[ ((tcp->head.control >> TCP_CONTROL_LENGTH_SIFT_SZ) << 2) - TCP_HEADER_SIZE ];  /*MpPbg̃f[^̈̐擪AhX*/

            /*[U[̗pӂobt@ɃpPbg̃f[^Rs[B*/
            if( CopyFromPacketToRcvBuffer( &copy_info ) == 0 ) RegistPacketToTable( &copy_info );
            RelMemBlock( ipr );    /*L̊J*/
            /*mFԍ̍XVBAf[^̉ZsȂ̂ŁAFIN̏ꍇ͕ʓrXVKvƂȂB*/
            state = 0;
            info->answerNo = FindLastSequenceNumberFromTable( &copy_info, &state, &info->DestWindowSz, &DestanswerNo );

            RcvByte = info->answerNo - copy_info.original_seq;  /*Mf[^̌vZ*/
            if( OriginalWindowSz <= RcvByte )
              info->WindowSz = 0;    /*0ɂ͂Ȃ*/
            else
              info->WindowSz = OriginalWindowSz - RcvByte;  /*WindowTCY̍XV*/

            /*Xe[gʏ*/
            if( state & TCP_RST )  /*悩狭ؒf󂯂B*/
            {
              /*悩ؒfė̂ŁAȏ̒ʐM͍sȂBDISCONNECTԂāAIĂ܂B*/
              TCPForceCloseStateWithoutRST( info );
              info->result = TCP_DISCONNECT;  /*Iؒf󂯂ĂB*/
              return TCP_DISCONNECT;  /*Iؒf󂯂ĂB*/
            }
            else
            {
              if( state & TCP_FIN )  /*葤MI̊mF*/
              {
                /*悩N[Y󂯂Ă̂ŁA܂łɃf[^̎ML鎞́ÃTCYԂB*/
                info->answerNo++;  /*FIN̏ꍇ́AV[PXԍ1iށB*/
                info->STATES = TCP_STATE_CLOSE_WAIT;  /*Xe[g̍XV*/
              }

              if( prcv_mbx( info->mid, (T_MSG **)&ipr ) == E_OK ) {}
              else if( state & TCP_PSH || copy_info.pktSz == 0 )
                goto __AnswerNumberCheck;  /*ȍ~̃f[^MȂ́A[v𔲂āAmFԍ̏ɈڂB*/
              else if( info->WindowSz == 0 )
                goto __AnswerNumberCheck;  /*Mobt@tɂȂĂ܂B*/
              else {}
            }
          }
        }
        else
        {
          if( ercd == E_TMOUT )  /*T[rXR[^CAEgŔĂB*/
          {
            /*^CAEg̏Ađs */
            for( i = 0; i < TRANSMIT_SCENARIO_SIZE; i++ )
            {
              if( scenario[i].AnswerNoNum )
              {
                /*đ*/
                info->state  = TCP_ACK | TCP_PSH;
                info->OptionSz = 0;
                temp = info->sequNo;
                info->sequNo = scenario[i].sequNo;
                info->TCPSBuffer = scenario[i].ptr;
                info->SndDataSz = scenario[i].size;
                TCPSend( info );
                info->sequNo = temp;
                break;
              }
            }
          }
          else
          {
            if( ercd == E_RLWAI )
            {
              info->result = TCP_RELOCATE_WAIT;  /*T[rXR[҂Ԃ̋ŔĂB*/
              return TCP_RELOCATE_WAIT;  /*T[rXR[҂Ԃ̋ŔĂB*/
            }
            else
            {
              info->result = TCP_SYSTEM_ERROR;  /*̏ꍇAۂǕsȃG[ƔfłB*/
              return TCP_SYSTEM_ERROR;  /*̏ꍇAۂǕsȃG[ƔfłB*/
            }
          }
        }
      }

      if( tmout == (sizeof(TimeOutPeriod) / sizeof(TMO)) )
      {
        /*荇ɑ΂鏈ǉĂ݂ 2008/07/02*/
        info->sequNo = DestanswerNo;  /*V[PXԍ߂*/
        info->WindowSz = OriginalWindowSz;  /*WindowTCY߂*/

        info->result = TCP_TIME_OUT;  /*肩̊mFꍇB*/
        return TCP_TIME_OUT;  /*肩̊mFꍇB*/
      }

__AnswerNumberCheck:
      /*MmFԍA܂ŊmFł`FbN*/
      for( i = TRANSMIT_SCENARIO_SIZE - 1; i >= 0 ; i-- )
      {
        if( scenario[i].size == 0 )
          continue;  /*̃e[u͎gpĂȂ*/
        /*V[PXԍ̈v*/
        if( SequenceRagLead( scenario[i].sequNo + scenario[i].size, DestanswerNo ) >= 0 )
        {
          scenario[i].size = 0;  /*mFł̂ŁAΏۂO*/
          scenario[i].AnswerNoNum = 0;  /*蒼NA*/
        }
        else
          scenario[i].AnswerNoNum = 1;  /*蒼tO𗧂ĂB*/
      }
      /*đpPbǧ*/
      for( i = 0 ; i < TRANSMIT_SCENARIO_SIZE; i++ )
        if( scenario[i].AnswerNoNum ) break;  /*đL*/

    } while( i != TRANSMIT_SCENARIO_SIZE );  /*đLȂ烋[v𑱂*/
  }

  return RcvByte;
}

/*#define  __TCP_DEFINE__*/

/* ------------------------------------------------------------------------ */
/*                                  Copyright (C) 1998-2002 by hamayan      */
/*                                  http://sourceforge.jp/projects/hos/     */
/* ------------------------------------------------------------------------ */
