/* ------------------------------------------------------------------------ */
/*  Hyper Operating System V4 ]vO								*/
/*                                                                          */
/*                                  Copyright (C) 1998-2002 by hamayan		*/
/*                                  http://sourceforge.jp/projects/hos/     */
/* ------------------------------------------------------------------------ */

#include	<stdio.h>
#include	<string.h>

#include	"itron.h"
#include	"kernel.h"
#include	"kernel_id.h"
#include	"system.h"
#include	"comm.h"
#include	"icmp.h"
#include	"ip.h"
#include	"nava_cfg.h"
#include	"udp.h"

/********************************************************************/
/*	[X|[g`												*/
/********************************************************************/
typedef struct
{
	short			valid;		/*L/*/
	unsigned short	port;		/*Y|[gԍ*/
	ID				mid;		/*^[{bNXIDԍ*/
	ID				callback_id; /*R[obNpIDԍ*/
	void			(* callBack)( ID callback_id );	/*R[obN֐*/
} LEASE_PORT_TABLE;
#define	MAX_UDP_PORT_NUM	8

static LEASE_PORT_TABLE	udp_lease_port_table[ MAX_UDP_PORT_NUM ];

/********************************************************/
/*	֐yѕϐ`									*/
/********************************************************/
extern	char	Type3Code[];
/*IP֘A֐*/
unsigned short	MakeCheckSum16( const unsigned short *a,unsigned short sz );
int				IPMake( IP_RECORD *ipr, const unsigned char *dip, const unsigned char *sip, unsigned char protocolNumber );

static	int		UDPPortCallBackFunction( unsigned short port, IP_RECORD *ipr );
static	ID		GetMIDfromLeasePortTable( unsigned short port );
static	void	RcvType3Error( IP_RECORD *ipr );
static	unsigned short GetPortNumber( void );
static	void	PurgeMbx( ID mid );

/********************************************************************/
/*	UDP̏														*/
/********************************************************************/
void UDPInit( void )
{
	LEASE_PORT_TABLE	*lpt = udp_lease_port_table;

	while( lpt < &udp_lease_port_table[ MAX_UDP_PORT_NUM ] )
	{
		lpt->valid = FALSE;
		lpt++;
	}
}

/********************************************************************/
/*	|[gԍgp̓o^											*/
/*	󂫂-1ԂāAI0ԂB					*/
/********************************************************************/
int	LeaseUDPPort( UdpAddressAndPortInformation *info )
{
	LEASE_PORT_TABLE	*lpt,*limit;

	/*ɓ|[gԍgpłȂ*/
	lpt = udp_lease_port_table;
	limit = &udp_lease_port_table[ MAX_UDP_PORT_NUM ];

	dis_dsp();
	while( lpt < limit )
	{
		if( lpt->port == info->sport )
		{
			if( lpt->valid == FALSE )	/*gpf*/
			{
				lpt->valid = TRUE;		/*gpɕύX*/
				lpt->mid = info->mid;	/*^[{bNXIDԍ*/
				lpt->callback_id = info->callback_id;	/*R[obNID̓o^*/
				lpt->callBack = info->callback;	/*R[obN֐̓o^*/
				ena_dsp();
				return 0;
			}
			ena_dsp();
			return EOF;					/*gp*/
		}
		lpt++;
	}

	/*󂫗̈*/
	lpt = udp_lease_port_table;
	limit = &udp_lease_port_table[ MAX_UDP_PORT_NUM ];
	while( lpt < limit )
	{
		if( lpt->valid == FALSE )		/*gpf*/
		{
			lpt->valid = TRUE;			/*gpɕύX*/
			lpt->port = info->sport;	/*|[gԍ̓o^*/
			lpt->mid = info->mid;		/*^[{bNXIDԍ*/
			lpt->callback_id = info->callback_id;	/*R[obNID̓o^*/
			lpt->callBack = info->callback;	/*R[obN֐̓o^*/
			ena_dsp();
			return 0;
		}
		lpt++;
	}
	ena_dsp();

	return EOF;
}

/********************************************************************/
/*	|[gԍ̕ԋp												*/
/*	̂Y|[g-1ԂāAI0ԂB		*/
/********************************************************************/
int	RelUDPPort( unsigned short port )
{
	LEASE_PORT_TABLE	*lpt,*limit;

	lpt = udp_lease_port_table;
	limit = &udp_lease_port_table[ MAX_UDP_PORT_NUM ];

	while( lpt < limit )
	{
		if( lpt->port == port && lpt->valid == TRUE )
		{
			lpt->valid = FALSE;		/*gpɂ*/
			return 0;
		}
		lpt++;
	}
	DebugPrint( "RelUDPPort Error\r\n" );
	return EOF;
}

/********************************************************************/
/*	|[gԍe[u烁[{bNXID擾					*/
/********************************************************************/
static ID GetMIDfromLeasePortTable( unsigned short port )
{
	LEASE_PORT_TABLE	*lpt,*limit;

	lpt = udp_lease_port_table;
	limit = &udp_lease_port_table[ MAX_UDP_PORT_NUM ];

	while( lpt < limit )
	{
		if( lpt->port == port && lpt->valid == TRUE )
			return lpt->mid;
		lpt++;
	}
	DebugPrint( "GetMIDfromLeasePortTable Error\r\n" );
	return EOF;
}

/********************************************************************/
/*	|[gԍ̃R[obN֐R[								*/
/*	̂Y|[g-1ԂāAI0ԂB		*/
/*	[{bNXID̂ݓo^Ă鎞-2ԂB				*/
/********************************************************************/
static int UDPPortCallBackFunction( unsigned short port, IP_RECORD *ipr )
{
	LEASE_PORT_TABLE	*lpt,*limit;

	lpt = udp_lease_port_table;
	limit = &udp_lease_port_table[ MAX_UDP_PORT_NUM ];

	while( lpt < limit )
	{
		if( lpt->port == port && lpt->valid == TRUE )
		{
			if( (void *)lpt->callBack != (void *)NADR )
			{
				lpt->callBack( lpt->callback_id );	/*R[obN֐̌Ăяo*/
				return 0;
			}
		}
		lpt++;
	}
	return (-1);
}

/********************************************************************/
/*	UDP̐														*/
/*	ip͑IPAhXAdata͑Mf[^Asz͂̃TCY		*/
/*	dport͑|[gԍAsport͎|[gԍ					*/
/*	߂l͐ɑMȂ-1AȂ0						*/
/********************************************************************/
int UDPSend( UdpAddressAndPortInformation *info )
{
	int				ret;
	IP_RECORD		*ipr;
	IP				*ip;
	UDP				*udp;
	TCP_UDP_HEADER_CHECK_SUM	*c_sum;

	/*ubN烁擾*/
	if( info->DataSz < UDP_MIN_DATA_SIZE )	/*f[^̃TCY18byteȂ18byteɕ⑫*/
		ipr = (IP_RECORD *)GetMemBlock( IP_RECORD_HEADER_SIZE + ETHERNETFRAME_HEADER_SIZE + IP_HEADER_SIZE + UDP_HEADER_SIZE + UDP_MIN_DATA_SIZE );
	else if( info->DataSz & 1 )	/*Mf[^TCYȂɂ*/
		ipr = (IP_RECORD *)GetMemBlock( IP_RECORD_HEADER_SIZE + ETHERNETFRAME_HEADER_SIZE + IP_HEADER_SIZE + UDP_HEADER_SIZE + info->DataSz + 1 );
	else
		ipr = (IP_RECORD *)GetMemBlock( IP_RECORD_HEADER_SIZE + ETHERNETFRAME_HEADER_SIZE + IP_HEADER_SIZE + UDP_HEADER_SIZE + info->DataSz );

	ip		= IPTopAddress( ipr );			/*IPwb_[ʒu̎擾*/
	udp		= UDPTopAddress( ip );			/*UDPwb_[ʒu̎擾*/
	ipr->vrf.IP_VAR_FLD = udp;				/*ϒtB[h̃AhXۑ*/

	ipr->handle = L0;						/*̏LOCAL*/
	/*UDP HEADER̍\*/
	udp->head.sport = info->sport;			/*|[gԍ*/
	udp->head.dport = info->dport;			/*|[gԍ*/
	memcpy( udp->data, info->data, info->DataSz );	/*f[^̃Rs[*/
	udp->head.length = UDP_HEADER_SIZE + info->DataSz;	/*UDPf[^*/
	ipr->sz = UDP_HEADER_SIZE + info->DataSz;
	if( info->DataSz & 1 )					/*f[^̎̏*/
	{
		ret = ipr->sz + 1;					/*f[^ɂO܂*/
		udp->data[ info->DataSz ] = 0;
	}
	else ret = ipr->sz;

	/*UDP`FbNTs*/
	c_sum = (TCP_UDP_HEADER_CHECK_SUM *)((char *)&udp->head.sport - sizeof(TCP_UDP_HEADER_CHECK_SUM) );
	IP_COPY( c_sum->sip, info->sip );
	IP_COPY( c_sum->dip, info->dip );
	c_sum->ZeroField = 0;					/*0*/
	c_sum->ProNumber = TYPEUDP;				/*vgRԍ*/
	c_sum->Length = ipr->sz;				/*UDPf[^*/
	udp->head.checksum = 0;					/*܂`FbNT0NA*/
	udp->head.checksum =
		MakeCheckSum16( (unsigned short *)c_sum, sizeof(TCP_UDP_HEADER_CHECK_SUM) + ret );
	if( udp->head.checksum == 0 ) udp->head.checksum = -1;
	/*03/01/27 IPAhXsȎAv[̊J*/
	/*(03/01/28 C) Ńv[̕ԋps킸AIPwōsBIPwɂ́Ađ*/
	return IPMake( ipr, info->dip, info->sip, TYPEUDP );
}

/********************************************************************/
/*	UDP̎M														*/
/*	ipr͎MpPbg											*/
/*	ʂ̃`FbNA|[gԍɃR[obN֐	*/
/*	NB													*/
/********************************************************************/
extern void ICMPType3Answer( const unsigned char *dip, const unsigned char *sip, const char *data, short sz );

void UDPRcv( IP_RECORD *ipr )
{
	int				ServiceType,length;
	ID				mid;
	TCP_UDP_HEADER_CHECK_SUM	*c_sum;
	IP_RECORD		*ipr_udp;
	IP				*ip;
	UDP				*udp;

	/*IPAUDP̈̐擪AhX擾*/
	ip	= IPTopAddress( ipr );			/*IPwb_[ʒu̎擾*/
	udp = ipr->vrf.IP_VAR_FLD;

	/*ICMP̓Bs\G[Ɉ˂Nǂ𔻒f*/
	if( ip->head.protocolNumber == TYPEICMP )
	{
		RcvType3Error( ipr );
		return;
	}

	/*f[^̈m*/
	ipr_udp = (IP_RECORD *)GetMemBlock( ipr->sz );
	ipr_udp->handle = ipr->handle;	/**/
	ipr_udp->sz = sizeof(TCP_UDP_HEADER_CHECK_SUM) + udp->head.length;	/*f[^TCY*/

	/*`FbNTؗptB[h̏*/
	c_sum = (TCP_UDP_HEADER_CHECK_SUM *)ipr_udp->data;	/*`FbNTpɒ`*/
	IP_COPY( c_sum->sip, ip->head.sIP );
	IP_COPY( c_sum->dip, ip->head.dIP );
	c_sum->ZeroField = 0;							/*0*/
	c_sum->ProNumber = ip->head.protocolNumber;		/*vgRԍ*/
	c_sum->Length = udp->head.length;				/*UDPf[^*/
	/*ipr̃f[^Rs[*/
	memcpy( &ipr_udp->data[ sizeof(TCP_UDP_HEADER_CHECK_SUM) ], udp, c_sum->Length );
	if( c_sum->Length & 1 )		/*̎̏*/
	{
		ipr_udp->data[ c_sum->Length + sizeof(TCP_UDP_HEADER_CHECK_SUM) ] = 0;	/*f[^ɂO܂*/
		length = c_sum->Length + 1;
	}
	else
		length = c_sum->Length;

	/*UDP`FbNT̊mF*/
	if( udp->head.checksum != 0 )					/*0̎̓`FbNTmFȂ*/
	{
		if( udp->head.checksum == 0xFFFF )			/*0xffff̎0ɂ*/
			udp->head.checksum = 0;

		/*`FbNŤvZ*/
		if( MakeCheckSum16( (unsigned short *)c_sum, sizeof(TCP_UDP_HEADER_CHECK_SUM) + length ) )
		{
			/*(03/01/29 Rgǉ) `FbNTG[̗L*/
			RelMemBlock( ipr );			/*̊J*/
			RelMemBlock( ipr_udp );
			return;
		}
	}

	/*R[obN[eB̌Ăяo*/
	ServiceType = UDPPortCallBackFunction( udp->head.dport, ipr_udp );
	if( ServiceType == (-1) )	/*Y|[gICMPŃ|[gBs\G[Ԃ*/
	{
		if( IP_COMPAER( ip->head.dIP, BroadCast ) != 0 && memcmp( ip->head.dIP, SubNetBroadCast, sizeof(ip->head.dIP) ) != 0 )
		{
			ICMPType3Answer( ip->head.sIP, ip->head.dIP, (char *)&ip->head, (ip->head.top.length * 4) + 8 );
		}

		RelMemBlock( ipr );			/*̊J*/
		RelMemBlock( ipr_udp );
	}
	else	/*[{bNXgăbZ[W𑗂*/
	{
		if( (mid = GetMIDfromLeasePortTable( udp->head.dport )) > 0 )
		{
			snd_mbx( mid, (T_MSG *)ipr_udp );
			/*ipr_udp̊J̓R[̐ӔC*/
		}
		else	/*[{bNXID擾łȂ*/
		{
			RelMemBlock( ipr_udp );
			DebugPrint( "UDP Illegal State 3\r\n" );
		}
		/*(03/01/28 ǉ) ML̊JBōsȂƁALHԂ*/
		RelMemBlock( ipr );
	}
}

/********************************************************************/
/*	ICMP TYPE3̃G[M̏							*/
/********************************************************************/
static void RcvType3Error( IP_RECORD *ipr )
{
	int		ServiceType;
	ID		mid;
	ICMP	*icmp;

	/*ICMPUDP̈悩|[gԍ擾*/
	icmp = ipr->vrf.IP_VAR_FLD;			/*ϔɂICMPĂ*/
	ipr->handle = Type3Code[icmp->head.code];	/*ϐhandleɕ̒lăG[`*/
	/*|[g݂oe[uY|[ggpĂAvP[VɘA*/
	ServiceType = UDPPortCallBackFunction( icmp->data.type3.data.udp_head.sport, ipr );
	if( ServiceType == (-1) )	/*(03/01/29 ǉ) 悩AG[ԂėAɂYT[rX*/
	{
		RelMemBlock( ipr );
	}
	else	/*[{bNXgăbZ[W𑗂*/
	{
		if( (mid = GetMIDfromLeasePortTable( icmp->data.type3.data.udp_head.sport )) > 0 )
		{
			snd_mbx( mid, (T_MSG *)ipr );
			/*(03/01/29 ǉ) L̊J́AbZ[W̎󂯐ōsB*/
		}
	}
}

/********************************************************************/
/*	\PbgɎlȊ֐											*/
/*	ʐM[_̐ڑ𐶐B									*/
/*	ُI̓VXeG[ԂB								*/
/********************************************************************/
int UDPsocket( UdpAddressAndPortInformation *info )
{
	/*Mp[{bNX̃^*/
	if( (info->mid = MBXLease()) <= 0 ) return UDP_SYSTEM_ERROR;
	/*IPAhXA|[gԍNA*/
	*((unsigned long *)info->sip) = 0;	/*lƂĂOĒu*/
	info->sport	= 0;					/*lƂĂOĒu*/
	/*T[o[^NCAg*/
	info->server = FALSE;
	/*^CAEgԂ͉iv҂*/
	info->tmout = TMO_FEVR;
	/*R[obN֐̃AhXNAĒu*/
	info->callback = (void *)NADR;

	return 0;
}

/********************************************************************/
/*	\PbgN[YɎlȊ֐									*/
/*	UDPZbVI												*/
/********************************************************************/
int UDPclose( UdpAddressAndPortInformation *info )
{
	/*\[X̊J*/
	PurgeMbx( info->mid );
	/*[{bNX̕ԋp*/
	MBXRelease( info->mid );
	/*|[g̕ԋp*/
	if( info->server == TRUE ) RelUDPPort( info->sport );

	return 0;
}

/********************************************************************/
/*	bindɎlȊ֐												*/
/*	ʐM[_̃AhX𐶐								*/
/*	ڑsportO̎́AKȃ|[gԍ蓖āB			*/
/*	ڑsipO̎́A{̓[eBOe[u		*/
/*	蓖āB														*/
/*	|[g̊蓖Ďs̓VXeG[ԂB					*/
/*	ȊO0ԂB												*/
/********************************************************************/
int UDPbind( UdpAddressAndPortInformation *info )
{
	/*IPAhX̐ݒAȌꍇ̓VXeŌ肷*/
#if 0
	if( *((unsigned long *)info->sip) == 0 )
		*((unsigned long *)info->sip) = *((unsigned long *)ThisIs);
#else
	if( info->sip[3] == 0 )
		IP_COPY(info->sip,ThisIs);
#endif
	/*ȃ|[gԍ̐ݒAȌꍇ̓VXeŌ肷*/
	if( info->sport == 0 ) info->sport = GetPortNumber();
	/*|[gԍ̊蓖ĂsB*/
	if( LeaseUDPPort( info ) == -1 ) return UDP_SYSTEM_ERROR;
	/*T[o[Aƌ bindꂽ*/
	info->server = TRUE;

	return 0;
}

/********************************************************************/
/*	UDPM															*/
/*	IPAhXA|[gԍݒ肳ĂȂAIPAhX	*/
/*	ɊւĖ{̓[eBOe[u擾A|[gԍ		*/
/*	󂫃|[gԍTĊtsB								*/
/*	Y|[gɎgpς݂Ȃ-1ԂďIB				*/
/********************************************************************/
int UDPsendto( UdpAddressAndPortInformation *info )
{
	int	ret = 0;

	/*|[g̎؂oAbindĂȂ sport͂ONAĂ*/
	if( info->server == FALSE )
	{
		IP_COPY(info->sip,ThisIs);
		info->sport = GetPortNumber();
		LeaseUDPPort( info );
	}
	/*M*/
	if( UDPSend( info ) == IPLAYERTRANSMIT_UNKNOWN_IP )	/*pPbg̑MƁÃUgR[h̉*/
		 ret = UDP_UNKNOWN_IP_ADDRESS;

	/*|[g̕ԋp*/
	if( info->server == FALSE ) RelUDPPort( info->sport );

	return ret;
}

/********************************************************************/
/*	UDPM															*/
/*	ftHgł́AM҂Ƀ^CAEĝŒӁI			*/
/*	߂l̏ꍇAMTCYȀꍇG[			*/
/********************************************************************/
long UDPrecvfrom( UdpAddressAndPortInformation *info )
{
	long					rcvsz;
	IP_RECORD				*ipr;
	UDP_DATA_FIELD_ACCESS	*udfa;
	ER						ercd;

	/*|[g̎؂oAbindĂȂ sport͂ONAĂ*/
	if( info->server == FALSE )
	{
		IP_COPY(info->sip,ThisIs);
		info->sport = GetPortNumber();
		LeaseUDPPort( info );
	}

	/*悩̉҂*/
	ercd = trcv_mbx( info->mid, (T_MSG **)&ipr, info->tmout );

	if( ercd != E_OK )
	{
		if( info->server == FALSE ) RelUDPPort( info->sport );
		if( ercd == E_TMOUT ) return UDP_TIMEOUT;
		else if( ercd == E_RLWAI ) return UDP_RELOCATE_WAIT;
		else return UDP_SYSTEM_ERROR;
	}

	/*擞Bs\G[̃`FbN*/
	if( ipr->handle >= ICMP_TYPE3_CODE15_ERROR && ipr->handle <= ICMP_TYPE3_CODE0_ERROR )
	{
		RelMemBlock( ipr );		/*(03/01/29 ǉ) ML̊JBōsȂƁALHԂ*/
		if( info->server == FALSE ) RelUDPPort( info->sport );
		return UDP_UNREACHABLE_PORT;
	}
	else
	{
		/*f[^̈̎擾*/
		udfa = (UDP_DATA_FIELD_ACCESS *)ipr->data;
		/*IPAhX擾*/
		*((unsigned long*)info->dip) = *((unsigned long*)udfa->c_sum.sip);
		/*|[gԍ擾*/
		info->dport = udfa->udp.head.sport;
		/*Mf[^TCY߂*/
		rcvsz = udfa->udp.head.length - UDP_HEADER_SIZE;
		/*obt@̈MTCY傫Aobt@TCYɍ킹*/
		rcvsz = ( rcvsz < info->DataSz ) ? rcvsz : info->DataSz;
		memcpy( info->data, udfa->udp.data, rcvsz );
		/*̊J*/
		RelMemBlock( ipr );
	}

	/*|[g̕ԋp*/
	if( info->server == FALSE ) RelUDPPort( info->sport );

	return rcvsz;
}

/********************************************************************/
/*	|[gԍ𓾂B												*/
/*	߂l̓|[gԍ												*/
/********************************************************************/
static unsigned short GetPortNumber( void )
{
	static unsigned short port = 1024;
	unsigned short	PortNumber;

	dis_dsp();
	PortNumber = port++;
	port = (port > 5000) ? 1024 : port;
	ena_dsp();

	return PortNumber;
}

/********************************************************************/
/*	[{bNX̕spȃ[NA							*/
/********************************************************************/
static void PurgeMbx( ID mid )
{
	T_MSG*	msg;

	while( prcv_mbx(mid, (T_MSG **)&msg) == E_OK ) RelMemBlock( (VP)msg );
}
