/* ------------------------------------------------------------------------ */
/*  Hyper Operating System V4 AKI-H8-LAN]vO						*/
/*  H8̎Ӌ@\̏                                                       */
/*                                  Copyright (C) 1998-2002 by hamayan		*/
/*                                  http://sourceforge.jp/projects/hos/     */
/* ------------------------------------------------------------------------ */

#include	"h83068f.h"

static unsigned char H8DDR[ 11 ];			/*DDRWX^̏ԕۑp*/
void					BusInitialize( void );
volatile unsigned char	H8DRread( int port );
void					H8DRSet( int port, unsigned char pd );
unsigned char			H8DDRread( int port );
void					H8DDRSet( int port, unsigned char pd );
static void				InitH8DDRSet( int port, unsigned char pd );

/*************************************************************************/
/*	oX֐													 */
/*************************************************************************/
void BusInitialize( void )
{
	/********************************************************************/
	/*			|[g1̏											*/
	/*	AhXoA0`A7pɐݒ										*/
	/********************************************************************/
	InitH8DDRSet( 1, 0xff );
	/********************************************************************/
	/*			|[g2̏											*/
	/*	AhXoA8`A10pɐݒ										*/
	/********************************************************************/
	InitH8DDRSet( 2, 0x0f );
	/********************************************************************/
	/*			|[g3̏											*/
	/*	[hTŎgpȂ玩IɃf[^oXɂȂĂB			*/
	/*	bit0`7:	o												*/
	/********************************************************************/
	InitH8DDRSet( 3, 0xff );
	/********************************************************************/
	/*			|[g4̏											*/
	/*	gp															*/
	/*	bit0`7:	o												*/
	/********************************************************************/
	InitH8DDRSet( 4, 0xff );
	/********************************************************************/
	/*			|[g5̏											*/
	/*	gp															*/
	/*	bit0`2:SWɐڑ												*/
	/*	bit3:ڑ													*/
	/*	bit4`7:݂												*/
	/********************************************************************/
	InitH8DDRSet( 5, 0x08 );
	/********************************************************************/
	/*			|[g6̏											*/
	/*	bit0:gp														*/
	/*	bit1:74138C[qɐڑ											*/
	/*	bit2:74138G1[qɐڑ										*/
	/*	bit3:gp														*/
	/*	bit4:gp														*/
	/*	bit5:gp														*/
	/*	bit6:gp														*/
	/*	bit7:VXeNbNo										*/
	/********************************************************************/
	InitH8DDRSet( 6, 0xff );
	/********************************************************************/
	/*			|[g7̏											*/
	/********************************************************************/

	/********************************************************************/
	/*			|[g8̏											*/
	/*	bit0:74138A[qɐڑ											*/
	/*	bit1:74138B[qɐڑ											*/
	/*	bit4:gp														*/
	/*	bit2:DRAMgȂRASo͂Ŏgp								*/
	/*	bit3:RTLgȂCS1o͂Ŏgp									*/
	/*	bit5`7:݂												*/
	/********************************************************************/
	InitH8DDRSet( 8, 0xff );
	/********************************************************************/
	/*			|[g9̏											*/
	/*	SCI0SCI1gpĂB										*/
	/*	bit0:SCI0̑M													*/
	/*	bit1:SCI1̑M													*/
	/*	bit2:SCI0̎M													*/
	/*	bit3:SCI1̎M													*/
	/*	bit4:gp														*/
	/*	bit5:RTL8019AS荞݂Ŏgp								*/
	/********************************************************************/
	InitH8DDRSet( 9, 0xd3 );
	/********************************************************************/
	/*			|[gȀ											*/
	/*	gp															*/
	/*	bit0`7:ڑ												*/
	/********************************************************************/
	InitH8DDRSet( 0xa, 0xff );
	/********************************************************************/
	/*			|[gB̏											*/
	/*	bit0:93C46DO()											*/
	/*	bit1:93C46DI(o)											*/
	/*	bit2:93C46CS(o)											*/
	/*	bit3:93C46SK(o)											*/
	/*	bit5:LCDڑĂ鎞RS(o)ATreva̎CLK(o)		*/
	/*	bit6:LCDڑĂ鎞R/W(o)ATreva͖̎(o)	*/
	/*	bit7:LCDڑĂ鎞E(o)ATreva̎DOUT()		*/
	/*	bit4:DRAMgȂCASŎgp									*/
	/********************************************************************/
	InitH8DDRSet( 0xb, 0x7e );
}

/*************************************************************************/
/*	|[gԎ擾֐													 */
/*************************************************************************/
volatile unsigned char H8DRread( int port )
{
	switch ( port )
	{
		case 1: return P1DR.BYTE;
		case 2: return P2DR.BYTE;
		case 3: return P3DR.BYTE;
		case 4: return P4DR.BYTE;
		case 5: return P5DR.BYTE;
		case 6: return P6DR.BYTE;
		case 7: return P7DR.BYTE;
		case 8: return P8DR.BYTE;
		case 9: return P9DR.BYTE;
		case 10: return PADR.BYTE;
		case 11: return PBDR.BYTE;
		default : break;
	}
	return 0;
}

/*************************************************************************/
/*	|[gԐݒ֐													 */
/*************************************************************************/
void H8DRSet( int port, unsigned char pd )
{
	switch ( port )
	{
		case 1: break;	/*P1́AAhXpȂ̂ŁAgp֎~*/
		case 2: break;	/*P2́AAhXpȂ̂ŁA͂̂ݗL*/
		case 3: break;	/*f[^oXɐڑĂ̂ŁAgp֎~*/
		case 4: P4DR.BYTE = pd; break;
		case 5: break;	/*P5́AAhXpȂ̂ŁA͂̂ݗL*/
		case 6: P6DR.BYTE = pd; break;
		case 7: break;	/*P7́A͐p|[g*/
		case 8: P8DR.BYTE = pd; break;
		case 9: P9DR.BYTE = pd; break;
		case 10: PADR.BYTE = pd; break;
		case 11: PBDR.BYTE = pd; break;
		default : break;
	}
}

/*************************************************************************/
/*	|[gԎ擾֐												 */
/*************************************************************************/
unsigned char H8DDRread( int port )
{
	return H8DDR[ port - 1 ];
}

/*************************************************************************/
/*	|[gݒ֐													 */
/*************************************************************************/
static void InitH8DDRSet( int port, unsigned char pd )
{
	switch ( port )
	{
		case 1:	P1DDR = pd; break;
		case 2:	P2DDR = pd; break;
		case 3:	P3DDR = pd; break;
		case 4:	P4DDR = pd; break;
		case 5:	P5DDR = pd; break;
		case 6:	P6DDR = pd; break;
		case 7:	break;
		case 8:	P8DDR = pd; break;
		case 9:	P9DDR = pd; break;
		case 10: PADDR = pd; break;
		case 11: PBDDR = pd; break;
		default : return;
	}
	H8DDR[ port - 1 ] = pd;
}

/*************************************************************************/
/*	|[gݒ֐													 */
/*************************************************************************/
void H8DDRSet( int port, unsigned char pd )
{
#define		P6DDRMASK	0x06
#define		P8DDRMASK	0x01
#define		PADDRMASK	0x7f
	switch ( port )
	{
		case 1: break;	/*[U[̐ݒ֎~*/
		case 2:	break;	/*[U[̐ݒ֎~*/
		case 3: break;	/*[U[̐ݒ֎~*/
		case 4:	P4DDR = pd; H8DDR[ 3 ] = pd; break;
		case 5: break;	/*[U[̐ݒ֎~*/
		case 6:	P6DDR = pd & P6DDRMASK; H8DDR[ 5 ] = pd & P6DDRMASK; break;
		case 7:	break;	/*[U[̐ݒ֎~*/
		case 8:	P8DDR = pd & P8DDRMASK; H8DDR[ 7 ] = pd & P8DDRMASK; break;
		case 9: P9DDR = pd; H8DDR[ 7 ] = pd; break;
		case 10: PADDR = pd & PADDRMASK; H8DDR[ 9 ] = pd & PADDRMASK; break;
		case 11: PBDDR = pd; break;
		default : break;
	}
}

/* ------------------------------------------------------------------------ */
/*  Copyright (C) 1998-2002 by Project HOS                                  */
/* ------------------------------------------------------------------------ */
