/* ------------------------------------------------------------------------ */
/*  Hyper Operating System V4 AKI-H8-LAN]vO						*/
/*                                                                          */
/*                                  Copyright (C) 1998-2002 by hamayan		*/
/*                                  http://sourceforge.jp/projects/hos/     */
/* ------------------------------------------------------------------------ */
#ifdef		__300HA__
#include	<no_float.h>
#endif		/*__300HA__*/

#include	<stdio.h>
#include	<string.h>

#include	"itron.h"
#include	"kernel.h"
#include	"kernel_id.h"
#include	"comm.h"
#include	"itu.h"
#include	"system.h"
#include	"ip.h"
#include	"nava_cfg.h"
#include	"dhcp.h"
#include	"ntp.h"
#include	"netclock3.h"

#include	"h83068f.h"

/* f[^oX֐*/
void	BusInitialize( void );
unsigned char H8DDRread( int port );
void H8DDRSet( int port, unsigned char pd );
/* TCP/IP/UDP֐*/
void	arpInit( void );
int		RTL8019ASInit( void );
void	UDPInit( void );
void	TCPInit( void );
/* SNTP֐*/
void	 SNTPSyncTimerCounterInit( void );
unsigned long SNTPClient( unsigned char dip[], int handle );
/* LCD֐*/
//void	LCDInit( void );
//void 	LCD_Puts( char *str );
/* EEPROM֐*/
//void	E2PInit( void );
//int		TestValidStateFromEEPROM( void );
//int		DeploymentAnyInformationFromEEPROM( void );

/*TREVA֐*/
void treva( void );

/*SYSLOGs*/
//void SystemLog( int argc, char *argv[], int handle );
//void SendMail( int argc, char *argv[], int handle );

extern const T_KERNEL_TCB_ROM kernel_tcb_rom[];

/*************************************************************************/
/*	C֐															 */
/*************************************************************************/
int main()
{
#if 0
	/* ꕔ^XÑX^bNNAB{IɕKv͖AX^bN̐Lj^ */
	memset( (char *)kernel_tcb_rom[TID_ETH0_EMERS - 1].stk, 0, kernel_tcb_rom[TID_ETH0_EMERS - 1].stksz );
	memset( (char *)kernel_tcb_rom[TID_ETH0 - 1].stk,       0, kernel_tcb_rom[TID_ETH0 - 1].stksz );
	memset( (char *)kernel_tcb_rom[TID_ETH0_SND - 1].stk,   0, kernel_tcb_rom[TID_ETH0_SND - 1].stksz );
	memset( (char *)kernel_tcb_rom[TID_LINK - 1].stk,       0, kernel_tcb_rom[TID_LINK - 1].stksz );
#endif

	/* HOS-V4 ̊Jn */
	sta_hos();
	
	return 0;
}

/*************************************************************************/
/*	֐														 */
/*************************************************************************/
void SampleInitialize(VP_INT exinf)
{
	/* oXݒ */
	BusInitialize();

	/* ^XNN */
	act_tsk(TID_SCI_SND1);
	act_tsk(TID_IDLE);
}

/*************************************************************************/
/*	IDLE^XNAVXeT[rX̋Ns							 */
/*************************************************************************/
void Idle( VP_INT exinf )
{
	unsigned long	loop = 0;
	unsigned char port_b;
#ifdef __DHCP_USE__
	DHCP_NETWORK_INFO	dnf;
#endif	/*__DHCP_USE__*/

	/* o͂̏ */
	SCI_Init( SCI_1, SCI_38400 );	/*SCI*/
	SCI_Puts( SCI_1, "\r\nHOS-V4 for HITACHI H8/300H\r\n Presented by Project HOS\r\n" );

	port_b = H8DDRread( 0x0b );
	H8DDRSet( 0x0b, 0xff );
//	LCDInit();	/*LCD*/
//	LCD_Puts( "HOS-V4 for H8\x1b[4;1HProject HOS" );
	H8DDRSet( 0x0b, port_b );

	/*EEPROM(93C46)̏*/
//	E2PInit();
//	DeploymentAnyInformationFromEEPROM();	/*EEPROMɗLȃlbg[N񂪑݂鎞AO[öɓWJB*/

	InitMBXControlBlock();	/*݂op[{bNX̊Ǘ̈̏*/
	InitMemControlBlock();	/*݂opv[̊Ǘ̈̏*/
	arpInit();				/*ARPe[ȕ*/
	UDPInit();				/*UDP̏*/
	TCPInit();				/*TCP̏*/
	if( RTL8019ASInit() != 0 )	/*RTL8019AS̏*/
	{
		SCI_Puts( SCI_1, "RTL8019AS is not available.\r\n" );
	}
	/*T[rX̋N*/
	act_tsk(TID_LINK);		/**/
	act_tsk(TID_ETH0);		/**/
	act_tsk(TID_ETH0_SND);	/**/
	act_tsk(TID_ETH0_EMERS);	/*OVER WRITE x TASK̋N*/

#ifdef CYC_ID_RTL8019
	sta_cyc( CYC_ID_RTL8019 );	/*NnhgRTL̑Ms*/
#endif	/*CYC_ID_RTL8019*/

#ifdef __DHCP_USE__
	if( TestValidStateFromEEPROM() != 0 ) RequesetDHCP( SCI_1, &dnf );	/*EEPROMɗLȃlbg[N񂪕ۑĂȂADHCPgB*/
#endif	/*__DHCP_USE__*/

#ifdef	__SNTP_USE__
	SNTPSyncTimerCounterInit();	/*SNTPvŎgpv̏ƋNB*/
	DynamicScanLEDUpdateInit((__CPU_CLOCK__/400/8 - 1));	/*Ar[hł肷鎞́A𒲐ƗǂB*/
#endif	/*__SNTP_USE__*/

	act_tsk(TID_HTTPD);		/*ȈWEBT[o[̋N*/
	act_tsk(TID_HTTPD2);	/*ȈWEBT[o[̋N*/
	act_tsk(TID_HTTPD3);	/*ȈWEBT[o[̋N*/
	act_tsk(TID_HTTPD4);	/*ȈWEBT[o[̋N*/
	act_tsk(TID_CUI_1);		/**/

	/*ł鎖΁AIĂ\Ȃ*/
	RegistProcessTable( _BACK_GROUND_, TRUE );
	while( 1 )
	{
		/*vZXKILLꂽf*/
		if( QueryRunningMode() == EOF ) break;
#ifdef	__SNTP_USE__
		if( (NTPServer[3] & ~SubNetMask[3]) && !(loop % 1200) )	/*2uɃANZXB*/
			SNTPClient( NTPServer, SCI_1 );
#endif	/*__SNTP_USE__*/

		/*SYSLOGM*/
		if( !(loop % (3600UL * 2 * 10)) )
#if 0
//			SystemLog( 1, (char **)0, SCI_1 );	/*߂1b|̂ŁAӂKvB*/
#else
//			SendMail( 1, (char **)0, SCI_1  );
#endif

#ifdef __DHCP_USE__
		if( !(loop % 100) && TestValidStateFromEEPROM() != 0 )	/*EEPROMɗLȃlbg[N񂪕ۑĂȂADHCPgB*/
		{
			/*DHCPLȎ́A[XԂxɉsB*/
			dnf.renew_time_value = ( (dnf.renew_time_value - 10) > dnf.renew_time_value ) ? 0 : dnf.renew_time_value - 10;
			if( dnf.lease_time != 0L && dnf.renew_time_value == 0 )
				UpdateDHCP( SCI_1, &dnf );
		}
#endif	/*__DHCP_USE__*/

		loop++;
		dly_tsk( 100 );
	}
	RelocateProcessTable();
	ext_tsk();						/*TASK̏I*/
}

/* ------------------------------------------------------------------------ */
/*  Copyright (C) 1998-2002 by Project HOS                                  */
/* ------------------------------------------------------------------------ */
